2010-01-29  Mark Rowe  <mrowe@apple.com>

        Fix the Mac build.

        Disable ENABLE_INDEXED_DATABASE since it is "completely non-functional".

        As the comment in FeatureDefines.xcconfig notes, the list of feature defines
        needs to be kept in sync across the various files.  The default values also
        need to be kept in sync between these files and build-webkit.

        * Configurations/FeatureDefines.xcconfig:

2010-01-29  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler.

        Timeout for client-based Geolocation shouldn't start until user gives consent
        https://bugs.webkit.org/show_bug.cgi?id=34352

        * page/Geolocation.cpp:
        (WebCore::Geolocation::startRequest): Don't start timer if we're blocked on user consent.
        (WebCore::Geolocation::setIsAllowed): Start timer after user gives consent.

2010-01-29  Jakob Petsovits  <jpetsovits@rim.com>

        Reviewed by Nikolas Zimmermann.

        [OpenVG] Implement more graphics primitives
        https://bugs.webkit.org/show_bug.cgi?id=34339

        Adds lines, arcs, ellipses, polygons and rounded
        rectangles to PainterOpenVG and GraphicsContext.

        Rounded rects support by Eli Fidler <efidler@rim.com>.

        * platform/graphics/openvg/GraphicsContextOpenVG.cpp:
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::fillRoundedRect):
        (WebCore::GraphicsContext::drawFocusRing):
        (WebCore::GraphicsContext::drawLineForText):
        (WebCore::GraphicsContext::clearRect):
        (WebCore::GraphicsContext::strokeRect):
        * platform/graphics/openvg/PainterOpenVG.cpp:
        (WebCore::PainterOpenVG::drawRect):
        (WebCore::PainterOpenVG::drawRoundedRect):
        (WebCore::PainterOpenVG::drawLine):
        (WebCore::PainterOpenVG::drawArc):
        (WebCore::PainterOpenVG::drawEllipse):
        (WebCore::PainterOpenVG::drawPolygon):
        * platform/graphics/openvg/PainterOpenVG.h:

2010-01-29  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Dimitri Glazkov.

        A first step towards the Indexed Database API
        https://bugs.webkit.org/show_bug.cgi?id=34342

        Flesh out the first part of Indexed Database API.
        Currently only compiles with v8 + chromium for now.
        Completely non-functional, but it seems best to do
        this in chunks.

        No tests because nothing works yet.

        * Configurations/FeatureDefines.xcconfig:
        * WebCore.gypi:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/v8/DOMObjectsInclude.h:
        * bindings/v8/DerivedSourcesAllInOne.cpp:
        * bindings/v8/RuntimeEnabledFeatures.cpp:
        * bindings/v8/RuntimeEnabledFeatures.h:
        (WebCore::RuntimeEnabledFeatures::setIndexedDatabaseEnabled):
        (WebCore::RuntimeEnabledFeatures::indexedDatabaseEnabled):
        * bindings/v8/V8Index.cpp:
        * bindings/v8/V8Index.h:
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::V8DOMWindow::IndexedDBEnabled):
        * bindings/v8/custom/V8IDBRequestCustom.cpp: Added.
        (WebCore::V8IDBRequest::resultAccessorGetter):
        * bindings/v8/custom/V8IndexedDatabaseRequestCustom.cpp: Added.
        (WebCore::V8IndexedDatabaseRequest::openCallback):
        * dom/EventNames.h:
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::indexedDB):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:
        * storage/IDBDatabaseError.h: Added.
        (WebCore::IDBDatabaseError::create):
        (WebCore::IDBDatabaseError::~IDBDatabaseError):
        (WebCore::IDBDatabaseError::code):
        (WebCore::IDBDatabaseError::setCode):
        (WebCore::IDBDatabaseError::message):
        (WebCore::IDBDatabaseError::setMessage):
        (WebCore::IDBDatabaseError::IDBDatabaseError):
        * storage/IDBDatabaseError.idl: Added.
        * storage/IDBDatabaseException.h: Added.
        (WebCore::IDBDatabaseException::create):
        (WebCore::IDBDatabaseException::~IDBDatabaseException):
        (WebCore::IDBDatabaseException::code):
        (WebCore::IDBDatabaseException::setCode):
        (WebCore::IDBDatabaseException::message):
        (WebCore::IDBDatabaseException::setMessage):
        (WebCore::IDBDatabaseException::IDBDatabaseException):
        * storage/IDBDatabaseException.idl: Added.
        * storage/IDBRequest.cpp: Added.
        (WebCore::IDBRequest::IDBRequest):
        (WebCore::IDBRequest::~IDBRequest):
        (WebCore::IDBRequest::abort):
        (WebCore::IDBRequest::eventTargetData):
        (WebCore::IDBRequest::ensureEventTargetData):
        * storage/IDBRequest.h: Added.
        (WebCore::IDBRequest::create):
        (WebCore::IDBRequest::readyState):
        (WebCore::IDBRequest::error):
        (WebCore::IDBRequest::result):
        (WebCore::IDBRequest::scriptExecutionContext):
        (WebCore::IDBRequest::toIDBRequest):
        (WebCore::IDBRequest::refEventTarget):
        (WebCore::IDBRequest::derefEventTarget):
        * storage/IDBRequest.idl: Added.
        * storage/IndexedDatabaseRequest.cpp: Added.
        (WebCore::IndexedDatabaseRequest::IndexedDatabaseRequest):
        (WebCore::IndexedDatabaseRequest::~IndexedDatabaseRequest):
        (WebCore::IndexedDatabaseRequest::open):
        * storage/IndexedDatabaseRequest.h: Added.
        (WebCore::IndexedDatabaseRequest::create):
        (WebCore::IndexedDatabaseRequest::request):
        * storage/IndexedDatabaseRequest.idl: Added.

2010-01-29  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Adam Roben.

        Drag and Drop: Windows uses "stop" sign as cursor when dragging
        https://bugs.webkit.org/show_bug.cgi?id=34305
        <rdar://problem/7589672>

        Add a FIXME for the code that needs to be changed to support full
        custom cursors.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleDrag):

2010-01-29  Victor Wang  <victorw@chromium.org>

        Reviewed by darin@apple.com.

        Fix the issue that both main frome and iframe are
        focused if window.onblur calls window.focus.
        https://bugs.webkit.org/show_bug.cgi?id=31692

        The problem is caused by the focused frame in FocusController
        is messed up if window.onblur calls window.focus:
        When user clicks iframe to switch focus from main frame to iframe,
        FocusController::setFocusedFrame fires onblur event, which calls
        window.focus and then calls setFocusedFrame again to switch back.
        This messes up the old focused frame and new focused frame and
        leaves the FocusController confused. As a result, controlls
        in both main frame and iframe look like get focused.

        To fix it, add a flag to FocusController and do no switch the focused
        frame when FocusController is in the middle of changing the focused frame. 

        Test: fast/events/change-frame-focus.html

        * page/FocusController.cpp:
        (WebCore::FocusController::FocusController):
        (WebCore::FocusController::setFocusedFrame):
        * page/FocusController.h:
        (WebCore::FocusController::focusedFrame):
        (WebCore::FocusController::isActive):
        (WebCore::FocusController::isFocused):

2010-01-29  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/7441982> REGRESSION (TOT): Adobe CS4: Installer alerts are displayed as
        blank windows

        We probably shouldn't be deferring loads below modal dialogs and alerts, because that's not
        what being modal means. But making such a change for general Web content would require fixes
        in other parts of code, which I'm not ready to implement right now, so making it application
        specific.

        * page/Page.cpp: (WebCore::Page::setDefersLoading): Do nothing if load deferring is not
        enabled in page settings.

        * WebCore.base.exp:
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        (WebCore::Settings::setLoadDeferringEnabled):
        * page/Settings.h: (WebCore::Settings::loadDeferringEnabled):
        Add the ability for client to disable page deferring (still enabled by default).

        * platform/mac/RuntimeApplicationChecks.h:
        * platform/mac/RuntimeApplicationChecks.mm: (WebCore::applicationIsAdobeInstaller):
        Added a bundle ID test for Adobe installer.

2010-01-29  Steve Falkenburg  <sfalken@apple.com>

        Build fix.

        * page/Geolocation.cpp:
        (WebCore::Geolocation::startUpdating):

2010-01-29  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler.

        Client-based Geolocation starts updating before getting consent from the user
        https://bugs.webkit.org/show_bug.cgi?id=34343

        * page/Geolocation.cpp:
        (WebCore::Geolocation::startRequest): Pass notifier instead of options to startUpdating.
        (WebCore::Geolocation::setIsAllowed): Add the observer or notify of error for deferred startUpdating.
        (WebCore::Geolocation::startUpdating): Pass notifier instead of options, since we may need to call it if we fail to get user consent.
        Defer adding the observer if we don't yet have user consent, since this could kick off
        server-based wifi Geolocation requests.
        * page/Geolocation.h:

2010-01-28  Jon Honeycutt  <jhoneycutt@apple.com>

        MSAA: Crash when posting a notification for a detached object

        https://bugs.webkit.org/show_bug.cgi?id=34309
        <rdar://problem/7409759>

        Reviewed by Darin Adler.

        Test: platform/win/accessibility/detached-object-notification-crash.html

        * accessibility/AccessibilityRenderObject.cpp:
        (AccessibilityRenderObject::document):
        Null check m_renderer. This is the bug fix; the other changes in the
        patch are for the test.

        * accessibility/win/AXObjectCacheWin.cpp:
        (WebCore::AXObjectCache::postPlatformNotification):
        Map AXValueChanged to EVENT_OBJECT_VALUECHANGED, so we'll post a
        notification when AXValueChanged is posted. Receiving an event of this
        type tells us that the test passed.

2010-01-29  Darin Fisher  <darin@chromium.org>

        Okayed by Oliver Hunt.

        Rollout r53949, r53951 and r54013 due to a Chromium regression that it
        causes.  Somehow this code change is triggering an endless repaint loop.

        https://bugs.webkit.org/show_bug.cgi?id=33808

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::drawTiledImage):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/transforms/TransformationMatrix.h:
        (WebCore::TransformationMatrix::isIdentityOrTranslation):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::~RenderBoxModelObject):
        (WebCore::RenderBoxModelObject::paintFillLayerExtended):
        * rendering/RenderBoxModelObject.h:

2010-01-29  Tony Chang  <tony@chromium.org>

        Reviewed by Darin Adler.

        Add gdb helper methods for Ranges like we have for VisibleSelections.
        https://bugs.webkit.org/show_bug.cgi?id=34308

        No new tests, these are only for debugging.

        * dom/Position.cpp:
        (WebCore::Position::showTreeForThis):
        * dom/Range.cpp:
        (showTree):
        * dom/Range.h:

2010-01-29  Drew Wilson  <atwilson@chromium.org>

        Reviewed by Adam Barth.

        V8 implementation of MessageEvent.initMessageEvent() does not set source correctly.
        https://bugs.webkit.org/show_bug.cgi?id=34292

        Test: fast/events/init-events.html will pass in Chrome now.

        * bindings/v8/custom/V8MessageEventCustom.cpp:
        (WebCore::V8MessageEvent::initMessageEventCallback):
        Now properly extracts the reference to the DOMWindow object from the passed-in window parameter.

2010-01-29  Ben Murdoch  <benm@google.com>

        Reviewed by Dimitri Glazkov.

        [Android] Android needs functionality in the ChromeClient to be informed when touch events are and are not needed by the webpage.
        https://bugs.webkit.org/show_bug.cgi?id=34215

        Add a function on the ChromeClient that WebCore can use to inform the platform when it needs touch events. This way the platform can optimise by not forwarding the events if they are not required.

        No new tests as the only implementation is specific to Android.

        * dom/Document.cpp:
        (WebCore::Document::detach): Check if this is the top level document and if so, stop forwarding touch events.
        (WebCore::Document::addListenerTypeIfNeeded): Inform the ChromeClient it should start forwarding touch events and guard touch event code properly.
        * history/CachedFrame.cpp:
        (WebCore::CachedFrameBase::restore): If the document uses touch events, inform the ChromeClient to start forwarding them.
        (WebCore::CachedFrame::CachedFrame): If the document uses touch events, inform the ChromeClient to stop forwarding them, as the document is being put into the page cache.
        * loader/EmptyClients.h:
        (WebCore::EmptyChromeClient::needTouchEvents): Add an empty implementation.
        * page/ChromeClient.h: Add the needTouchEvents() function.

2010-01-29  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Fix toolbar gradient to match the window's titlebar on Snow Leopard
        https://bugs.webkit.org/show_bug.cgi?id=34320

        * inspector/front-end/inspector.css:

2010-01-29  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Fix MacOS X version detection

        MacOS X version can have 2 or 3 segments.
        https://bugs.webkit.org/show_bug.cgi?id=34322

        * inspector/front-end/inspector.js:
        (WebInspector._detectPlatform):

2010-01-29  Jakob Petsovits  <jpetsovits@rim.com>

        Reviewed by Nikolas Zimmermann.

        [OpenVG] Implement a basic GraphicsContext on top of a new PainterOpenVG class
        https://bugs.webkit.org/show_bug.cgi?id=33405

        PainterOpenVG provides painter state management that works
        on a single (EGL) context, and apart from painter state
        implements a single drawing operation (for now), drawRect().

        It is a generic painter class that cooperates with
        SurfaceOpenVG to enable robust surface/context switching
        (given that EGL doesn't notify us if somebody switches
        the surface/context behind our backs), and provides
        painting operations close to OpenVG's way of working
        that GraphicsContext, Path, Image, Font and other WebKit
        platform classes can use to draw on.

        Initial code for state management and OpenVG scissoring by
        Eli Fidler <efidler@rim.com>. VGRect/VGMatrix and the bulk
        of the transformations code by Adam Treat <atreat@rim.com>.
        Preliminary drawFocusRing() implementation by Yong Li <yoli@rim.com>.

        * platform/graphics/FloatRect.h:
        * platform/graphics/GraphicsContext.cpp:
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/openvg/GraphicsContextOpenVG.cpp: Added.
        (WebCore::GraphicsContextPlatformPrivate::GraphicsContextPlatformPrivate):
        (WebCore::GraphicsContext::GraphicsContext):
        (WebCore::GraphicsContext::~GraphicsContext):
        (WebCore::GraphicsContext::platformContext):
        (WebCore::GraphicsContext::getCTM):
        (WebCore::GraphicsContext::savePlatformState):
        (WebCore::GraphicsContext::restorePlatformState):
        (WebCore::GraphicsContext::drawRect):
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::fillRoundedRect):
        (WebCore::GraphicsContext::beginPath):
        (WebCore::GraphicsContext::addPath):
        (WebCore::GraphicsContext::clip):
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::drawFocusRing):
        (WebCore::GraphicsContext::drawLineForText):
        (WebCore::GraphicsContext::drawLineForMisspellingOrBadGrammar):
        (WebCore::GraphicsContext::roundToDevicePixels):
        (WebCore::GraphicsContext::setPlatformShadow):
        (WebCore::GraphicsContext::clearPlatformShadow):
        (WebCore::GraphicsContext::beginTransparencyLayer):
        (WebCore::GraphicsContext::endTransparencyLayer):
        (WebCore::GraphicsContext::clearRect):
        (WebCore::GraphicsContext::strokeRect):
        (WebCore::GraphicsContext::setLineCap):
        (WebCore::GraphicsContext::setLineDash):
        (WebCore::GraphicsContext::setLineJoin):
        (WebCore::GraphicsContext::setMiterLimit):
        (WebCore::GraphicsContext::setAlpha):
        (WebCore::GraphicsContext::setCompositeOperation):
        (WebCore::GraphicsContext::canvasClip):
        (WebCore::GraphicsContext::clipOut):
        (WebCore::GraphicsContext::scale):
        (WebCore::GraphicsContext::rotate):
        (WebCore::GraphicsContext::translate):
        (WebCore::GraphicsContext::origin):
        (WebCore::GraphicsContext::clipOutEllipseInRect):
        (WebCore::GraphicsContext::clipToImageBuffer):
        (WebCore::GraphicsContext::addInnerRoundedRectClip):
        (WebCore::GraphicsContext::concatCTM):
        (WebCore::GraphicsContext::setURLForRect):
        (WebCore::GraphicsContext::setPlatformStrokeColor):
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        (WebCore::GraphicsContext::setPlatformFillColor):
        (WebCore::GraphicsContext::setPlatformShouldAntialias):
        (WebCore::GraphicsContext::setImageInterpolationQuality):
        (WebCore::GraphicsContext::imageInterpolationQuality):
        * platform/graphics/openvg/PainterOpenVG.cpp: Added.
        (WebCore::isNonRotatedAffineTransformation):
        (WebCore::toVGCapStyle):
        (WebCore::toVGJoinStyle):
        (WebCore::toVGFillRule):
        (WebCore::colorToVGColor):
        (WebCore::setVGSolidColor):
        (WebCore::PlatformPainterState::PlatformPainterState):
        (WebCore::PlatformPainterState::copyPaintState):
        (WebCore::PlatformPainterState::applyState):
        (WebCore::PlatformPainterState::applyBlending):
        (WebCore::PlatformPainterState::applyTransformationMatrix):
        (WebCore::PlatformPainterState::applyScissorRect):
        (WebCore::PlatformPainterState::applyStrokeStyle):
        (WebCore::PlatformPainterState::strokeDisabled):
        (WebCore::PlatformPainterState::fillDisabled):
        (WebCore::PainterOpenVG::PainterOpenVG):
        (WebCore::PainterOpenVG::~PainterOpenVG):
        (WebCore::PainterOpenVG::begin):
        (WebCore::PainterOpenVG::end):
        (WebCore::PainterOpenVG::destroyPainterStates):
        (WebCore::PainterOpenVG::applyState):
        (WebCore::PainterOpenVG::blitToSurface):
        (WebCore::PainterOpenVG::transformationMatrix):
        (WebCore::PainterOpenVG::concatTransformationMatrix):
        (WebCore::PainterOpenVG::setTransformationMatrix):
        (WebCore::PainterOpenVG::compositeOperation):
        (WebCore::PainterOpenVG::setCompositeOperation):
        (WebCore::PainterOpenVG::opacity):
        (WebCore::PainterOpenVG::setOpacity):
        (WebCore::PainterOpenVG::strokeThickness):
        (WebCore::PainterOpenVG::setStrokeThickness):
        (WebCore::PainterOpenVG::strokeStyle):
        (WebCore::PainterOpenVG::setStrokeStyle):
        (WebCore::PainterOpenVG::setLineDash):
        (WebCore::PainterOpenVG::setLineCap):
        (WebCore::PainterOpenVG::setLineJoin):
        (WebCore::PainterOpenVG::setMiterLimit):
        (WebCore::PainterOpenVG::strokeColor):
        (WebCore::PainterOpenVG::setStrokeColor):
        (WebCore::PainterOpenVG::fillColor):
        (WebCore::PainterOpenVG::setFillColor):
        (WebCore::PainterOpenVG::antialiasingEnabled):
        (WebCore::PainterOpenVG::setAntialiasingEnabled):
        (WebCore::PainterOpenVG::scale):
        (WebCore::PainterOpenVG::rotate):
        (WebCore::PainterOpenVG::translate):
        (WebCore::PainterOpenVG::intersectScissorRect):
        (WebCore::PainterOpenVG::intersectClipRect):
        (WebCore::PainterOpenVG::drawRect):
        (WebCore::PainterOpenVG::save):
        (WebCore::PainterOpenVG::restore):
        * platform/graphics/openvg/PainterOpenVG.h: Added.
        (WebCore::PainterOpenVG::):
        (WebCore::PainterOpenVG::surface):
        * platform/graphics/openvg/SurfaceOpenVG.cpp:
        (WebCore::SurfaceOpenVG::SurfaceOpenVG):
        (WebCore::SurfaceOpenVG::~SurfaceOpenVG):
        (WebCore::SurfaceOpenVG::makeCurrent):
        (WebCore::SurfaceOpenVG::makeCompatibleCurrent):
        (WebCore::SurfaceOpenVG::setActivePainter):
        (WebCore::SurfaceOpenVG::activePainter):
        * platform/graphics/openvg/SurfaceOpenVG.h:
        (WebCore::SurfaceOpenVG::):
        * platform/graphics/openvg/VGUtils.cpp: Added.
        (WebCore::VGMatrix::VGMatrix):
        (WebCore::VGMatrix::operator TransformationMatrix):
        (WebCore::TransformationMatrix::operator VGMatrix):
        (WebCore::VGRect::VGRect):
        (WebCore::VGRect::operator FloatRect):
        (WebCore::FloatRect::operator VGRect):
        * platform/graphics/openvg/VGUtils.h:
        (WebCore::VGMatrix::toVGfloat):
        (WebCore::VGRect::toVGfloat):
        * platform/graphics/transforms/TransformationMatrix.h:

2010-01-29  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Gustavo Noronha Silva.

        [Gtk] Vimeo HTML5 player doesn't work
        https://bugs.webkit.org/show_bug.cgi?id=34327

        Send Referer when requesting media over HTTP.

        Test: http/tests/media/video-referer.html

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateSourceChangedCallback):

2010-01-29  Oswald Buddenhagen <oswald.buddenhagen@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Speed up the WebCore::String -> QString conversion

        Use QString(const QChar *, int len) constructor instead of QString::fromUtf16 to
        avoid BOM checks and byteswapping.

        * bridge/qt/qt_class.cpp:
        (JSC::Bindings::QtClass::fieldNamed):
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertValueToQVariant):

2010-01-29  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Source view displays text using wrong fonts
        https://bugs.webkit.org/show_bug.cgi?id=34269

        * inspector/front-end/TextEditor.js:
        (WebInspector.TextEditor):
        (WebInspector.TextEditor.prototype._initFont):
        * inspector/front-end/inspector.js:

2010-01-29  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Gustavo Noronha Silva.

        [Gtk] Apple trailers don't play anymore
        https://bugs.webkit.org/show_bug.cgi?id=34316

        Fake QuickTime when accessing movie trailers.

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateSourceChangedCallback):

2010-01-29  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: migrate to tokenizer-based highlighting in the Elements panel.

        https://bugs.webkit.org/show_bug.cgi?id=34273

        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/front-end/CSSSourceSyntaxHighlighter.js: Removed.
        * inspector/front-end/DOMSyntaxHighlighter.js: Added.
        (WebInspector.DOMSyntaxHighlighter):
        (WebInspector.DOMSyntaxHighlighter.prototype.createSpan):
        (WebInspector.DOMSyntaxHighlighter.prototype.syntaxHighlightNode):
        * inspector/front-end/ElementsTreeOutline.js:
        * inspector/front-end/JavaScriptSourceSyntaxHighlighter.js: Removed.
        * inspector/front-end/SourceCSSTokenizer.js:
        (WebInspector.SourceCSSTokenizer):
        (WebInspector.SourceCSSTokenizer.prototype.nextToken):
        * inspector/front-end/SourceCSSTokenizer.re2js:
        * inspector/front-end/SourceHTMLTokenizer.js:
        (WebInspector.SourceHTMLTokenizer):
        (WebInspector.SourceHTMLTokenizer.prototype.nextToken):
        * inspector/front-end/SourceHTMLTokenizer.re2js:
        * inspector/front-end/SourceJavaScriptTokenizer.js:
        (WebInspector.SourceJavaScriptTokenizer):
        (WebInspector.SourceJavaScriptTokenizer.prototype.nextToken):
        * inspector/front-end/SourceJavaScriptTokenizer.re2js:
        * inspector/front-end/SourceSyntaxHighlighter.js: Removed.
        * inspector/front-end/SourceTokenizer.js: Added.
        (WebInspector.SourceTokenizer):
        (WebInspector.SourceTokenizer.prototype.set line):
        (WebInspector.SourceTokenizer.prototype.set condition):
        (WebInspector.SourceTokenizer.prototype.get condition):
        (WebInspector.SourceTokenizer.prototype.hasCondition):
        (WebInspector.SourceTokenizer.prototype.getLexCondition):
        (WebInspector.SourceTokenizer.prototype.setLexCondition):
        (WebInspector.SourceTokenizer.prototype._charAt):
        (WebInspector.SourceTokenizer.Registry):
        (WebInspector.SourceTokenizer.Registry.getInstance):
        (WebInspector.SourceTokenizer.Registry.prototype.getTokenizer):
        * inspector/front-end/TextEditorHighlighter.js:
        (WebInspector.TextEditorHighlighter):
        (WebInspector.TextEditorHighlighter.prototype.set mimeType):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.html:

2010-01-29  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: No need to render background sources
        when performing search.

        https://bugs.webkit.org/show_bug.cgi?id=34263

        * inspector/front-end/ScriptView.js:
        (WebInspector.ScriptView):
        (WebInspector.ScriptView.prototype.show):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame):
        (WebInspector.SourceFrame.prototype.set visible):
        (WebInspector.SourceFrame.prototype.set executionLine):
        (WebInspector.SourceFrame.prototype.revealLine):
        (WebInspector.SourceFrame.prototype.clearMessages):
        (WebInspector.SourceFrame.prototype.sizeToFitContentHeight):
        (WebInspector.SourceFrame.prototype.setContent):
        (WebInspector.SourceFrame.prototype._createEditorIfNeeded):
        (WebInspector.SourceFrame.prototype.setSelection):
        (WebInspector.SourceFrame.prototype.clearSelection):
        (WebInspector.SourceFrame.prototype._contextMenu.addConditionalBreakpoint):
        (WebInspector.SourceFrame.prototype._contextMenu):
        (WebInspector.SourceFrame.prototype._toggleBreakpoint):
        (WebInspector.SourceFrame.prototype.resize):
        (WebInspector.BreakpointLineNumberDecorator):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView):
        (WebInspector.SourceView.prototype.show):
        (WebInspector.SourceView.prototype.hide):
        (WebInspector.SourceView.prototype.resize):
        * inspector/front-end/TextEditor.js:
        (WebInspector.TextEditor):
        * inspector/front-end/TextEditorHighlighter.js:
        (WebInspector.TextEditorHighlighter):
        * inspector/front-end/TextEditorModel.js:
        (WebInspector.TextEditorModel):
        (WebInspector.TextEditorModel.prototype.set changeListener):
        (WebInspector.TextEditorModel.prototype.setText):

2010-01-29  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Adam Barth.

        Remove ScriptState::frame which is only used for reporting exceptions
        in some cases in a way that diverges from the regular exception reporting in
        v8 bindings.

        Cache ScriptState directly on v8::Context instead of providing
        implementations specific for isolated worlds and ScriptController.

        https://bugs.webkit.org/show_bug.cgi?id=34266

        * bindings/js/ScriptController.cpp:
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptState.cpp:
        (WebCore::mainWorldScriptState):
        * bindings/js/ScriptState.h:
        * bindings/v8/ScriptCallStack.cpp:
        (WebCore::ScriptCallStack::ScriptCallStack):
        * bindings/v8/ScriptController.cpp:
        (WebCore::ScriptController::evaluate):
        (WebCore::ScriptController::clearWindowShell):
        * bindings/v8/ScriptController.h:
        * bindings/v8/ScriptScope.cpp:
        (WebCore::ScriptScope::ScriptScope):
        (WebCore::ScriptScope::success):
        * bindings/v8/ScriptScope.h:
        * bindings/v8/ScriptState.cpp:
        (WebCore::ScriptState::ScriptState):
        (WebCore::ScriptState::forContext):
        (WebCore::ScriptState::current):
        (WebCore::ScriptState::weakReferenceCallback):
        (WebCore::mainWorldScriptState):
        (WebCore::scriptStateFromPage):
        * bindings/v8/ScriptState.h:
        (WebCore::ScriptState::ScriptState):
        (WebCore::EmptyScriptState::EmptyScriptState):
        (WebCore::EmptyScriptState::~EmptyScriptState):
        * bindings/v8/V8HiddenPropertyName.h:
        * bindings/v8/V8IsolatedContext.cpp:
        * bindings/v8/V8IsolatedContext.h:
        * bindings/v8/V8Utilities.cpp:
        (WebCore::getScriptExecutionContext):
        (WebCore::reportException):
        * bindings/v8/custom/V8NodeIteratorCustom.cpp:
        (WebCore::V8NodeIterator::nextNodeCallback):
        (WebCore::V8NodeIterator::previousNodeCallback):
        * bindings/v8/custom/V8TreeWalkerCustom.cpp:
        (WebCore::V8TreeWalker::parentNodeCallback):
        (WebCore::V8TreeWalker::firstChildCallback):
        (WebCore::V8TreeWalker::lastChildCallback):
        (WebCore::V8TreeWalker::nextNodeCallback):
        (WebCore::V8TreeWalker::previousNodeCallback):
        (WebCore::V8TreeWalker::nextSiblingCallback):
        (WebCore::V8TreeWalker::previousSiblingCallback):
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::injectedScriptForNodeId):

2010-01-29  Darin Fisher  <darin@chromium.org>

        Reviewed by Adam Barth.

        Add FrameLoaderClient::allowImages method to allow the client to
        overrule image loading policy on a per frame basis.

        https://bugs.webkit.org/show_bug.cgi?id=34225

        For completeness, this patch also adds Settings::areImagesEnabled.
        This is different from loadsImagesAutomatically as is explained in
        Settings.h.

        * loader/DocLoader.cpp:
        (WebCore::DocLoader::requestImage):
        * loader/FrameLoaderClient.h:
        (WebCore::FrameLoaderClient::allowImages):
        * loader/ImageDocument.cpp:
        (WebCore::ImageTokenizer::writeRawData):
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        (WebCore::Settings::setImagesEnabled):
        * page/Settings.h:
        (WebCore::Settings::areImagesEnabled):

2010-01-28  Nicholas Young  <nicholas.young@nokia.com>

        Reviewed by Eric Carlson.

        Prefer provided video element width/height properties to hard coded
        defaults for intrinsic size when natural video size is unavailable.
        https://bugs.webkit.org/show_bug.cgi?id=34302

        No new tests needed.

        * rendering/RenderVideo.cpp: Attempt to use width/height properties
        (WebCore::RenderVideo::RenderVideo):
        * rendering/RenderVideo.h: More appropriate constructor signature

2010-01-28  Oliver Hunt  <oliver@apple.com>

        Reviewed by Gavin Barraclough.

        MessageEvent.data should not be repeated deserialised
        https://bugs.webkit.org/show_bug.cgi?id=34311

        Cache the result of deserialising the event data

        * bindings/scripts/CodeGeneratorJS.pm:
        * dom/MessageEvent.idl:

2010-01-28  Hayato Ito  <hayato@chromium.org>

        Reviewed by Darin Adler.

        Change CSS 'page-break-inside' property from inherited one to non-inherited one because CSS specification defines so.

        Note: Currently, the 'page-break-inside' property is used only when parsing the CSS. That property is not used when rendering.

        https://bugs.webkit.org/show_bug.cgi?id=34195

        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::NonInheritedFlags::operator==):
        (WebCore::InheritedFlags::setBitDefaults):
        (WebCore::InheritedFlags::pageBreakInside):
        (WebCore::InheritedFlags::setPageBreakInside):
        * rendering/style/StyleInheritedData.cpp:
        (WebCore::StyleInheritedData::StyleInheritedData):
        (WebCore::StyleInheritedData::operator==):
        * rendering/style/StyleInheritedData.h:

2010-01-28  Michael Nordman  <michaeln@google.com>

        Reviewed by Alexey Proskuryakov.

        ApplicationCache events should be deferred until after Document onload has fired.
        https://bugs.webkit.org/show_bug.cgi?id=29690

        Test: http/tests/appcache/deferred-events.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::handledOnloadEvents):  Tells the ApplicationCacheHost to stop deferring events.
        * loader/appcache/ApplicationCacheHost.cpp:
        (WebCore::ApplicationCacheHost::ApplicationCacheHost): Initialize m_isDeferringEvents to true.
        (WebCore::ApplicationCacheHost::notifyDOMApplicationCache): Depending, defer or raise the event.
        (WebCore::ApplicationCacheHost::stopDeferringEvents): Raise any deferred events and reset the flag.
        * loader/appcache/ApplicationCacheHost.h: Declare new data members and method.

2010-01-28  Kavita Kanetkar  <kkanetkar@chromium.org>

        Reviewed by Dimitri Glazkov.

        [V8] Generate header declaration for custom constructor callbacks
        https://bugs.webkit.org/show_bug.cgi?id=33680

        Added handling of 'CanBeConstructed' and 'OmitConstructor' and a new extended attribute
        CustomConstructor'.

        Deleted implementation .cpp files for corresponding 'CanBeConstructed'
        extended attributes. These are now generated via CodeGeneratorV8.pm
        Treating 'OmitConstructor' and 'CustomConstructor' to be the same in
        CodeGeneratorJS.pm
        Cleaned idls that had 'CustomConstructor' and 'OmitConstructor' together, and
        same with CustomConstructor and CanBeConstructed.

        * Android.v8bindings.mk:
        * WebCore.gypi: Removed deps for classes being generated.
        * bindings/scripts/CodeGeneratorJS.pm: OmitConstructor and CustomConstructor have the same behavior in generator.
        * bindings/scripts/CodeGeneratorV8.pm: Generating the callbacks for constructors.
        * bindings/v8/V8DOMWrapper.cpp: Removed manual calls to SetCallHandler() for constructor callbacks.
        (WebCore::V8DOMWrapper::getTemplate):
        * bindings/v8/custom/V8CustomBinding.h: Removed manual declarations of constructor callbacks.
        * bindings/v8/custom/V8DOMParserConstructor.cpp:
        * bindings/v8/custom/V8EventSourceConstructor.cpp:
        (WebCore::V8EventSource::constructorCallback):
        * bindings/v8/custom/V8MessageChannelConstructor.cpp:
        (WebCore::V8MessageChannel::constructorCallback):
        * bindings/v8/custom/V8SharedWorkerCustom.cpp:
        (WebCore::V8SharedWorker::constructorCallback):
        * bindings/v8/custom/V8WebGLArrayBufferCustom.cpp:
        (WebCore::V8WebGLArrayBuffer::constructorCallback):
        * bindings/v8/custom/V8WebGLByteArrayCustom.cpp:
        (WebCore::V8WebGLByteArray::constructorCallback):
        * bindings/v8/custom/V8WebGLFloatArrayCustom.cpp:
        (WebCore::V8WebGLFloatArray::constructorCallback):
        * bindings/v8/custom/V8WebGLIntArrayCustom.cpp:
        (WebCore::V8WebGLIntArray::constructorCallback):
        * bindings/v8/custom/V8WebGLShortArrayCustom.cpp:
        (WebCore::V8WebGLShortArray::constructorCallback):
        * bindings/v8/custom/V8WebGLUnsignedByteArrayCustom.cpp:
        (WebCore::V8WebGLUnsignedByteArray::constructorCallback):
        * bindings/v8/custom/V8WebGLUnsignedIntArrayCustom.cpp:
        (WebCore::V8WebGLUnsignedIntArray::constructorCallback):
        * bindings/v8/custom/V8WebGLUnsignedShortArrayCustom.cpp:
        (WebCore::V8WebGLUnsignedShortArray::constructorCallback):
        * bindings/v8/custom/V8WebKitCSSMatrixConstructor.cpp:
        (WebCore::V8WebKitCSSMatrix::constructorCallback):
        * bindings/v8/custom/V8WebKitPointConstructor.cpp:
        (WebCore::V8WebKitPoint::constructorCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):
        * bindings/v8/custom/V8WorkerCustom.cpp:
        (WebCore::V8Worker::constructorCallback):
        * bindings/v8/custom/V8XMLHttpRequestConstructor.cpp:
        (WebCore::V8XMLHttpRequest::constructorCallback):
        * bindings/v8/custom/V8XMLSerializerConstructor.cpp:
        * bindings/v8/custom/V8XPathEvaluatorConstructor.cpp: Deleted the file. Implementation now being generated.
        * bindings/v8/custom/V8XSLTProcessorCustom.cpp: Deleted the file. Implementation now being generated.
        (WebCore::V8XSLTProcessor::constructorCallback): Deleted the file. Implementation now being generated.
        * css/WebKitCSSMatrix.idl: Added CustomConstructor attribute.
        * dom/MessageChannel.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLArrayBuffer.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLByteArray.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLFloatArray.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLIntArray.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLShortArray.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLUnsignedByteArray.idl: Added CustomConstructor attribute.
        * html/canvas/WebGLUnsignedIntArray.idl: Added CustomConstructor attribute.

2010-01-28  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Add stub for AXObjectCache::contentChanged when HAVE(ACCESSIBILITY) is not defined
        https://bugs.webkit.org/show_bug.cgi?id=34271

        No new tests, build fix only.

        * accessibility/AXObjectCache.cpp: Modified. Added HAVE(ACCESSIBILITY) guards around contentChanged
        * accessibility/AXObjectCache.h: Modified.
        (WebCore::AXObjectCache::contentChanged): Added stub

2010-01-28  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Use long long rather than int64 in V8Binding.h
        https://bugs.webkit.org/show_bug.cgi?id=34270

        No new tests, build fix only.

        * bindings/v8/V8Binding.h: Modified.
        (WebCore::toInt64): Returns long long

2010-01-28  Avi Drissman  <avi@chromium.org>

        Reviewed by David Levin.

        Unused variable in ThemeMac (followup to change 49103).
        https://bugs.webkit.org/show_bug.cgi?id=34274

        Covered by existing tests.

        * platform/mac/ThemeMac.mm:
        (WebCore::setupButtonCell):

2010-01-28  Enrica Casucci  <enrica@apple.com>

        Reviewed by Maciej Stachowiak.

        Huge plain text pastes are slow
        <rdar://problem/5195056>
        https://bugs.webkit.org/show_bug.cgi?id=34237

        No new tests. It is a performance improvement.

        The performance of the plain text paste is now linear.
        We treat as a special case, a fragment that has been
        created from plain text. Finding VisiblePositions and
        applying style is greatly simplified, given the nature of
        the fragment.

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::doApply):
        * editing/markup.cpp:
        (WebCore::isPlainTextMarkup):
        * editing/markup.h:

2010-01-28  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Adam Barth.

        Initialize DOM Storage's quota's current length parameter when we clone it.
        https://bugs.webkit.org/show_bug.cgi?id=34294

        * storage/StorageMap.cpp:
        (WebCore::StorageMap::copy):

2010-01-28  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed build fix after r53411 on WinCairo.

        * platform/image-decoders/gif/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::frameCount):

2010-01-28  Nayan Kumar K  <nayankk@gmail.com>

        Reviewed by Laszlo Gombos.

        Fix for compilation error in WML enabled build introduced because of the changeset 53514.

        https://bugs.webkit.org/show_bug.cgi?id=34254

        * wml/WMLDocument.cpp:
        (WebCore::WMLDocument::WMLDocument):

2010-01-28  Alex Milowski  <alex@milowski.com>

        Reviewed by Eric Seidel.

        Update to CSS to remove unnecessary line-height settings

        * css/mathml.css:

2010-01-28  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Add missing includes for HashMap/HashSet
        https://bugs.webkit.org/show_bug.cgi?id=34276

        No new tests, build fix only.

        * platform/KURL.cpp: Modified. Include HashMap.h
        * platform/network/CredentialStorage.cpp: Modified. Include HashMap.h and HashSet.h
        * platform/network/ProtectionSpaceHash.h: Modified. Include HashTraits.h

2010-01-28  Sebastian Dröge  <sebastian.droege@collabora.co.uk>

        Reviewed by Gustavo Noronha.

        Pass cookies to the GStreamer HTTP source
        https://bugs.webkit.org/show_bug.cgi?id=34003

        Test: http/tests/media/video-cookie.html

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateSourceChangedCallback):
        When using an appropiate GStreamer HTTP source element, pass
        the cookies for the media URI to it. This fixes playback of
        the YouTube HTML5 videos.

2010-01-28  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt] Unreviewed buildfix after r54022.

        * bridge/qt/qt_instance.cpp:
        (JSC::Bindings::QtRuntimeObjectImp::createStructure):
        * bridge/qt/qt_pixmapruntime.cpp:
        (JSC::Bindings::QtPixmapRuntimeObjectImp::createStructure):
        * bridge/qt/qt_runtime.h:
        (JSC::Bindings::QtRuntimeMethod::createStructure):

2010-01-28  Adam Roben  <aroben@apple.com>

        Fix an assertion beneath SerializedScriptValue::deserialize on 32-bit
        builds (e.g., on Windows)

        Passing a JSValue to toRef on 32-bit builds can perform an allocation,
        so we need to make sure we hold a JSLock when that occurs.

        Reviewed by Oliver Hunt.

        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValueData::serialize):
        (WebCore::SerializedScriptValueData::deserialize):
        Moved JSLocks from here...

        (WebCore::SerializedScriptValue::create):
        (WebCore::SerializedScriptValue::deserialize):
        ...to this higher level, from which toRef can be called.

2010-01-28  Oliver Hunt  <oliver@apple.com>

        Reviewed by Gavin Barraclough.

        DOM Objects shouldn't all require custom mark functions
        https://bugs.webkit.org/show_bug.cgi?id=34291

        Make DOMObjectWithGlobalPointer use an anonymous slot to store the global object
        reference.

        * bindings/js/JSDOMBinding.h:
        (WebCore::DOMObjectWithGlobalPointer::globalObject):
        (WebCore::DOMObjectWithGlobalPointer::scriptExecutionContext):
        (WebCore::DOMObjectWithGlobalPointer::DOMObjectWithGlobalPointer):

2010-01-28  Oliver Hunt  <oliver@apple.com>

        Reviewed by Gavin Barraclough.

        Simplify anonymous slot implementation
        https://bugs.webkit.org/show_bug.cgi?id=34282

        Update the WebCore JS DOM bindings to correctly pass and
        propagate the anonymous slot count information.

        * bindings/js/JSDOMBinding.h:
        (WebCore::DOMObjectWithGlobalPointer::createStructure):
        (WebCore::DOMConstructorObject::createStructure):
        * bindings/js/JSDOMWindowShell.h:
        (WebCore::JSDOMWindowShell::createStructure):
        * bindings/scripts/CodeGeneratorJS.pm:
        * bridge/objc/objc_runtime.h:
        (JSC::Bindings::ObjcFallbackObjectImp::createStructure):
        * bridge/runtime_array.h:
        (JSC::RuntimeArray::createStructure):
        * bridge/runtime_method.h:
        (JSC::RuntimeMethod::createStructure):
        * bridge/runtime_object.h:
        (JSC::RuntimeObjectImp::createStructure):

2010-01-27  Evan Martin  <evan@chromium.org>

        Reviewed by David Levin.

        [chromium] hebrew vowel marks incorrectly positioned
        https://bugs.webkit.org/show_bug.cgi?id=34234

        Fix glyph metrics computation such that the glyph offsets
        are correct, so we can now make use of them.

        Test: fast/text/international/hebrew-vowels.html

        * platform/graphics/chromium/FontLinux.cpp:
        (WebCore::TextRunWalker::createGlyphArrays): initialize per-glyph
        offset table.
        (WebCore::TextRunWalker::setGlyphXPositions): use per-glyph
        offsets.
        * platform/graphics/chromium/HarfbuzzSkia.cpp:
        (WebCore::getGlyphMetrics): fix metrics computation such that
        per-glyph offsets are computed correctly.

2010-01-28  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Unreviewed build fix.

        [Qt] Build fix if websockets support is turned off after r53947.

        * WebCore.pro:

2010-01-28  Dimitri Glazkov  <dglazkov@chromium.org>

        No review, rolling out r54012.
        http://trac.webkit.org/changeset/54012
        https://bugs.webkit.org/show_bug.cgi?id=34266

        Introduced 33 crashes in V8 traversal/ tests.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::mainWorldScriptState):
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptState.cpp:
        * bindings/js/ScriptState.h:
        * bindings/v8/ScriptCallStack.cpp:
        (WebCore::ScriptCallStack::ScriptCallStack):
        * bindings/v8/ScriptController.cpp:
        (WebCore::ScriptController::mainWorldScriptState):
        (WebCore::ScriptController::currentScriptState):
        (WebCore::ScriptController::clearWindowShell):
        * bindings/v8/ScriptController.h:
        * bindings/v8/ScriptScope.cpp:
        (WebCore::ScriptScope::ScriptScope):
        (WebCore::ScriptScope::success):
        * bindings/v8/ScriptScope.h:
        * bindings/v8/ScriptState.cpp:
        (WebCore::ScriptState::ScriptState):
        (WebCore::scriptStateFromPage):
        * bindings/v8/ScriptState.h:
        (WebCore::ScriptState::ScriptState):
        (WebCore::ScriptState::frame):
        * bindings/v8/V8HiddenPropertyName.h:
        * bindings/v8/V8IsolatedContext.cpp:
        (WebCore::V8IsolatedContext::scriptState):
        * bindings/v8/V8IsolatedContext.h:
        * bindings/v8/V8Utilities.cpp:
        (WebCore::getScriptExecutionContext):
        (WebCore::reportException):
        * bindings/v8/custom/V8NodeIteratorCustom.cpp:
        (WebCore::V8NodeIterator::nextNodeCallback):
        (WebCore::V8NodeIterator::previousNodeCallback):
        * bindings/v8/custom/V8TreeWalkerCustom.cpp:
        (WebCore::V8TreeWalker::parentNodeCallback):
        (WebCore::V8TreeWalker::firstChildCallback):
        (WebCore::V8TreeWalker::lastChildCallback):
        (WebCore::V8TreeWalker::nextNodeCallback):
        (WebCore::V8TreeWalker::previousNodeCallback):
        (WebCore::V8TreeWalker::nextSiblingCallback):
        (WebCore::V8TreeWalker::previousSiblingCallback):
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::injectedScriptForNodeId):

2010-01-28  Steve Block  <steveblock@google.com>

        Reviewed by Adam Barth.

        Fix missing forward-declarations and includes in V8 bindings
        https://bugs.webkit.org/show_bug.cgi?id=34272

        No new tests, build fix only.

        * bindings/v8/ScriptController.h: Modified. Forward-declare NPObject
        * bindings/v8/V8DOMWindowShell.cpp: Modified. Include CString.h and PlatformBridge.h
        * bindings/v8/V8DOMWrapper.h: Modified. Forward-declare V8Proxy

2010-01-28  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Adam Barth.

        Remove ScriptState::frame which is only used for reporting exceptions
        in some cases in a way that diverges from the regular exception reporting in
        v8 bindings.
        
        Cache ScriptState directly on v8::Context instead of providing
        implementations specific for isolated worlds and ScriptController.

        https://bugs.webkit.org/show_bug.cgi?id=34266

        * bindings/js/ScriptController.cpp:
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptState.cpp:
        (WebCore::mainWorldScriptState):
        * bindings/js/ScriptState.h:
        * bindings/v8/ScriptCallStack.cpp:
        (WebCore::ScriptCallStack::ScriptCallStack):
        * bindings/v8/ScriptController.cpp:
        (WebCore::ScriptController::clearWindowShell):
        * bindings/v8/ScriptController.h:
        * bindings/v8/ScriptScope.cpp:
        (WebCore::ScriptScope::ScriptScope):
        (WebCore::ScriptScope::success):
        * bindings/v8/ScriptScope.h:
        * bindings/v8/ScriptState.cpp:
        (WebCore::ScriptState::ScriptState):
        (WebCore::ScriptState::forContext):
        (WebCore::ScriptState::current):
        (WebCore::ScriptState::empty):
        (WebCore::ScriptState::weakReferenceCallback):
        (WebCore::mainWorldScriptState):
        (WebCore::scriptStateFromPage):
        * bindings/v8/ScriptState.h:
        * bindings/v8/V8HiddenPropertyName.h:
        * bindings/v8/V8IsolatedContext.cpp:
        * bindings/v8/V8IsolatedContext.h:
        * bindings/v8/V8Utilities.cpp:
        (WebCore::getScriptExecutionContext):
        (WebCore::reportException):
        * bindings/v8/custom/V8NodeIteratorCustom.cpp:
        (WebCore::V8NodeIterator::nextNodeCallback):
        (WebCore::V8NodeIterator::previousNodeCallback):
        * bindings/v8/custom/V8TreeWalkerCustom.cpp:
        (WebCore::V8TreeWalker::parentNodeCallback):
        (WebCore::V8TreeWalker::firstChildCallback):
        (WebCore::V8TreeWalker::lastChildCallback):
        (WebCore::V8TreeWalker::nextNodeCallback):
        (WebCore::V8TreeWalker::previousNodeCallback):
        (WebCore::V8TreeWalker::nextSiblingCallback):
        (WebCore::V8TreeWalker::previousSiblingCallback):
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::injectedScriptForNodeId):

2010-01-28  Adam Barth  <abarth@webkit.org>

        Reviewed by David Levin.

        Remove XSSAuditor false positive for Google Translate
        https://bugs.webkit.org/show_bug.cgi?id=34242

        Google translate takes a base URL as a parameter, causing a false
        positive in the XSS filter.  This patch removes the false positive by
        allowing direct injections into the href property of the base tag.

        Test: http/tests/security/xssAuditor/base-href-direct.html

        * page/XSSAuditor.cpp:
        (WebCore::XSSAuditor::canSetBaseElementURL):

2010-01-28  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        Save additional memory in SVG*Element classes, by introducing SVGElementRareData
        https://bugs.webkit.org/show_bug.cgi?id=34268

        Introduce SVGElementRareData, to remove the need to store any members in SVGElement/SVGStyledElement.
        This saves some additional MB for the svg-node-count-vs-scroll.xhtml testcase.

        SVGElementRareData works just like NodeRareData. Unlike ElementRareData, we're not inheriting from
        NodeRareData in SVG, as we don't need all the rare data stored there, unlike Element.

        * GNUmakefile.am: Add SVGElementRareData.h to build.
        * WebCore.gypi: Ditto.
        * WebCore.pro: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * dom/Node.cpp: Use Nodes bitfield to keep track wheter a SVGElement has a SVGElementRareData object associated.
        (WebCore::Node::Node):
        * dom/Node.h: Add m_hasRareSVGData flag, merged with the existing bitfield, 10 bits remaining now.
        (WebCore::Node::hasRareSVGData):
        * svg/SVGAnimateMotionElement.cpp: SVGElement::instancesForElement() now returns a const-reference to the HashMap instead of copying.
        (WebCore::SVGAnimateMotionElement::applyResultsToTarget):
        * svg/SVGAnimateTransformElement.cpp: Ditto.
        (WebCore::SVGAnimateTransformElement::applyResultsToTarget):
        * svg/SVGAnimationElement.cpp: Ditto.
        (WebCore::SVGAnimationElement::setTargetAttributeAnimatedValue):
        * svg/SVGElement.cpp: Move the element instances HashSet and two cursor-related pointers into SVGElementRareData.
        (WebCore::SVGElement::SVGElement):
        (WebCore::SVGElement::~SVGElement):
        (WebCore::SVGElement::rareSVGData): Modelled just like Node::rareData().
        (WebCore::SVGElement::ensureRareSVGData): Dito.
        (WebCore::SVGElement::accessDocumentSVGExtensions):
        (WebCore::SVGElement::mapInstanceToElement): Route call through SVGElementRareData.
        (WebCore::SVGElement::removeInstanceMapping): Ditto.
        (WebCore::SVGElement::instancesForElement): Ditto.
        (WebCore::SVGElement::setCursorElement): Ditto.
        (WebCore::SVGElement::setCursorImageValue): Ditto.
        * svg/SVGElement.h:
        * svg/SVGElementInstance.cpp: Ditto.
        (WebCore::SVGElementInstance::invalidateAllInstancesOfElement):
        * svg/SVGElementRareData.h: Added. Based on NodeRareData - works exactly the same.
        (WebCore::SVGElementRareData::SVGElementRareData):
        (WebCore::SVGElementRareData::rareDataMap):
        (WebCore::SVGElementRareData::rareDataFromMap):
        (WebCore::SVGElementRareData::elementInstances):
        (WebCore::SVGElementRareData::instanceUpdatesBlocked):
        (WebCore::SVGElementRareData::setInstanceUpdatesBlocked):
        (WebCore::SVGElementRareData::cursorElement):
        (WebCore::SVGElementRareData::setCursorElement):
        (WebCore::SVGElementRareData::cursorImageValue):
        (WebCore::SVGElementRareData::setCursorImageValue):
        * svg/SVGStyledElement.cpp: Move m_instancesUpdatesBlocked into SVGElementRareData.
        (WebCore::SVGStyledElement::SVGStyledElement):
        (WebCore::SVGStyledElement::instanceUpdatesBlocked):
        (WebCore::SVGStyledElement::setInstanceUpdatesBlocked):
        * svg/SVGStyledElement.h:
        * svg/SVGUseElement.cpp: Adapt to element instances changes, now passed as const-reference.
        (WebCore::dumpInstanceTree):

2010-01-28  Aaron Boodman  <aa@chromium.org>

        Reviewed by Darin Adler.

        Expand the NotificationPresenter::checkPermission() interface to send the full
        URL of the requesting context, as well as a pointer to the document if that
        context was a document.

        https://bugs.webkit.org/show_bug.cgi?id=34238

        * notifications/Notification.cpp:
        (WebCore::Notification::Notification):
        * notifications/NotificationCenter.cpp:
        (WebCore::NotificationCenter::NotificationCenter):
        (WebCore::NotificationCenter::checkPermission):
        Pass the full URL and document from the requesting context when calling
        NotificationPresenter::checkPermission().
        
        * notifications/NotificationPresenter.h:
        (WebCore::NotificationPresenter::):
        Expand interface.

2010-01-28  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Video can overlap position:fixed element when scrolling
        https://bugs.webkit.org/show_bug.cgi?id=32180
        
        When the scroll position changes, and we're using overlap to decide what gets composited,
        then we need to re-evaluate what gets compositing when scrolling in case fixed postion elements
        overlap composited elements (e.g. video).

        Test: compositing/geometry/video-fixed-scrolling.html

        * page/FrameView.cpp:
        (WebCore::FrameView::updateCompositingLayers):
        (WebCore::FrameView::scrollPositionChanged): Annotate the calls to updateCompositingLayers()
        with the type of change that occurred.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateCompositingAndLayerListsIfNeeded): Ditto.
        
        * rendering/RenderLayerCompositor.h:
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::updateCompositingLayers): For scroll changes, check
        for hierarchy update if m_compositingConsultsOverlap is true, and do
        a geometry update. For other changes, always check for hierarchy updates.

2010-01-27  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        Fix for user stylesheet bugs where they get parsed using the wrong compatibility mode.  This was a regression
        caused from Safari 3 -> 4 by the Acid3 fixes to create a real DOCTYPE in the DOM.

        This patch makes style selector creation lazy, so that the selector isn't built unless someone asks for it.

        In order to avoid creating the style selector before the compatibility mode has been determined, document
        style is now created without having a dependence on an instantiated style selector.  The creation of the style
        is now done as a static method on CSSStyleSelector called styleForDocument, and a couple of font-related
        functions have been made static as well so that they can be used by this method.

        m_styleSelector on Document is now an OwnPtr.

        Added userscripts/mixed-case-stylesheet.html

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::styleForDocument):
        (WebCore::CSSStyleSelector::applyProperty):
        (WebCore::CSSStyleSelector::checkForGenericFamilyChange):
        (WebCore::CSSStyleSelector::setFontSize):
        (WebCore::CSSStyleSelector::getComputedSizeFromSpecifiedSize):
        (WebCore::CSSStyleSelector::fontSizeForKeyword):
        * css/CSSStyleSelector.h:
        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::~Document):
        (WebCore::Document::recalcStyle):
        (WebCore::Document::createStyleSelector):
        (WebCore::Document::attach):
        (WebCore::Document::setVisuallyOrdered):
        (WebCore::Document::recalcStyleSelector):
        * dom/Document.h:
        (WebCore::Document::styleSelector):
        (WebCore::Document::visuallyOrdered):
        * html/HTMLDocument.cpp:
        (WebCore::HTMLDocument::determineParseMode):
        * loader/PlaceholderDocument.cpp:
        (WebCore::PlaceholderDocument::attach):

2010-01-28  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        Rename ISODateTime.{cpp,h} to DateComponents.{cpp,h}
        https://bugs.webkit.org/show_bug.cgi?id=34245

        No functional changes.

        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * html/DateComponents.cpp: Copied from WebCore/html/ISODateTime.cpp.
        (WebCore::DateComponents::maxWeekNumberInYear):
        (WebCore::DateComponents::parseYear):
        (WebCore::DateComponents::addDay):
        (WebCore::DateComponents::addMinute):
        (WebCore::DateComponents::parseTimeZone):
        (WebCore::DateComponents::parseMonth):
        (WebCore::DateComponents::parseDate):
        (WebCore::DateComponents::parseWeek):
        (WebCore::DateComponents::parseTime):
        (WebCore::DateComponents::parseDateTimeLocal):
        (WebCore::DateComponents::parseDateTime):
        (WebCore::DateComponents::setMillisecondsSinceMidnightInternal):
        (WebCore::DateComponents::setMillisecondsSinceEpochForDateInternal):
        (WebCore::DateComponents::setMillisecondsSinceEpochForDate):
        (WebCore::DateComponents::setMillisecondsSinceEpochForDateTime):
        (WebCore::DateComponents::setMillisecondsSinceEpochForDateTimeLocal):
        (WebCore::DateComponents::setMillisecondsSinceEpochForMonth):
        (WebCore::DateComponents::setMillisecondsSinceMidnight):
        (WebCore::DateComponents::setMillisecondsSinceEpochForWeek):
        (WebCore::DateComponents::millisecondsSinceEpochForTime):
        (WebCore::DateComponents::millisecondsSinceEpoch):
        (WebCore::DateComponents::toStringForTime):
        (WebCore::DateComponents::toString):
        * html/DateComponents.h: Copied from WebCore/html/ISODateTime.h.
        (WebCore::DateComponents::DateComponents):
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::parseToDouble):
        (WebCore::HTMLInputElement::valueAsDate):
        (WebCore::HTMLInputElement::setValueAsDate):
        (WebCore::HTMLInputElement::setValueAsNumber):
        (WebCore::HTMLInputElement::formStringToDateComponents):
        * html/HTMLInputElement.h:
        * html/ISODateTime.cpp: Removed.
        * html/ISODateTime.h: Removed.
        * html/ValidityState.cpp:
        (WebCore::ValidityState::typeMismatch):

2010-01-28  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Pavel Feldman.

        Use platform-specific monospace fonts in the Web Inspector

        Move the OS version detection code into the frontend,
        add custom CSS monospace styles for known platforms.
        https://bugs.webkit.org/show_bug.cgi?id=34040

        * inspector/InspectorFrontendHost.cpp:
        (WebCore::InspectorFrontendHost::platform):
        * inspector/front-end/BreakpointsSidebarPane.js:
        (WebInspector.BreakpointsSidebarPane.prototype._appendBreakpointElement):
        * inspector/front-end/DatabaseQueryView.js:
        (WebInspector.DatabaseQueryView):
        * inspector/front-end/InspectorBackendStub.js:
        (.WebInspector.InspectorBackendStub.prototype.releaseWrapperObjectGroup):
        (.WebInspector.InspectorBackendStub.prototype.setInjectedScriptSource):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype._createConditionElement):
        * inspector/front-end/inspector.css:
        * inspector/front-end/inspector.html:
        * inspector/front-end/inspector.js:
        (WebInspector.URLRegExp.i.get platform):
        (WebInspector._detectPlatform):

2010-01-28  Mikhail Naganov  <mnaganov@chromium.org>

        Reviewed by Timothy Hatcher.

        Simplify views logic in Profiler panel, and fix the problem described in the issue.
        Remove image from Welcome view.
        Preserve border on status bar-like buttons in Welcome view on window deactivation.

        https://bugs.webkit.org/show_bug.cgi?id=34201

        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype.show):
        (WebInspector.ProfilesPanel.prototype.reset):
        (WebInspector.ProfilesPanel.prototype.addProfileHeader):
        (WebInspector.ProfilesPanel.prototype.showView):
        (WebInspector.ProfilesPanel.prototype._updateInterface):
        * inspector/front-end/WelcomeView.js:
        (WebInspector.WelcomeView):
        * inspector/front-end/inspector.css:

2010-01-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Eric Seidel.

        [Qt] Speed up KURL to QUrl conversion
        https://bugs.webkit.org/show_bug.cgi?id=33873

        The WebCore::String::utf8 method will use the generic WebCore::TextCodec
        and then call the encode method on it. In QtWebKit this class is implemented
        around the QTextCodec class. Instead of going the generic codec way we treat
        the WebCore::String as a QString (no copying) and then use the built-in
        QString::toUtf8 to do the conversion.

        * platform/qt/KURLQt.cpp:
        (WebCore::KURL::operator QUrl):

2010-01-28  Ben Murdoch  <benm@google.com>

        Reviewed by Simon Hausmann.

        [Android] [Qt] Touch event page co-ordinates are incorrect when touch is received in an iframe.
        https://bugs.webkit.org/show_bug.cgi?id=34162

        The pageX/pageY co-ordinates of a touch event should be relative to the containing frame, not the main frame. This change implements that and also updates the existing touch-inside-iframe test to also examine the page co-ordinates.

        * dom/Touch.cpp:
        (WebCore::Touch::Touch): Remove dead code.
        * dom/Touch.h: Remove dead code.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleTouchEvent): Rename framePoint to pagePoint, as it seems a clearer name. Also adjust the pagePoint to be relative to the touch target element's containing frame rather than the main frame.
        * platform/PlatformTouchEvent.h: Rename Android specific constructor parameter to better reflect it's contents.
        * platform/PlatformTouchPoint.h: Ditto.
        * platform/android/PlatformTouchEventAndroid.cpp: Ditto.
        * platform/android/PlatformTouchPointAndroid.cpp: Ditto.

2010-01-28  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Simplify isActivation method.

        https://bugs.webkit.org/show_bug.cgi?id=34161

        Test: WebCore/manual-tests/inspector/debugger-scopes-inspection.html

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::isActivation):

2010-01-27  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        rangeOverflow/rangeUnderflow support for type=date
        https://bugs.webkit.org/show_bug.cgi?id=34209

        Add DATE type support to rangeUnderflow(), rangeOverflow(),
        minimum(), and maximum() of HTMLInputElement.
        In order to unify parsing code for value, min, and max strings,
        introduce parseToDouble() function and it is called by
        valueAsDate() and valueAsNumber() too.

        Tests: fast/forms/ValidityState-rangeOverflow-date.html
               fast/forms/ValidityState-rangeUnderflow-date.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::rangeUnderflow): Support DATE type, and use parseToDouble().
        (WebCore::HTMLInputElement::rangeOverflow): ditto.
        (WebCore::HTMLInputElement::minimum): ditto.
        (WebCore::HTMLInputElement::maximum): ditto.
        (WebCore::HTMLInputElement::doubleValueFor): Added.
        (WebCore::HTMLInputElement::valueAsDate): Use parseToDouble().
        (WebCore::HTMLInputElement::valueAsNumber): Use parseToDouble().
        * html/HTMLInputElement.h: Declare parseToDouble().

2010-01-27  Darin Fisher  <darin@chromium.org>

        Fix chromium build bustage (take 2).

        * bindings/scripts/CodeGeneratorV8.pm: Really treat V8CustomGetter like CustomGetter in all cases.

2010-01-27  Darin Fisher  <darin@chromium.org>

        Fix chromium build bustage.

        * bindings/scripts/CodeGeneratorV8.pm: Treat V8CustomGetter like CustomGetter in all cases.

2010-01-27  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej Stachowiak.

        MessageEvent.data should deserialize in the context of the MessageEvent's global object
        https://bugs.webkit.org/show_bug.cgi?id=34227

        Make ScriptValue deserialisation support the provision of a specific global
        object to use when creating new objects.  This then allows us to make
        MessageEvent.data and PopStateEvent.state deserialize in the correct
        context.

        Test: fast/dom/Window/window-postmessage-clone-frames.html

        * bindings/js/JSPopStateEventCustom.cpp:
          Remove custom implementation of state getter
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::DeserializingTreeWalker::DeserializingTreeWalker):
        (WebCore::DeserializingTreeWalker::createOutputArray):
        (WebCore::DeserializingTreeWalker::createOutputObject):
        (WebCore::DeserializingTreeWalker::convertIfTerminal):
        (WebCore::SerializedScriptValueData::deserialize):
        (WebCore::SerializedScriptValue::deserialize):
        * bindings/js/SerializedScriptValue.h:
        (WebCore::SerializedScriptValue::deserialize):
        * bindings/scripts/CodeGeneratorJS.pm:
          Update bindings generation to pass the correct global object, and to
          treat "any" as synonymous with SerializedValue.
        * dom/PopStateEvent.idl:

2010-01-27  Nicholas Young  <nicholas.young@nokia.com>

        Reviewed by Eric Carlson.

        Make media controls fade in/out transition duration configurable on a theme level.
        https://bugs.webkit.org/show_bug.cgi?id=34196

        No new tests needed (I hope).

        * rendering/RenderMedia.cpp:
        (WebCore::RenderMedia::RenderMedia): Removed constant from contructor - the initial value is meaningless.
        (WebCore::RenderMedia::updateControlVisibility): Get fade in/out duration from theme.
        * rendering/RenderTheme.h:
        (WebCore::RenderTheme::mediaControlsFadeInDuration): New virtual method.
        (WebCore::RenderTheme::mediaControlsFadeOutDuration): New virtual method.

2010-01-27  John Abd-El-Malek  <jam@chromium.org>

        Reviewed by Dimitri Glazkov.

        Tests that when a page removes an iframe that sleeps in its unload handler and
        terminates its JS execution, the outer page's JS continues running.
        
        https://bugs.webkit.org/show_bug.cgi?id=34226

        Tests: fast/dom/Window/slow-unload-handler-only-frame-is-stopped.html
               fast/dom/Window/slow-unload-handler.html

        * bindings/v8/DateExtension.cpp:
        (WebCore::DateExtension::OnSleepDetected):

2010-01-27  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        Add valueAsNumber support for type=datetime-local.
        https://bugs.webkit.org/show_bug.cgi?id=34200

        Implement necessary methods of ISODateTime, and call them from
        HTMLInputElement.

        Test: fast/forms/input-valueasnumber-datetimelocal.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::valueAsNumber):
        (WebCore::HTMLInputElement::setValueAsNumber):
        * html/ISODateTime.cpp:
        (WebCore::ISODateTime::setMillisecondsSinceEpochForDateTimeLocal):
          Implemented.  Just call setMillisecondsSinceEpochForDateTime().
        (WebCore::ISODateTime::millisecondsSinceEpochForTime):
          Accept to be called for m_type=DateTimeLocal.
        (WebCore::ISODateTime::toString): Add DateTimeLocal support.
        * html/ISODateTime.h: Declare new methods.

2010-01-27  Steve Falkenburg  <sfalken@apple.com>

        Windows Debug_All build fix.

        * platform/graphics/win/WKCACFLayer.cpp:
        * platform/graphics/win/WKCACFLayerRenderer.cpp:

2010-01-27  Evan Martin  <evan@chromium.org>

        Reviewed by David Levin.

        [chromium] complex text draws newlines as bells
        https://bugs.webkit.org/show_bug.cgi?id=34186

        Revert r45496 -- once we've got a glyph array, it is too late to normalize
        because we could have had multiple codepoints combine into one glyph.  The
        Uniscribe code it mentions it's duplicating uses the log cluster map to fix
        this.

        Instead, we just normalize the input text if it contains any non-ascii-space
        whitespace.

        This fixes fast/text/international/hindi-whitespace, which currently has an
        incorrect baseline containing a square box glyph.

        * platform/graphics/chromium/FontLinux.cpp:
        (WebCore::TextRunWalker::getTextRun):
        (WebCore::TextRunWalker::getNormalizedTextRun):
        * platform/graphics/chromium/HarfbuzzSkia.cpp:
        (WebCore::stringToGlyphs):

2010-01-27  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=34150
        WebKit needs a mechanism to catch stale HashMap entries

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSRuleSet::getIDRules):
        (WebCore::CSSRuleSet::getClassRules):
        (WebCore::CSSRuleSet::getTagRules):
        (WebCore::CSSStyleSelector::keyframeStylesForAnimation):
        * dom/CheckedRadioButtons.cpp:
        (WebCore::CheckedRadioButtons::checkedButtonForGroup):
        (WebCore::CheckedRadioButtons::removeButton):
        * editing/markup.cpp:
        (WebCore::shouldAddNamespaceAttr):
        (WebCore::appendNamespace):
        (WebCore::appendStartMarkup):
        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::namedItems):
        (WebCore::HTMLCollection::nextNamedItem):
        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::formCollectionInfo):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::collectionInfo):
        * loader/loader.cpp:
        (WebCore::Loader::load):
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::nonCacheRequestInFlight):
        (WebCore::Loader::nonCacheRequestComplete):
        (WebCore::Loader::cancelRequests):
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimation::clearRenderer):
        (WebCore::CompositeAnimation::updateKeyframeAnimations):
        (WebCore::CompositeAnimation::animate):
        (WebCore::CompositeAnimation::getAnimatedStyle):
        (WebCore::CompositeAnimation::setAnimating):
        (WebCore::CompositeAnimation::timeToNextService):
        (WebCore::CompositeAnimation::getAnimationForProperty):
        (WebCore::CompositeAnimation::suspendAnimations):
        (WebCore::CompositeAnimation::resumeAnimations):
        (WebCore::CompositeAnimation::isAnimatingProperty):
        (WebCore::CompositeAnimation::pauseAnimationAtTime):
        (WebCore::CompositeAnimation::numberOfActiveAnimations):
        Added checkConsistency checks before lookups in HashMaps with AtomicStringImpl* keys.

        * dom/Document.cpp:
        (WebCore::Document::removedLastRef): Clear m_elementsById map, because removeAllChildren()
        doesn't always update it correctly when called during docuemnt destruction.
        (WebCore::Document::getElementById): Added checkConsistency().
        (WebCore::Document::removeElementById): Ditto.
        (WebCore::Document::removeImageMap): Ditto.
        (WebCore::Document::getImageMap): Ditto.
        (WebCore::Document::nameCollectionInfo): Ditto.
        * dom/Document.h:
        (WebCore::Document::collectionInfo): Ditto.

        * html/CollectionCache.cpp:
        (WebCore::CollectionCache::checkConsistency):
        * html/CollectionCache.h:
        Added a checkConsistency() method that checks both HashMaps in the cache.

        * platform/TreeShared.h:
        (WebCore::TreeShared::~TreeShared): Assert that m_refCount is null. Since Nodes can be
        destroyed with operator delete (as done in ContainerNodeAlgorithms), this is important to check.
        (WebCore::TreeShared::deref): Assert that m_refCount isn't already negative.

2010-01-27  Brian Tarricone  <brian@kakai.com>

        Reviewed by Gustavo Noronha Silva.

        [gtk] Add support for windowless NPAPI plugins

        Much of this is a translation of how the Qt backend does this,
        modified for Gtk.

        https://bugs.webkit.org/show_bug.cgi?id=18831

        No new tests; there is already a windowless test in the tree.

        * plugins/PluginView.cpp:
        (WebCore::PluginView::handleEvent):
        (WebCore::PluginView::PluginView):
        * plugins/PluginView.h:
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::getRootWindow):
        (WebCore::PluginView::updatePluginWidget):
        (WebCore::PluginView::paint):
        (WebCore::PluginView::handleKeyboardEvent):
        (WebCore::inputEventState):
        (WebCore::PluginView::initXEvent):
        (WebCore::setXButtonEventSpecificFields):
        (WebCore::setXMotionEventSpecificFields):
        (WebCore::setXCrossingEventSpecificFields):
        (WebCore::PluginView::handleMouseEvent):
        (WebCore::PluginView::handleFocusInEvent):
        (WebCore::PluginView::handleFocusOutEvent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::setNPWindowIfNeeded):
        (WebCore::PluginView::getValueStatic):
        (WebCore::PluginView::invalidateRect):
        (WebCore::getPluginDisplay):
        (WebCore::plug_removed_cb):
        (WebCore::getVisualAndColormap):
        (WebCore::PluginView::platformStart):
        (WebCore::PluginView::platformDestroy):

2010-01-27  Anton Muhin  <antonm@chromium.org>

        Reviewed by David Levin.

        [v8] minor cosmetic fix in V8 bindings codegenerator
        https://bugs.webkit.org/show_bug.cgi?id=34224

        * bindings/scripts/CodeGeneratorV8.pm:

2010-01-27  Darin Fisher  <darin@chromium.org>

        Fix Chromium build bustage.

        * rendering/RenderBoxModelObject.cpp: Add wtf/CurrentTime.h include.

2010-01-26  Darin Fisher  <darin@chromium.org>

        Reviewed by Brady Eidson and David Levin.

        Chains of history items representing same-document navigation need to
        always remember that association

        https://bugs.webkit.org/show_bug.cgi?id=33224

        Replace HistoryItem's Document pointer with a DocumentSequenceNumber.
        During session history traversal, if the current HistoryItem and the
        target HistoryItem have the same DocumentSequenceNumber, then it means
        that the current Document should remain.

        NOTE: To support Chromium's serialization of HistoryItems, I generate
        DocumentSequenceNumbers that are unique across application launches.
        DocumentSequenceNumbers are generated using a counter initialized with
        the time of day.

        Test: fast/loader/stateobjects/document-destroyed-navigate-back.html

        * dom/Document.cpp:
        (WebCore::Document::detach):
        * dom/Document.h:
        * history/BackForwardList.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/BackForwardListChromium.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/HistoryItem.cpp:
        (WebCore::generateDocumentSequenceNumber):
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::~HistoryItem):
        (WebCore::HistoryItem::setStateObject):
        * history/HistoryItem.h:
        (WebCore::HistoryItem::setDocumentSequenceNumber):
        (WebCore::HistoryItem::documentSequenceNumber):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::navigateWithinDocument):
        (WebCore::FrameLoader::loadItem):
        * loader/HistoryController.cpp:
        (WebCore::HistoryController::updateBackForwardListForFragmentScroll):
        (WebCore::HistoryController::pushState):
        (WebCore::HistoryController::replaceState):
        * loader/RedirectScheduler.cpp:
        (WebCore::RedirectScheduler::scheduleHistoryNavigation):
        * page/History.cpp:
        (WebCore::History::stateObjectAdded):
        * page/Page.cpp:
        (WebCore::Page::goToItem):

2010-01-27  Oliver Hunt  <oliver@apple.com>

        Reviewed by Simon Fraser.

        Animated scaling of background-image is too slow
        https://bugs.webkit.org/show_bug.cgi?id=33808

        Implement a version of the RenderImage animated scaling optimisation
        for background images.  Due to the possibility of arbitrary transforms
        being applied to containing elements we explicitly check the current
        CTM of the context for scaling or rotation.

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::drawTiledImage):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/transforms/TransformationMatrix.h:
        (WebCore::TransformationMatrix::isIdentityOrTranslation):
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelScaleData::RenderBoxModelScaleData):
        (WebCore::RenderBoxModelScaleData::~RenderBoxModelScaleData):
        (WebCore::RenderBoxModelScaleData::size):
        (WebCore::RenderBoxModelScaleData::time):
        (WebCore::RenderBoxModelScaleData::useLowQualityScale):
        (WebCore::RenderBoxModelScaleData::hiqhQualityRepaintTimer):
        (WebCore::RenderBoxModelScaleData::setSize):
        (WebCore::RenderBoxModelScaleData::setTime):
        (WebCore::RenderBoxModelScaleData::setUseLowQualityScale):
        (WebCore::RenderBoxModelScaleObserver::boxModelObjectDestroyed):
        (WebCore::RenderBoxModelScaleObserver::highQualityRepaintTimerFired):
        (WebCore::RenderBoxModelScaleObserver::shouldPaintBackgroundAtLowQuality):
        (WebCore::RenderBoxModelObject::highQualityRepaintTimerFired):
        (WebCore::RenderBoxModelObject::~RenderBoxModelObject):
        (WebCore::RenderBoxModelObject::paintFillLayerExtended):
        * rendering/RenderBoxModelObject.h:

2010-01-27  Yael Aharon  <yael.aharon@nokia.com>

        Reviewed by Laszlo Gombos.

        [Qt] Enable websockets support in QtWebKit
        https://bugs.webkit.org/show_bug.cgi?id=34180

        Connected between SocketStreamHandle and QTcpSocket/QSslSocket
        to enable support for websockets.
        Proxy authentication is not yet supported.
        SSL certificate errors are ignored while this is under development.

        * WebCore.pro:
        * platform/network/qt/SocketStreamHandle.h:
        * platform/network/qt/SocketStreamHandlePrivate.h: Added.
        * platform/network/qt/SocketStreamHandleQt.cpp:
        (WebCore::SocketStreamHandlePrivate::SocketStreamHandlePrivate):
        (WebCore::SocketStreamHandlePrivate::~SocketStreamHandlePrivate):
        (WebCore::SocketStreamHandlePrivate::socketConnected):
        (WebCore::SocketStreamHandlePrivate::socketReadyRead):
        (WebCore::SocketStreamHandlePrivate::send):
        (WebCore::SocketStreamHandlePrivate::close):
        (WebCore::SocketStreamHandlePrivate::socketSentdata):
        (WebCore::SocketStreamHandlePrivate::socketClosed):
        (WebCore::SocketStreamHandlePrivate::socketError):
        (WebCore::SocketStreamHandlePrivate::socketClosedCallback):
        (WebCore::SocketStreamHandlePrivate::socketErrorCallback):
        (WebCore::SocketStreamHandlePrivate::socketSslErrors):
        (WebCore::SocketStreamHandle::SocketStreamHandle):
        (WebCore::SocketStreamHandle::~SocketStreamHandle):
        (WebCore::SocketStreamHandle::platformSend):
        (WebCore::SocketStreamHandle::platformClose):

2010-01-27  Mads Ager  <ager@chromium.org>

        Reviewed by Dimitri Glazkov.

        [V8] Support getting integer-named properties using indexing notation on document object
        https://bugs.webkit.org/show_bug.cgi?id=34211

        Add indexed property getter to HTMLDocument to support getting
        elements with integer names using indexing notation on document.

        Test: fast/dom/HTMLDocument/get-iframe-with-integer-name.html

        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/v8/custom/V8HTMLDocumentCustom.cpp:
        (WebCore::V8HTMLDocument::indexedPropertyGetter):

2010-01-27  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Oliver Hunt.

        Instead of relying on Object.prototype.toString result use JSObject::isActivationObject
        to check if a scope node is a JSActivation. Object.prototype.toString for JSActivation
        will call JSActivation::toThisObject whose result depends on the current call stack.

        https://bugs.webkit.org/show_bug.cgi?id=34161

        Test: WebCore/manual-tests/inspector/debugger-scopes-inspection.html

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::isActivation):
        * inspector/InjectedScriptHost.idl:
        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor.):
        * manual-tests/inspector/debugger-scopes-inspection.html: Added.

2010-01-27 Anton Muhin <antonm@google.com>
        Review by Adam Barth.

        Implement Node map in intrusive way for better speed.
        https://bugs.webkit.org/show_bug.cgi?id=33957

        * bindings/v8/DOMData.h:
        (WebCore::DOMData::removeObjectsFromWrapperMap):
        * bindings/v8/DOMDataStore.cpp:
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::get):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::set):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::removeIfPresent):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::contains):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::visit):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::clear):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::allocateTableEntry):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::freeTableEntry):
        * bindings/v8/DOMDataStore.h:
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::IntrusiveDOMWrapperMap):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::clearEntry):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::clearEntries):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::visitEntries):
        (WebCore::DOMDataStore::IntrusiveDOMWrapperMap::TableChunk::TableChunk):
        (WebCore::DOMDataStore::domNodeMap):
        * bindings/v8/StaticDOMDataStore.cpp:
        (WebCore::StaticDOMDataStore::StaticDOMDataStore):
        * bindings/v8/StaticDOMDataStore.h:
        * bindings/v8/V8DOMMap.cpp:
        (WebCore::getDOMNodeMap):
        * bindings/v8/V8DOMMap.h:
        (WebCore::AbstractWeakReferenceMap::AbstractWeakReferenceMap):
        (WebCore::AbstractWeakReferenceMap::weakReferenceCallback):
        (WebCore::WeakReferenceMap::WeakReferenceMap):
        (WebCore::WeakReferenceMap::set):
        (WebCore::WeakReferenceMap::visit):
        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore::V8DOMWrapper::convertDocumentToV8Object):
        (WebCore::getWrapper):
        (WebCore::V8DOMWrapper::convertNodeToV8Object):
        (WebCore::V8DOMWrapper::convertNewNodeToV8Object):
        * bindings/v8/V8DOMWrapper.h:

2010-01-27  Kinuko Yasuda  <kinuko@chromium.org>

        Reviewed by Eric Seidel.

        Add key event mappings for numpad keys for Gtk and Chromium/Gtk.
        http://bugs.webkit.org/show_bug.cgi?id=28247

        Test: fast/events/keydown-numpad-keys.html

        * platform/chromium/KeyCodeConversionGtk.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):
        * platform/gtk/KeyEventGtk.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):

2010-01-27  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: migrate from SourceFrame to SourceFrame2.

        https://bugs.webkit.org/show_bug.cgi?id=34171

        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * bindings/js/JSInspectorFrontendHostCustom.cpp:
        * bindings/v8/custom/V8InspectorFrontendHostCustom.cpp:
        * inspector/InspectorFrontendHost.cpp:
        * inspector/InspectorFrontendHost.h:
        * inspector/InspectorFrontendHost.idl:
        * inspector/front-end/InspectorBackendStub.js:
        * inspector/front-end/InspectorFrontendHostStub.js:
        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceView.prototype._innerSelectContentTab):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.getResourceContent):
        * inspector/front-end/ScriptView.js:
        (WebInspector.ScriptView):
        (WebInspector.ScriptView.prototype.setupSourceFrameIfNeeded):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._sidebarResizeDrag):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame):
        (WebInspector.SourceFrame.prototype.set executionLine):
        (WebInspector.SourceFrame.prototype.revealLine):
        (WebInspector.SourceFrame.prototype.addBreakpoint):
        (WebInspector.SourceFrame.prototype.removeBreakpoint):
        (WebInspector.SourceFrame.prototype.addMessage):
        (WebInspector.SourceFrame.prototype.clearMessages):
        (WebInspector.SourceFrame.prototype.sizeToFitContentHeight):
        (WebInspector.SourceFrame.prototype.setContent):
        (WebInspector.SourceFrame.prototype.findSearchMatches):
        (WebInspector.SourceFrame.prototype._collectRegexMatches):
        (WebInspector.SourceFrame.prototype.setSelection):
        (WebInspector.SourceFrame.prototype._incrementMessageRepeatCount):
        (WebInspector.SourceFrame.prototype._addExistingMessagesToSource):
        (WebInspector.SourceFrame.prototype._addMessageToSource):
        (WebInspector.SourceFrame.prototype._addExistingBreakpointsToSource):
        (WebInspector.SourceFrame.prototype._addBreakpointToSource):
        (WebInspector.SourceFrame.prototype._removeBreakpointFromSource):
        (WebInspector.SourceFrame.prototype._contextMenu.addConditionalBreakpoint):
        (WebInspector.SourceFrame.prototype._contextMenu):
        (WebInspector.SourceFrame.prototype._toggleBreakpoint):
        (WebInspector.SourceFrame.prototype._editBreakpointCondition.committed):
        (WebInspector.SourceFrame.prototype._editBreakpointCondition.dismissed):
        (WebInspector.SourceFrame.prototype._editBreakpointCondition):
        (WebInspector.SourceFrame.prototype._showBreakpointConditionPopup):
        (WebInspector.SourceFrame.prototype._createConditionElement):
        (WebInspector.SourceFrame.prototype._keyDown):
        (WebInspector.SourceFrame.prototype._evalSelectionInCallFrame):
        (WebInspector.SourceFrame.prototype._breakpointChanged):
        (WebInspector.SourceFrame.prototype.resize):
        (WebInspector.BreakpointLineNumberDecorator):
        (WebInspector.BreakpointLineNumberDecorator.prototype.decorate):
        (WebInspector.BreakpointLineNumberDecorator.prototype._paintBreakpoint):
        (WebInspector.BreakpointLineNumberDecorator.prototype._paintProgramCounter):
        (WebInspector.BreakpointLineNumberDecorator.prototype.mouseDown):
        (WebInspector.BreakpointLineNumberDecorator.prototype.contextMenu):
        (WebInspector.ExecutionLineDecorator):
        (WebInspector.ExecutionLineDecorator.prototype.decorate):
        * inspector/front-end/SourceFrame2.js: Removed.
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView):
        (WebInspector.SourceView.prototype.show):
        (WebInspector.SourceView.prototype.resize):
        (WebInspector.SourceView.prototype.setupSourceFrameIfNeeded):
        (WebInspector.SourceView.prototype._contentLoaded):
        (WebInspector.SourceView.prototype.performSearch.findSearchMatches):
        (WebInspector.SourceView.prototype.performSearch):
        (WebInspector.SourceView.prototype._jumpToSearchResult):
        (WebInspector.SourceView.prototype._sourceFrameSetupFinished):
        * inspector/front-end/TextEditor.js:
        (WebInspector.TextEditor.prototype._mouseDown):
        (WebInspector.TextEditor.prototype._copy.delayCopy):
        (WebInspector.TextEditor.prototype._copy):
        (WebInspector.TextEditor.prototype._cut):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.html:

2010-01-27  Dominik Röttsches  <dominik.roettsches@access-company.com>

        Reviewed by Xan Lopez.

        [Gtk] For removing ICU, implement IDN support by means of libidn
        https://bugs.webkit.org/show_bug.cgi?id=31470

        In order to avoid a new dependency, 
        IDN support now based on GLib for the GLib unicode backend.

        * platform/KURL.cpp:
        (WebCore::appendEncodedHostname):

2010-01-27  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] For package builds use the .def files on Symbian

        * WebCore.pro:

2010-01-27  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Timothy Hatcher.

        Avoid watch expressions duplication
        https://bugs.webkit.org/show_bug.cgi?id=33996

        * inspector/front-end/WatchExpressionsSidebarPane.js:
        (WebInspector.WatchExpressionsSidebarPane.prototype._settingsLoaded):

2010-01-27  Marcus Bulach  <bulach@chromium.org>

        Reviewed by Dimitri Glazkov.

        Adds EventSource bindings for V8
        https://bugs.webkit.org/show_bug.cgi?id=33695

        No new tests (existing layout tests for EventSource should pass).

        * Android.v8bindings.mk:
        * WebCore.gypi:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/v8/DOMObjectsInclude.h:
        * bindings/v8/DerivedSourcesAllInOne.cpp:
        * bindings/v8/V8DOMWrapper.cpp:
        * bindings/v8/V8DOMWrapper.h:
        * bindings/v8/V8Index.cpp:
        * bindings/v8/V8Index.h:
        * bindings/v8/WorkerContextExecutionProxy.cpp:
        * bindings/v8/custom/V8CustomBinding.h:
        * bindings/v8/custom/V8EventSourceConstructor.cpp: Added.
        * bindings/v8/custom/V8EventSourceCustom.cpp: Added.

2010-01-27  Kent Hansen  <kent.hansen@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Meta-methods can't be introspected using ES5 API
        https://bugs.webkit.org/show_bug.cgi?id=34087

        Add getOwnPropertyDescriptor() and getOwnPropertyNames() reimplementations.

        Tests are in WebKit/qt/tests/qwebframe

        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::QtRuntimeMetaMethod::getOwnPropertyDescriptor):
        (JSC::Bindings::QtRuntimeMetaMethod::getOwnPropertyNames):
        (JSC::Bindings::QtRuntimeConnectionMethod::getOwnPropertyDescriptor):
        (JSC::Bindings::QtRuntimeConnectionMethod::getOwnPropertyNames):
        * bridge/qt/qt_runtime.h:

2010-01-27  Tony Chang  <tony@chromium.org>

        Reviewed by Eric Seidel.

        Fix a crash when trying to indent a block element that was contained
        in a list.  This was happening because enclosingBlock() in
        htmlediting.cpp can return the current the same Node when a block
        element (like an <hr> or a <table>) is passed in.  This causes
        the indent command to think that it is not in a list item.

        Work around this by checking to see if enclosingBlock returned the
        same Node.

        https://bugs.webkit.org/show_bug.cgi?id=32390

        Test: editing/execCommand/indent-block-in-list.html

        * editing/IndentOutdentCommand.cpp:
        (WebCore::IndentOutdentCommand::tryIndentingAsListItem):

2010-01-27  Jocelyn Turcotte  <jocelyn.turcotte@nokia.com>

        Reviewed by Tor Arne Vestbø.

        [Qt] Add the "d" suffix to QtWebKit's dll on Windows.

        * WebCore.pro:

2010-01-27  Matt Perry  <mpcomplete@chromium.org>

        Reviewed by Eric Seidel.

        Fix a bug where dispatchDocumentElementAvailable was fired for fragment parsing on XML documents.
        https://bugs.webkit.org/show_bug.cgi?id=33920

        Tests: userscripts/script-not-run-for-fragments.html
               userscripts/script-run-at-start.html

        * dom/XMLTokenizerLibxml2.cpp:
        (WebCore::XMLTokenizer::startElementNs):

2010-01-27  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Improve SourceHTMLTokenizer so that it treats script tag well.

        https://bugs.webkit.org/show_bug.cgi?id=34177

        * inspector/front-end/SourceHTMLTokenizer.js:
        (WebInspector.SourceHTMLTokenizer):
        (WebInspector.SourceHTMLTokenizer.prototype._isAttribute):
        (WebInspector.SourceHTMLTokenizer.prototype._isAttributeValue):
        (WebInspector.SourceHTMLTokenizer.prototype._setAttributeValue):
        (WebInspector.SourceHTMLTokenizer.prototype._setAttribute):
        (WebInspector.SourceHTMLTokenizer.prototype._stringToken):
        (WebInspector.SourceHTMLTokenizer.prototype.nextToken):
        * inspector/front-end/SourceHTMLTokenizer.re2js:

2010-01-26  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: nuke quarantine wrappers.

        https://bugs.webkit.org/show_bug.cgi?id=34203

        * Android.jscbindings.mk:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * bindings/js/JSBindingsAllInOne.cpp:
        * bindings/js/JSInspectedObjectWrapper.cpp: Removed.
        * bindings/js/JSInspectedObjectWrapper.h: Removed.
        * bindings/js/JSInspectorCallbackWrapper.cpp: Removed.
        * bindings/js/JSInspectorCallbackWrapper.h: Removed.
        * bindings/js/JSQuarantinedObjectWrapper.cpp: Removed.
        * bindings/js/JSQuarantinedObjectWrapper.h: Removed.

2010-01-27  Alexey Proskuryakov  <ap@apple.com>

        Revert r53899 (HashMap<AtomicStringImpl*, Value> key checks) and subsequent build fixes,
        because they make SVG tests crash in release builds.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSRuleSet::getIDRules):
        (WebCore::CSSRuleSet::getClassRules):
        (WebCore::CSSRuleSet::getTagRules):
        (WebCore::CSSStyleSelector::keyframeStylesForAnimation):
        * dom/CheckedRadioButtons.cpp:
        (WebCore::CheckedRadioButtons::checkedButtonForGroup):
        (WebCore::CheckedRadioButtons::removeButton):
        * dom/ContainerNodeAlgorithms.h:
        (WebCore::removeAllChildrenInContainer):
        * dom/Document.cpp:
        (WebCore::Document::getElementById):
        (WebCore::Document::removeElementById):
        (WebCore::Document::removeImageMap):
        (WebCore::Document::getImageMap):
        (WebCore::Document::nameCollectionInfo):
        * dom/Document.h:
        (WebCore::Document::collectionInfo):
        * editing/markup.cpp:
        (WebCore::shouldAddNamespaceAttr):
        (WebCore::appendNamespace):
        (WebCore::appendStartMarkup):
        * html/CollectionCache.cpp:
        * html/CollectionCache.h:
        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::namedItems):
        (WebCore::HTMLCollection::nextNamedItem):
        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::formCollectionInfo):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::collectionInfo):
        * loader/loader.cpp:
        (WebCore::Loader::load):
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::nonCacheRequestInFlight):
        (WebCore::Loader::nonCacheRequestComplete):
        (WebCore::Loader::cancelRequests):
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimation::clearRenderer):
        (WebCore::CompositeAnimation::updateKeyframeAnimations):
        (WebCore::CompositeAnimation::animate):
        (WebCore::CompositeAnimation::getAnimatedStyle):
        (WebCore::CompositeAnimation::setAnimating):
        (WebCore::CompositeAnimation::timeToNextService):
        (WebCore::CompositeAnimation::getAnimationForProperty):
        (WebCore::CompositeAnimation::suspendAnimations):
        (WebCore::CompositeAnimation::resumeAnimations):
        (WebCore::CompositeAnimation::isAnimatingProperty):
        (WebCore::CompositeAnimation::pauseAnimationAtTime):
        (WebCore::CompositeAnimation::numberOfActiveAnimations):
        * platform/TreeShared.h:
        (WebCore::TreeShared::~TreeShared):
        (WebCore::TreeShared::deref):

2010-01-25  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Eric Seidel.

        autobuffer value not forwarded media element to MediaPlayer
        https://bugs.webkit.org/show_bug.cgi?id=33889

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::loadResource): Forward autobuffer
        value to MediaPlayer instance.
        * platform/graphics/MediaPlayer.cpp:
        (WebCore::MediaPlayer::load): Forward autobuffer and
        preservesPitch values to newly created platform media player instance.

2010-01-25  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Eric Seidel.

        [Gtk] media/video-reverse-play-duration.html fails on and off on Gtk buildbots
        https://bugs.webkit.org/show_bug.cgi?id=34086

        Cache media duration and fix didEnd() in case of reverse
        playback. When EOS was reached but in case of reverse playback the
        position is not always 0. So to not confuse the HTMLMediaElement
        we synchronize position and duration values.

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::duration):
        (WebCore::MediaPlayerPrivate::updateStates):
        (WebCore::MediaPlayerPrivate::didEnd):
        (WebCore::MediaPlayerPrivate::durationChanged):
        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.h:

2010-01-27  Alexey Proskuryakov  <ap@apple.com>

        * WebCore.xcodeproj/project.pbxproj: Actually land the change to add ContainerNodeAlgorithms.h
        (it's "svn resolved", not "svn revert"!).

2010-01-26  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=34150
        WebKit needs a mechanism to catch stale HashMap entries

        * WebCore.xcodeproj/project.pbxproj: Added ContainerNodeAlgorithms.h to the project to make
        it easier to search for.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSRuleSet::getIDRules):
        (WebCore::CSSRuleSet::getClassRules):
        (WebCore::CSSRuleSet::getTagRules):
        (WebCore::CSSStyleSelector::keyframeStylesForAnimation):
        * dom/CheckedRadioButtons.cpp:
        (WebCore::CheckedRadioButtons::checkedButtonForGroup):
        (WebCore::CheckedRadioButtons::removeButton):
        * dom/Document.cpp:
        (WebCore::Document::getElementById):
        (WebCore::Document::removeElementById):
        (WebCore::Document::removeImageMap):
        (WebCore::Document::getImageMap):
        (WebCore::Document::nameCollectionInfo):
        * dom/Document.h:
        (WebCore::Document::collectionInfo):
        * editing/markup.cpp:
        (WebCore::shouldAddNamespaceAttr):
        (WebCore::appendNamespace):
        (WebCore::appendStartMarkup):
        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::namedItems):
        (WebCore::HTMLCollection::nextNamedItem):
        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::formCollectionInfo):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::collectionInfo):
        * loader/loader.cpp:
        (WebCore::Loader::load):
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::nonCacheRequestInFlight):
        (WebCore::Loader::nonCacheRequestComplete):
        (WebCore::Loader::cancelRequests):
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimation::clearRenderer):
        (WebCore::CompositeAnimation::updateKeyframeAnimations):
        (WebCore::CompositeAnimation::animate):
        (WebCore::CompositeAnimation::getAnimatedStyle):
        (WebCore::CompositeAnimation::setAnimating):
        (WebCore::CompositeAnimation::timeToNextService):
        (WebCore::CompositeAnimation::getAnimationForProperty):
        (WebCore::CompositeAnimation::suspendAnimations):
        (WebCore::CompositeAnimation::resumeAnimations):
        (WebCore::CompositeAnimation::isAnimatingProperty):
        (WebCore::CompositeAnimation::pauseAnimationAtTime):
        (WebCore::CompositeAnimation::numberOfActiveAnimations):
        Added checkConsistency checks before lookups in HashMaps with AtomicStringImpl* keys.

        * dom/ContainerNodeAlgorithms.h: (WebCore::removeAllChildrenInContainer): Be sure to notify
        about removed child nodes that can be deleted immediately.

        * html/CollectionCache.cpp:
        (WebCore::CollectionCache::checkConsistency):
        * html/CollectionCache.h:
        Added a checkConsistency() method that checks both HashMaps in the cache.

        * platform/TreeShared.h:
        (WebCore::TreeShared::~TreeShared): Assert that m_refCount is null. Since Nodes can be
        destroyed with operator delete (as done in ContainerNodeAlgorithms), this is important to check.
        (WebCore::TreeShared::deref): Assert that m_refCount isn't already negative.

2010-01-26  Daniel Bates  <dbates@webkit.org>

        Reviewed by Tor Arne Vestbø.

        https://bugs.webkit.org/show_bug.cgi?id=29564

        [Qt] Fixes an issue where the height of <button>- and
        <input type="button">- elements are fixed to the height of the
        button label font plus padding. That is, the CSS height property
        is being ignored.

        Instead, we should honor the user-specified height, if appropriate
        for the platform and context. Notice, the Mac ports do not honor the
        height for <input type="button"> elements unless a border and/or
        background is also specified.

        Test: fast/css/button-height.html

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::adjustButtonStyle):

2010-01-26  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Timothy Hatcher.

        Enable the Audits panel via a shortcut (Cmd/Ctrl+Alt+A)
        https://bugs.webkit.org/show_bug.cgi?id=34158

        * inspector/front-end/inspector.js:
        (WebInspector.documentKeyDown):

2010-01-26  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        HTMLInputElement::valueAsNumber support except type=datetime-local.
        https://bugs.webkit.org/show_bug.cgi?id=32696

        Tests: fast/forms/input-valueasnumber-date.html
               fast/forms/input-valueasnumber-datetime.html
               fast/forms/input-valueasnumber-month.html
               fast/forms/input-valueasnumber-number.html
               fast/forms/input-valueasnumber-range.html
               fast/forms/input-valueasnumber-time.html
               fast/forms/input-valueasnumber-unsupported.html
               fast/forms/input-valueasnumber-week.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::valueAsNumber):
          According to the specification, we should return NaN for invalid values.
        (WebCore::HTMLInputElement::setValueAsNumber):
          According to the specification, throws NOT_SUPPORTED_ERR for Infinitiy or NaN,
          and throws INVALID_STATE_ERR for unsupported types.
        (WebCore::HTMLInputElement::formStringToDouble):
          According to the step 14 of Real Number in the specification, we
          should round -0 to 0.
        * html/HTMLInputElement.h: Declare valueAsNumber() and setValueAsNumber().
        * html/HTMLInputElement.idl: Add valueAsNumber.

2010-01-26  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Oliver Hunt.

        Make sure there is a lock on serialize in SerializedScriptValueData, since type errors can be created when
        exceptions are thrown.

        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValueData::serialize):

2010-01-26  Kent Tamura  <tkent@chromium.org>

        Reviewed by Eric Seidel.

        Add Date type support for Objective-C binding.
        https://bugs.webkit.org/show_bug.cgi?id=32810

        The Date type in IDLs is mapped to NSTimeInterval in Objective-C.

        * bindings/objc/DOMInternal.h: Add kit() and core() for NSTimeInterval.
        * bindings/scripts/CodeGenerator.pm: Make Date a primitive type.
        * bindings/scripts/CodeGeneratorJS.pm: Move some code for the CodeGeenrator.pm change.
        * bindings/scripts/CodeGeneratorObjC.pm:
        * bindings/scripts/CodeGeneratorV8.pm: Move some code for the CodeGeenrator.pm change.
        * html/HTMLInputElement.idl: Remove Objective-C exclusion for valueAsDate.

2010-01-26  Dmitry Titov  <dimich@chromium.org>

        Not reviewed, attempt to fix Tiger build.

        * rendering/RenderTreeAsText.cpp:
        (WebCore::write): Use UNUSED_PARAM macros to prevent compiler warning on targets without accelerated compositing.

2010-01-26  Roland Steiner  <rolandsteiner@chromium.org>

        Reviewed by Darin Adler.

        Incorrect boolean expression in isMailBlockquote() (WebCore/htmlediting.cpp)
        https://bugs.webkit.org/show_bug.cgi?id=34156

        No new tests (minor code change).

        * editing/htmlediting.cpp:
        (WebCore::isMailBlockquote):

2010-01-26  Peter Kasting  <pkasting@google.com>

        Reviewed by David Levin.

        Handle broken images more correctly in the open-source image decoders.
        https://bugs.webkit.org/show_bug.cgi?id=33747

        No tests since Safari doesn't use these decoders and there's already a
        broken-image test in the tree.

        * platform/graphics/ImageSource.cpp:
        (WebCore::ImageSource::createFrameAtIndex): No need to check isSizeAvailable() since size() is now always safe.
        * platform/image-decoders/ImageDecoder.h:
        (WebCore::ImageDecoder::size): Don't assert that the bitmap is valid; we don't need a complete successful decode to be able to give info about the size.
        * platform/image-decoders/qt/RGBA32BufferQt.cpp:
        (WebCore::RGBA32Buffer::setSize): Don't set the frame to complete on failure, since it's not complete, but empty, and callers can better handle empty frames.
        * platform/image-decoders/skia/ImageDecoderSkia.cpp:
        (WebCore::RGBA32Buffer::setSize): Don't set the frame to complete on failure, since it's not complete, but empty, and callers can better handle empty frames.

2010-01-26  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed. Synchronize Qt/Gtk build systems with Mac/Win, should fix Qt compilation. Gtk results still pending.

        * GNUmakefile.am:
        * WebCore.pro:

2010-01-26  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed. Attempt to fix V8 - change SetterMethod function signatures, just like it has been done for JSSVGPODTypeWrapper.

        * bindings/v8/V8SVGPODTypeWrapper.h:

2010-01-26  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed. Revert Base.xcconfig changes, was not meant to be committed.

        * Configurations/Base.xcconfig:

2010-01-26  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Oliver Hunt.

        SVG consumes way too much memory to store animated properties in the DOM
        https://bugs.webkit.org/show_bug.cgi?id=34188

        Shrink WebCore library size to 75% (measured in debug builds) and reduce SVG memory usage to <25%.
        Adding Oliver testcase as manual-tests/svg-node-count-vs-scroll.xhtml, which creates an arbitary number of
        rects (50.000 <rect> elements added to the DOM by default) - memory usage down to 111M from 503M (RPRVT).
        The SVG DOM side is almost fine, still some optimizations possible, that will be implemented soon - next
        target is the SVG render tree, there are plenty of possibilities to reduce memory usage there.

        Redesign the way we store animated properties in the individual SVG*Element files. Short story: In order
        to support SVG DOM through the bindings (e.g. JS) we need to associate SVGAnimatedProperty objects with
        the SVGElement object that created it - we used to store this pointer directly in the SVGAnimatedProperty.
        This means, every SVGAnimatedProperty stored in a SVGRectElement, stored a pointer to the SVGRectElement, resulting
        in excessive memory usage. This is now properly implemented, without wasting tons of memory. Unfortunately this
        requires touching all SVG*Element files.

        Detailed list of changes:
        - Remove template bloat by not specializing class templates for each attributeName/tagName combination. Instead
          SVGAnimatedProperty is a non-specialized template class now, only depending on the AnimatedType (ie. SVGLength for SVGAnimatedLength)
          -> This heavily reduces the generated code, thus shrinking WebCore size. I hope we can build windows again without SVGAllInOne.cpp

        - Remove "exportStrings" / "exportString" handling from make_names.pl - SVG defined string literals for each QualifiedName,
          in order to use template specialization based on "const char*" parameters. All that bloat is gone, so there's no need for it anymore.

        - Redesign SVGAnimatedProperty so it does not need any back-pointers to the SVGElement that created it

        - Don't actually store the XML DOM attribute name associated with a SVG DOM property in SVGAnimatedProperty, move the associatedAttributeName()
          function inside the macro declaration and just return the passed macro parameter DOMAttribute there, storing is inefficient and useless.

        - Remove SynchronizablePropertyController, which was living in SVGElement as member variable, keeping a HashMap<AttributeName, SVGAnimatedProperty>.
          It was needed before to lookup a SVGAnimatedProperty for a XML DOM attribute, in order to synchronize SVG <-> XML dom properties/attributes.
          Instead just add a "synchronizeProperty(const QualifiedName&)" method to all SVG*Element classes. As each SVG*Element class knows about its
          animated properties it can just ask them to synchronize themselves - no need for any dynamic lookups anymore.

        - Remove SynchronizableTypeWrapper which added more complexity for the sake of SVG <-> XML DOM synchronization, all replaced by synchronizeProperty.

        - Pass around any POD objects as const references, instead of copying them for no reason.

        - Clean up SVGAnimatedProperty, splitting up into SVGAnimatedProperty/PropertySynchronizer/PropertyTraits.

        - Remove baseValue/setBaseValue code from SVGDocumentExtensions, not needed anymore.

        ... and tons of changes to all SVG*Element classes, adapting to the new way of handling animated properties.

        * GNUmakefile.am: Remove Synchronizable* from build, add new SVGAnimatedPropertySynchronizer/Traits files
        * WebCore.gypi: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * bindings/js/JSSVGPODTypeWrapper.h: Change synchronization callback signatures, as we pass around const-references now.
        * dom/Element.cpp: Let updateAnimatedSVGAttribute take a QualifiedName instead of pure Strings.
        (WebCore::Element::getAttribute):
        (WebCore::Element::hasAttributes):
        * dom/Element.h:
        (WebCore::Element::updateAnimatedSVGAttribute):
        (WebCore::Element::attributes):
        * dom/make_names.pl: Remove SVG specific "exportString" / "exportStrings" functionality, see above.
        * html/HTMLAttributeNames.in: Remove "exportString" tag from "className" attribute.
        * manual-tests/svg-node-count-vs-scroll.xhtml: Added. Can be used to verify memory consumption with a lot of DOM objects.
        * mathml/mathattrs.in: MathML doesn't need "exportStrings" - remove it.
        * mathml/mathtags.in: Ditto.
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::SVGAElement):
        (WebCore::SVGAElement::synchronizeProperty):
        * svg/SVGAElement.h:
        * svg/SVGAllInOne.cpp: Remove SynchronizablePropertyController.cpp
        * svg/SVGAltGlyphElement.cpp:
        (WebCore::SVGAltGlyphElement::SVGAltGlyphElement):
        (WebCore::SVGAltGlyphElement::synchronizeProperty):
        * svg/SVGAltGlyphElement.h:
        * svg/SVGAnimateTransformElement.cpp:
        (WebCore::SVGAnimateTransformElement::applyResultsToTarget):
        * svg/SVGAnimatedProperty.h: Rewritten, see above for details.
        (WebCore::SVGAnimatedPropertyTearOff::create):
        (WebCore::SVGAnimatedPropertyTearOff::setBaseVal):
        (WebCore::SVGAnimatedPropertyTearOff::setAnimVal):
        (WebCore::SVGAnimatedPropertyTearOff::baseVal):
        (WebCore::SVGAnimatedPropertyTearOff::animVal):
        (WebCore::SVGAnimatedPropertyTearOff::associatedAttributeName):
        (WebCore::SVGAnimatedPropertyTearOff::SVGAnimatedPropertyTearOff):
        (WebCore::SVGAnimatedPropertyTearOff::~SVGAnimatedPropertyTearOff):
        (WebCore::SVGAnimatedProperty::~SVGAnimatedProperty):
        (WebCore::SVGAnimatedProperty::SVGAnimatedProperty):
        (WebCore::SVGAnimatedProperty::value):
        (WebCore::SVGAnimatedProperty::baseValue):
        (WebCore::SVGAnimatedProperty::setValue):
        (WebCore::SVGAnimatedProperty::setBaseValue):
        (WebCore::SVGAnimatedProperty::shouldSynchronize):
        (WebCore::SVGAnimatedProperty::setShouldSynchronize):
        * svg/SVGAnimatedPropertySynchronizer.h: Added.
        (WebCore::):
        * svg/SVGAnimatedPropertyTraits.h: Added.
        (WebCore::):
        * svg/SVGAnimatedTemplate.h: Move SVGAnimatedPropertyTraits into its own file.
        (WebCore::SVGAnimatedTemplate::forgetWrapper):
        (WebCore::lookupOrCreateWrapper):
        * svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::SVGAnimationElement):
        (WebCore::SVGAnimationElement::synchronizeProperty):
        * svg/SVGAnimationElement.h:
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::SVGCircleElement):
        (WebCore::SVGCircleElement::synchronizeProperty):
        * svg/SVGCircleElement.h:
        * svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::SVGClipPathElement):
        (WebCore::SVGClipPathElement::synchronizeProperty):
        * svg/SVGClipPathElement.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::SVGComponentTransferFunctionElement):
        (WebCore::SVGComponentTransferFunctionElement::parseMappedAttribute):
        (WebCore::SVGComponentTransferFunctionElement::synchronizeProperty):
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::SVGCursorElement):
        (WebCore::SVGCursorElement::synchronizeProperty):
        * svg/SVGCursorElement.h:
        * svg/SVGDefsElement.cpp:
        (WebCore::SVGDefsElement::SVGDefsElement):
        (WebCore::SVGDefsElement::synchronizeProperty):
        * svg/SVGDefsElement.h:
        * svg/SVGDocumentExtensions.h:
        * svg/SVGElement.cpp: Adapt to synchronization changes: use synchronizeProperty() call, instead of SynchronizablePropertyController.
        (WebCore::SVGElement::updateAnimatedSVGAttribute):
        * svg/SVGElement.h: Don't store SynchronizablePropertyController anymore, it's gone.
        (WebCore::SVGElement::synchronizeProperty):
        (WebCore::SVGElement::setSynchronizedSVGAttributes):
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::SVGEllipseElement):
        (WebCore::SVGEllipseElement::synchronizeProperty):
        * svg/SVGEllipseElement.h:
        * svg/SVGExternalResourcesRequired.cpp:
        * svg/SVGExternalResourcesRequired.h:
        * svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::SVGFEBlendElement):
        (WebCore::SVGFEBlendElement::synchronizeProperty):
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::SVGFEColorMatrixElement):
        (WebCore::SVGFEColorMatrixElement::synchronizeProperty):
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::SVGFEComponentTransferElement):
        (WebCore::SVGFEComponentTransferElement::synchronizeProperty):
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        (WebCore::SVGFECompositeElement::parseMappedAttribute):
        (WebCore::SVGFECompositeElement::synchronizeProperty):
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::SVGFEDiffuseLightingElement):
        (WebCore::SVGFEDiffuseLightingElement::synchronizeProperty):
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        (WebCore::SVGFEDisplacementMapElement::synchronizeProperty):
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::SVGFEGaussianBlurElement):
        (WebCore::SVGFEGaussianBlurElement::synchronizeProperty):
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::SVGFEImageElement):
        (WebCore::SVGFEImageElement::synchronizeProperty):
        * svg/SVGFEImageElement.h:
        * svg/SVGFELightElement.cpp:
        (WebCore::SVGFELightElement::SVGFELightElement):
        (WebCore::SVGFELightElement::synchronizeProperty):
        * svg/SVGFELightElement.h:
        * svg/SVGFEMergeNodeElement.cpp:
        (WebCore::SVGFEMergeNodeElement::SVGFEMergeNodeElement):
        (WebCore::SVGFEMergeNodeElement::synchronizeProperty):
        * svg/SVGFEMergeNodeElement.h:
        * svg/SVGFEMorphologyElement.cpp:
        (WebCore::SVGFEMorphologyElement::SVGFEMorphologyElement):
        (WebCore::SVGFEMorphologyElement::synchronizeProperty):
        * svg/SVGFEMorphologyElement.h:
        * svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::SVGFEOffsetElement):
        (WebCore::SVGFEOffsetElement::synchronizeProperty):
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::SVGFESpecularLightingElement):
        (WebCore::SVGFESpecularLightingElement::synchronizeProperty):
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        (WebCore::SVGFETileElement::SVGFETileElement):
        (WebCore::SVGFETileElement::synchronizeProperty):
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        (WebCore::SVGFETurbulenceElement::synchronizeProperty):
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::SVGFilterElement):
        (WebCore::SVGFilterElement::synchronizeProperty):
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        (WebCore::SVGFilterPrimitiveStandardAttributes::synchronizeProperty):
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGFitToViewBox.cpp:
        * svg/SVGFitToViewBox.h:
        * svg/SVGFontElement.cpp:
        (WebCore::SVGFontElement::SVGFontElement):
        (WebCore::SVGFontElement::synchronizeProperty):
        * svg/SVGFontElement.h:
        * svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        (WebCore::SVGForeignObjectElement::synchronizeProperty):
        * svg/SVGForeignObjectElement.h:
        * svg/SVGGElement.cpp:
        (WebCore::SVGGElement::SVGGElement):
        (WebCore::SVGGElement::synchronizeProperty):
        * svg/SVGGElement.h:
        * svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::SVGGradientElement):
        (WebCore::SVGGradientElement::synchronizeProperty):
        * svg/SVGGradientElement.h:
        * svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::SVGImageElement):
        (WebCore::SVGImageElement::synchronizeProperty):
        * svg/SVGImageElement.h:
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::SVGLineElement):
        (WebCore::SVGLineElement::synchronizeProperty):
        * svg/SVGLineElement.h:
        * svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::SVGLinearGradientElement):
        (WebCore::SVGLinearGradientElement::synchronizeProperty):
        * svg/SVGLinearGradientElement.h:
        * svg/SVGList.h: Adapt to const-reference changes.
        (WebCore::SVGPODListItem::setValue):
        * svg/SVGMPathElement.cpp:
        (WebCore::SVGMPathElement::SVGMPathElement):
        (WebCore::SVGMPathElement::synchronizeProperty):
        * svg/SVGMPathElement.h:
        * svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        (WebCore::SVGMarkerElement::synchronizeProperty):
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        (WebCore::SVGMaskElement::synchronizeProperty):
        * svg/SVGMaskElement.h:
        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        (WebCore::SVGPathElement::synchronizeProperty):
        * svg/SVGPathElement.h:
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::SVGPatternElement):
        (WebCore::SVGPatternElement::synchronizeProperty):
        * svg/SVGPatternElement.h:
        * svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::SVGPolyElement):
        (WebCore::SVGPolyElement::svgAttributeChanged):
        (WebCore::SVGPolyElement::synchronizeProperty):
        * svg/SVGPolyElement.h:
        * svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::SVGRadialGradientElement):
        (WebCore::SVGRadialGradientElement::synchronizeProperty):
        * svg/SVGRadialGradientElement.h:
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::SVGRectElement):
        (WebCore::SVGRectElement::synchronizeProperty):
        * svg/SVGRectElement.h:
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        (WebCore::SVGSVGElement::synchronizeProperty):
        * svg/SVGSVGElement.h:
        * svg/SVGScriptElement.cpp:
        (WebCore::SVGScriptElement::SVGScriptElement):
        (WebCore::SVGScriptElement::synchronizeProperty):
        * svg/SVGScriptElement.h:
        * svg/SVGStopElement.cpp:
        (WebCore::SVGStopElement::SVGStopElement):
        (WebCore::SVGStopElement::synchronizeProperty):
        * svg/SVGStopElement.h:
        * svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::SVGStyledElement):
        (WebCore::SVGStyledElement::parseMappedAttribute):
        (WebCore::SVGStyledElement::synchronizeProperty):
        * svg/SVGStyledElement.h:
        * svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::SVGStyledTransformableElement):
        (WebCore::SVGStyledTransformableElement::synchronizeProperty):
        * svg/SVGStyledTransformableElement.h:
        * svg/SVGSwitchElement.cpp:
        (WebCore::SVGSwitchElement::SVGSwitchElement):
        (WebCore::SVGSwitchElement::synchronizeProperty):
        * svg/SVGSwitchElement.h:
        * svg/SVGSymbolElement.cpp:
        (WebCore::SVGSymbolElement::SVGSymbolElement):
        (WebCore::SVGSymbolElement::synchronizeProperty):
        * svg/SVGSymbolElement.h:
        * svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::SVGTRefElement):
        (WebCore::SVGTRefElement::synchronizeProperty):
        * svg/SVGTRefElement.h:
        * svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        (WebCore::SVGTextContentElement::synchronizeProperty):
        * svg/SVGTextContentElement.h:
        * svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::SVGTextElement):
        (WebCore::SVGTextElement::synchronizeProperty):
        * svg/SVGTextElement.h:
        * svg/SVGTextPathElement.cpp:
        (WebCore::SVGTextPathElement::SVGTextPathElement):
        (WebCore::SVGTextPathElement::synchronizeProperty):
        * svg/SVGTextPathElement.h:
        * svg/SVGTextPositioningElement.cpp:
        (WebCore::SVGTextPositioningElement::SVGTextPositioningElement):
        (WebCore::SVGTextPositioningElement::synchronizeProperty):
        * svg/SVGTextPositioningElement.h:
        * svg/SVGURIReference.cpp:
        * svg/SVGURIReference.h:
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::SVGUseElement):
        (WebCore::SVGUseElement::synchronizeProperty):
        * svg/SVGUseElement.h:
        * svg/SVGViewElement.cpp:
        (WebCore::SVGViewElement::SVGViewElement):
        (WebCore::SVGViewElement::synchronizeProperty):
        * svg/SVGViewElement.h:
        * svg/SVGViewSpec.cpp:
        (WebCore::SVGViewSpec::SVGViewSpec):
        * svg/SVGViewSpec.h:
        (WebCore::SVGViewSpec::contextElement):
        * svg/SynchronizablePropertyController.cpp: Removed.
        * svg/SynchronizablePropertyController.h: Removed.
        * svg/SynchronizableTypeWrapper.h: Removed.
        * svg/svgattrs.in: Remove "exportStrings" tag.
        * svg/svgtags.in: Ditto.
        * svg/xlinkattrs.in:

2010-01-26  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Fix for <rdar://problem/7169464> REGRESSION (r47444): PLT is 1% slower due to implementation of :valid and :invalid CSS selectors
        https://bugs.webkit.org/show_bug.cgi?id=34029

        If we never hit the valid or invalid selectors for a particular document, 
        then we'll skip the validity checks when deciding about style sharing.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::canShareStyleWithElement):
        (WebCore::CSSStyleSelector::SelectorChecker::checkOneSelector):
        
        * dom/Document.cpp: (WebCore::Document::Document):
        * dom/Document.h:
        (WebCore::Document::considerValidity):
        (WebCore::Document::setConsiderValidity):

2010-01-26  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Simon Fraser.

        Revert 53797 as it seems to be causing crashes.
        https://bugs.webkit.org/show_bug.cgi?id=34153

        * page/FrameView.cpp:
        (WebCore::FrameView::useSlowRepaints):
        (WebCore::FrameView::useSlowRepaintsIfNotOverlapped):
        * page/FrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::scrollContents):
        * platform/ScrollView.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):
        (WebCore::RenderObject::destroy):

2010-01-26  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Steve Falkenburg.

        DumpRenderTree silently crashes at the end of the run because geolocationControllerClient pointer is 0.
        https://bugs.webkit.org/show_bug.cgi?id=34191

        * page/GeolocationController.cpp:
        (WebCore::GeolocationController::~GeolocationController): Add check for m_client being 0.
        (WebCore::GeolocationController::addObserver): Ditto.
        (WebCore::GeolocationController::removeObserver): Ditto.
        (WebCore::GeolocationController::lastPosition): Ditto.

2010-01-26  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Adele Peterson.

        Enhance externalRepresentation() to make it more useful for layer debugging
        https://bugs.webkit.org/show_bug.cgi?id=34143

        Enhance externalRepresentation() to output additional information about layers when certain flags are passed.
        The new flags allow you to show all layers (not just those that would paint), to the structure of the z-order
        and normal flow lists, and to show which layers are composited.

        * WebCore.base.exp: The signature of externalRepresentation() changed.

        * platform/text/TextStream.h: Add operator<<(void*)
        * platform/text/TextStream.cpp: Implement operator<<(void*)

        * rendering/RenderLayer.h:
        * rendering/RenderLayer.cpp:
        (showLayerTree): New method outside the WebCore namespace, for ease of calling from gdb.

        * rendering/RenderTreeAsText.h: New behavior flags for externalRepresentation().
        * rendering/RenderTreeAsText.cpp:
        (WebCore::write): Output compositing information if requested. Also clean up some -1/1 magic
        numbers with an enum.
        (WebCore::writeLayers): If requested, show layer nesting via the z-order and normal flow lists.
        (WebCore::externalRepresentation): New arguments

2010-01-26  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        Fixed an off-by-one error.

        * rendering/break_lines.cpp:
        (WebCore::shouldBreakAfter):

2010-01-26  Dmitry Titov  <dimich@chromium.org>

        Reviewed by David Levin.

        Avoid reloading iframe on re-parenting between documents.
        https://bugs.webkit.org/show_bug.cgi?id=32848

        Achieved by setting a flag on iframe element when it is a target of document.adoptNode(node) operation.
        The flag prevents unload/load cycle and is reset once element is attached to a new document.
        If iframe is adopted but not actually inserted into the tree, it gets unloaded by async timer
        once JS yields, to avoid having active content in non-attached iframe.

        Test: fast/frames/iframe-reparenting.html

        * dom/Document.cpp:
        (WebCore::Document::adoptNode): If the adopted node is iframe, set a remainsAliveOnRemovalFromTree on it.
        * html/HTMLFrameElementBase.h:
        * html/HTMLFrameElementBase.cpp:
        (WebCore::HTMLFrameElementBase::HTMLFrameElementBase):
        (WebCore::HTMLFrameElementBase::attach): Skip actual loading of the frame if it has remainsAliveOnRemovalFromTree flag. Reset the flag.
        (WebCore::HTMLFrameElementBase::willRemove): Skip unloading the frame if it has remainsAliveOnRemovalFromTree flag set.
        (WebCore::HTMLFrameElementBase::setRemainsAliveOnRemovalFromTree): Set the flag, start the async timer to check if the frame was actually attached.
        (WebCore::HTMLFrameElementBase::checkAttachedTimerFired):
        * html/HTMLFrameOwnerElement.h:
        (WebCore::HTMLFrameOwnerElement::willRemove): Move from private to protected, since it is conditionally called in HTMLFrameElementBase::willRemove now.

2010-01-26  Adam Roben  <aroben@apple.com>

        No review, rolling out r53861.
        http://trac.webkit.org/changeset/53861
        https://bugs.webkit.org/show_bug.cgi?id=33224

        Caused 2 regression tests to fail.

        * dom/Document.cpp:
        (WebCore::Document::detach):
        (WebCore::Document::registerHistoryItem):
        (WebCore::Document::unregisterHistoryItem):
        * dom/Document.h:
        * history/BackForwardList.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/BackForwardListChromium.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/HistoryItem.cpp:
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::~HistoryItem):
        (WebCore::HistoryItem::setStateObject):
        (WebCore::HistoryItem::setDocument):
        (WebCore::HistoryItem::documentDetached):
        * history/HistoryItem.h:
        (WebCore::HistoryItem::document):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::navigateWithinDocument):
        (WebCore::FrameLoader::loadItem):
        * loader/HistoryController.cpp:
        (WebCore::HistoryController::updateBackForwardListForFragmentScroll):
        (WebCore::HistoryController::pushState):
        (WebCore::HistoryController::replaceState):
        * loader/RedirectScheduler.cpp:
        (WebCore::RedirectScheduler::scheduleHistoryNavigation):
        * page/History.cpp:
        (WebCore::History::stateObjectAdded):
        * page/Page.cpp:
        (WebCore::Page::goToItem):

2010-01-26  Dan Bernstein  <mitz@apple.com>

        Reviewed by Beth Dakin.

        <rdar://problem/7576663> Crash caused by anonymous list item
        https://bugs.webkit.org/show_bug.cgi?id=34183

        Test: fast/lists/anonymous-items.html

        enclosingList() and previousListItem() were DOM-based, but in order to work with anonymous
        list items, they need to work with rthe render tree.

        * rendering/RenderListItem.cpp:
        (WebCore::isList): Factored out.
        (WebCore::enclosingList): Added this variant that takes a RenderObject.
        (WebCore::previousListItem): Changed to travers the render tree.
        (WebCore::RenderListItem::calcValue): Use the RenderObject version of enclosingList()
        (WebCore::RenderListItem::setExplicitValue): Added an assertion.
        (WebCore::RenderListItem::clearExplicitValue): Ditto.

2010-01-26  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Jon Honeycutt.

        Crash in WebKit!WebCore::RenderMenuList::itemStyle
        https://bugs.webkit.org/show_bug.cgi?id=34182
        <rdar://7087757>
        
        Added bounds checks in RenderMenuList to make sure we are
        not making an out of bounds check in a vector once an option
        element has been deleted. If we are out of bounds, we fall back to
        a default value and return early, and in the case of itemStyle, we use a 
        previous option's style, if it is available.

        * manual-tests/select-delete-item.html: Added.
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::itemText): If out of bounds check, return early.
        (WebCore::RenderMenuList::itemToolTip): Ditto.
        (WebCore::RenderMenuList::itemIsEnabled): Ditto.
        (WebCore::RenderMenuList::itemStyle): If out of bounds check, try using the 0th index
            option style, then fall back to the select's style if that option doesn't exist.
        (WebCore::RenderMenuList::itemBackgroundColor): If out of bounds check, return early.
        (WebCore::RenderMenuList::itemIsSeparator): Ditto.
        (WebCore::RenderMenuList::itemIsLabel): Ditto.
        (WebCore::RenderMenuList::itemIsSelected): Ditto.

2010-01-25  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Anders Carlsson.

        Some methods in JSC JNI bridge need more error checking of results from JNI.
        https://bugs.webkit.org/show_bug.cgi?id=34149

        In JNIUtility.h, callJNIMethodV<jobject> might return null (from CallObjectMethodV, via
        JNICaller<jobject>::callV) if an exception is thrown.  All clients of callJNIMethodV<jobject>
        that are calling methods on the returned object should null check first.

        * bridge/jni/JNIBridge.cpp:
        (JavaField::JavaField):
        (JavaMethod::JavaMethod):
        * bridge/jni/JNIUtility.h:
        (JSC::Bindings::):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::convertJObjectToValue):
        * bridge/jni/jsc/JavaClassJSC.cpp:
        (JavaClass::JavaClass):
        * bridge/jni/jsc/JavaInstanceJSC.cpp:
        (JavaInstance::stringValue):

2010-01-26  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Oliver Hunt.

        Windows build references non-existent include paths
        https://bugs.webkit.org/show_bug.cgi?id=34175

        * WebCore.vcproj/QTMovieWin.vcproj:
        * WebCore.vcproj/WebCoreCommon.vsprops:

2010-01-26  Darin Fisher  <darin@chromium.org>

        Reviewed by Brady Eidson.

        Chains of history items representing same-document navigation need to
        always remember that association

        https://bugs.webkit.org/show_bug.cgi?id=33224

        Replace HistoryItem's Document pointer with a DocumentSequenceNumber.
        During session history traversal, if the current HistoryItem and the
        target HistoryItem have the same DocumentSequenceNumber, then it means
        that the current Document should remain.

        NOTE: To support Chromium's serialization of HistoryItems, I generate
        DocumentSequenceNumbers that are unique across application launches.
        DocumentSequenceNumbers are generated using a counter initialized with
        the time of day.

        Test: fast/loader/stateobjects/document-destroyed-navigate-back.html

        * dom/Document.cpp:
        (WebCore::Document::detach):
        * dom/Document.h:
        * history/BackForwardList.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/BackForwardListChromium.cpp:
        (WebCore::BackForwardList::pushStateItem):
        * history/HistoryItem.cpp:
        (WebCore::generateDocumentSequenceNumber):
        (WebCore::HistoryItem::HistoryItem):
        (WebCore::HistoryItem::~HistoryItem):
        (WebCore::HistoryItem::setStateObject):
        * history/HistoryItem.h:
        (WebCore::HistoryItem::setDocumentSequenceNumber):
        (WebCore::HistoryItem::documentSequenceNumber):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::navigateWithinDocument):
        (WebCore::FrameLoader::loadItem):
        * loader/HistoryController.cpp:
        (WebCore::HistoryController::updateBackForwardListForFragmentScroll):
        (WebCore::HistoryController::pushState):
        (WebCore::HistoryController::replaceState):
        * loader/RedirectScheduler.cpp:
        (WebCore::RedirectScheduler::scheduleHistoryNavigation):
        * page/History.cpp:
        (WebCore::History::stateObjectAdded):
        * page/Page.cpp:
        (WebCore::Page::goToItem):

2010-01-26  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        Add ability for image maps to be focused via tabbing
        https://bugs.webkit.org/show_bug.cgi?id=17513

        Test: fast/events/tab-imagemap.html

        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::focusedImageMapUIElement):
        (WebCore::AXObjectCache::focusedUIElementForPage):
        * accessibility/AXObjectCache.h:
        * accessibility/AccessibilityImageMapLink.h:
        (WebCore::AccessibilityImageMapLink::areaElement):
        (WebCore::AccessibilityImageMapLink::mapElement):
        (WebCore::AccessibilityImageMapLink::isImageMapLink):
        * accessibility/AccessibilityObject.h:
        (WebCore::AccessibilityObject::isImageMapLink):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::accessibilityParentForImageMap):
        * html/HTMLAreaElement.cpp:
        (WebCore::HTMLAreaElement::getPath):
        (WebCore::HTMLAreaElement::getRect):
        (WebCore::HTMLAreaElement::imageElement):
        (WebCore::HTMLAreaElement::isKeyboardFocusable):
        (WebCore::HTMLAreaElement::isFocusable):
        (WebCore::HTMLAreaElement::dispatchBlurEvent):
        (WebCore::HTMLAreaElement::updateFocusAppearance):
        (WebCore::HTMLAreaElement::supportsFocus):
        * html/HTMLAreaElement.h:
        * html/HTMLMapElement.cpp:
        (WebCore::HTMLMapElement::imageElement):
        * html/HTMLMapElement.h:
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/haiku/GraphicsContextHaiku.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/mac/GraphicsContextMac.mm:
        (WebCore::drawFocusRingToContext):
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/win/GraphicsContextCGWin.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/wince/GraphicsContextWince.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * platform/graphics/wx/GraphicsContextWx.cpp:
        (WebCore::GraphicsContext::drawFocusRing):
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::paint):
        (WebCore::RenderImage::paintFocusRings):
        (WebCore::RenderImage::imageMap):
        * rendering/RenderImage.h:
        * rendering/RenderReplaced.h:

2010-01-26  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: add support for breakpoints, messages and search into the SourceFrame2.

        https://bugs.webkit.org/show_bug.cgi?id=34165

        * inspector/front-end/SourceFrame2.js:
        (WebInspector.SourceFrame2):
        (WebInspector.SourceFrame2.prototype.get executionLine):
        (WebInspector.SourceFrame2.prototype.set executionLine):
        (WebInspector.SourceFrame2.prototype.revealLine):
        (WebInspector.SourceFrame2.prototype.addBreakpoint):
        (WebInspector.SourceFrame2.prototype.removeBreakpoint):
        (WebInspector.SourceFrame2.prototype.sizeToFitContentHeight):
        (WebInspector.SourceFrame2.prototype.setContent):
        (WebInspector.SourceFrame2.prototype.findSearchMatches):
        (WebInspector.SourceFrame2.prototype.setSelection):
        (WebInspector.SourceFrame2.prototype._addMessageToSource):
        (WebInspector.SourceFrame2.prototype._addExistingBreakpointsToSource):
        (WebInspector.SourceFrame2.prototype._addBreakpointToSource):
        (WebInspector.SourceFrame2.prototype._removeBreakpointFromSource):
        (WebInspector.SourceFrame2.prototype._contextMenu.addConditionalBreakpoint):
        (WebInspector.SourceFrame2.prototype._contextMenu):
        (WebInspector.SourceFrame2.prototype._toggleBreakpoint):
        (WebInspector.SourceFrame2.prototype._editBreakpointCondition.committed):
        (WebInspector.SourceFrame2.prototype._editBreakpointCondition.dismissed):
        (WebInspector.SourceFrame2.prototype._editBreakpointCondition):
        (WebInspector.SourceFrame2.prototype._showBreakpointConditionPopup):
        (WebInspector.SourceFrame2.prototype._createConditionElement):
        (WebInspector.SourceFrame2.prototype._keyDown):
        (WebInspector.SourceFrame2.prototype._evalSelectionInCallFrame):
        (WebInspector.SourceFrame2.prototype._breakpointChanged):
        (WebInspector.SourceFrame2.prototype.resize):
        (WebInspector.BreakpointLineNumberDecorator.prototype.decorate):
        (WebInspector.BreakpointLineNumberDecorator.prototype._paintBreakpoint):
        (WebInspector.BreakpointLineNumberDecorator.prototype.mouseDown):
        (WebInspector.BreakpointLineNumberDecorator.prototype.contextMenu):
        (WebInspector.ExecutionLineDecorator.prototype.decorate):
        * inspector/front-end/TextEditor.js:
        (WebInspector.TextEditor):
        (WebInspector.TextEditor.prototype.set mimeType):
        (WebInspector.TextEditor.prototype.set readOnly):
        (WebInspector.TextEditor.prototype.setDivDecoration):
        (WebInspector.TextEditor.prototype.reveal):
        (WebInspector.TextEditor.prototype.packAndRepaintAll):
        (WebInspector.TextEditor.prototype._updateSize):
        (WebInspector.TextEditor.prototype.updateCanvasSize):
        (WebInspector.TextEditor.prototype.repaintAll):
        (WebInspector.TextEditor.prototype._paintLinesContinuation):
        (WebInspector.TextEditor.prototype._repaintOnScroll):
        (WebInspector.TextEditor.prototype._mouseDown):
        (WebInspector.TextEditor.prototype._contextMenu):
        (WebInspector.TextEditor.prototype._caretForMouseEvent):
        (WebInspector.TextEditor.prototype._columnForOffset):
        (WebInspector.TextEditor.prototype._handleNavigationKey):
        (WebInspector.TextEditor.prototype._positionDivDecoration):
        (WebInspector.TextEditor.prototype._replaceSelectionWith):
        (WebInspector.TextEditor.prototype.setCoalescingUpdate):
        (WebInspector.TextEditor.prototype._handleUndo):
        (WebInspector.TextEditor.prototype._handleRedo):
        (WebInspector.TextEditor.prototype._changeFont):
        * inspector/front-end/TextEditorHighlighter.js:
        (WebInspector.TextEditorHighlighter):
        (WebInspector.TextEditorHighlighter.prototype.set mimeType):
        * inspector/front-end/inspector.css:
        * inspector/front-end/textEditor.css:

2010-01-26  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: add methods for getting resource content from within frontend.

        https://bugs.webkit.org/show_bug.cgi?id=34163

        * inspector/InspectorBackend.cpp:
        (WebCore::InspectorBackend::getResourceContent):
        * inspector/InspectorBackend.h:
        * inspector/InspectorBackend.idl:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::didGetResourceContent):
        * inspector/InspectorFrontend.h:
        * inspector/InspectorFrontendHost.cpp:
        * inspector/InspectorFrontendHost.h:
        * inspector/InspectorFrontendHost.idl:
        * inspector/front-end/InspectorBackendStub.js:
        (.WebInspector.InspectorBackendStub.prototype.getResourceContent):
        * inspector/front-end/InspectorFrontendHostStub.js:

2010-01-26  Pavel Feldman  <pfeldman@chromium.org>

        Not reviewed: added null check into the timeline agent getter.

        * inspector/InspectorTimelineAgent.h:
        (WebCore::InspectorTimelineAgent::retrieve):

2010-01-26  Steve Block  <steveblock@google.com>

        Reviewed by Adam Barth.

        Moves JSC-specific classes from bridge/jni/JNIBridge to bridge/jni/jsc/JNIBridgeJSC
        https://bugs.webkit.org/show_bug.cgi?id=33958

        This allows bridge/jni/JNIBridge to be used with both JSC and V8.
        A later change will add the V8 equivalent of these JSC-specific classes.

        No new tests, refactoring only.

        * Android.jscbindings.mk: Modified. Added JNIBridgeJSC.cpp
        * GNUmakefile.am: Modified. Added JNIBridgeJSC.h
        * WebCore.xcodeproj/project.pbxproj: Modified. Added JNIBridgeJSC.[cpp|h]
        * bridge/jni/JNIBridge.cpp: Modified. Moved JavaField and JavaArray to JNIBridgeJSC.cpp
        (appendClassName): Modfied. Guard calls to JSLock
        (JavaMethod::signature): Modfied. Guard calls to JSLock
        * bridge/jni/JNIBridge.h: Modified. Moved JavaField and JavaArray to JNIBridgeJSC.h
        * bridge/jni/jsc/JNIBridgeJSC.cpp: Copied from WebCore/bridge/jni/JNIBridge.cpp.
        * bridge/jni/jsc/JNIBridgeJSC.h: Copied from WebCore/bridge/jni/JNIBridge.h.
        * bridge/jni/jsc/JNIUtilityPrivate.cpp: Modified. Include JNIBridgeJSC.h
        * bridge/jni/jsc/JavaClassJSC.h: Modified. Include JNIBridgeJSC.h
        * bridge/jni/jsc/JavaInstanceJSC.cpp: Modified. Include JNIBridgeJSC.h

2010-01-26  Jocelyn Turcotte  <jocelyn.turcotte@nokia.com>

        Unreviewed build fix.

        [Qt] Fix Windows build when sqlite is not available.

        * WebCore.pri:
        * WebCore.pro:

2010-01-26  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        [Qt] JavaScript prompt is currently broken.
        https://bugs.webkit.org/show_bug.cgi?id=30914

        Remove the manual test case in favor of an automated
        test case in WebKit/qt/tests/qwebpage.

        * manual-tests/qt/java-script-prompt.html: Removed.

2010-01-26  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Implement HTML and CSS highlighters.

        https://bugs.webkit.org/show_bug.cgi?id=34144

        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/front-end/JavaScriptTokenizer.js: Removed.
        * inspector/front-end/JavaScriptTokenizer.re2js: Removed.
        * inspector/front-end/SourceCSSTokenizer.js: Added.
        (WebInspector.SourceCSSTokenizer):
        (WebInspector.SourceCSSTokenizer.prototype._stringToken):
        (WebInspector.SourceCSSTokenizer.prototype._isPropertyValue):
        (WebInspector.SourceCSSTokenizer.prototype.nextToken):
        * inspector/front-end/SourceCSSTokenizer.re2js: Added.
        * inspector/front-end/SourceHTMLTokenizer.js: Added.
        (WebInspector.SourceHTMLTokenizer):
        (WebInspector.SourceHTMLTokenizer.prototype._stringToken):
        (WebInspector.SourceHTMLTokenizer.prototype.nextToken):
        * inspector/front-end/SourceHTMLTokenizer.re2js: Added.
        * inspector/front-end/SourceJavaScriptTokenizer.js: Added.
        (WebInspector.SourceJavaScriptTokenizer):
        (WebInspector.SourceJavaScriptTokenizer.prototype.nextToken):
        * inspector/front-end/SourceJavaScriptTokenizer.re2js: Added.
        * inspector/front-end/TextEditorHighlighter.js:
        (WebInspector.TextEditorHighlighter):
        (WebInspector.TextEditorHighlighter.prototype._highlightLines):
        (WebInspector.TextEditorHighlighter.Tokenizer):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.set line):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.set condition):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.get condition):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.hasCondition):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.getLexCondition):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype.setLexCondition):
        (WebInspector.TextEditorHighlighter.Tokenizer.prototype._charAt):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.html:

2010-01-26  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Holger Freyther.

        REGRESSION(r53835): Fix editing/pasteboard/paste-noscript-xhtml.xhtml
        https://bugs.webkit.org/show_bug.cgi?id=34157

        Pass the FragmentScriptingPermission correctly through to the DOM
        and disallow scripting elements in parseEndElement(), similar to
        the libxml tokenizer change in r53835.

        * dom/XMLTokenizerQt.cpp:
        (WebCore::handleElementNamespaces):
        (WebCore::handleElementAttributes):
        (WebCore::XMLTokenizer::parseStartElement):
        (WebCore::XMLTokenizer::parseEndElement):

2010-01-26  Garret Kelly  <gdk@chromium.org>

        Reviewed by Eric Seidel.

        Add missing declaration for the feMorphology SVG element.
        https://bugs.webkit.org/show_bug.cgi?id=34151

        * bindings/v8/V8DOMWrapper.cpp:

2010-01-26  Andras Becsi  <abecsi@inf.u-szeged.hu>

        Unreviewed build fix.

        [Qt] Build fix after API changes in r53835.

        No new tests needed.

        * dom/XMLTokenizerQt.cpp:
        (WebCore::XMLTokenizer::XMLTokenizer):
        (WebCore::parseXMLDocumentFragment):

2010-01-22  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Darin Adler.

        Make storage events match the spec.
        https://bugs.webkit.org/show_bug.cgi?id=30546

        This meat of the patch I just posted is very simple.  It's just making events
        asynchronous, not posting them to the frame that generated them, passing a null
        for the key when issuing a clear storage event, and making the events
        non-cancelable/non-bubbleable...all of which are clearly stated in the spec.

        The asynchronous and not posting to the frame that generated them forced me to
        re-write all the layout tests that dealt with storage events.  There's a lot of
        code there, but I tried to be fairly careful to ensure that test coverage did
        not shrink in any area.

        Tests: storage/domstorage/events/basic-body-attribute.html
               storage/domstorage/events/basic-setattribute.html
               storage/domstorage/events/basic.html
               storage/domstorage/events/case-sensitive.html
               storage/domstorage/events/documentURI.html

        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::enqueueStorageEvent):
        (WebCore::Document::storageEventTimerFired):
        * dom/Document.h:
        * storage/StorageEvent.cpp:
        (WebCore::StorageEvent::StorageEvent):
        * storage/StorageEvent.idl:
        * storage/StorageEventDispatcher.cpp:
        (WebCore::StorageEventDispatcher::dispatch):

2010-01-25  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7573493> Error with line break inside ?&raquo; pair of characters.
        https://bugs.webkit.org/show_bug.cgi?id=17475

        Test: fast/text/line-break-after-question-mark.html

        Instead of unconditionally allowing lines to break after a question mark, which was intended
        to mimic Internet Explorer, apply the Unicode line breaking behavior after a question mark,
        with one exception in the ASCII range to match IE, namely not allowing a line break between
        a question mark and a vertical line.

        * rendering/break_lines.cpp:
        (WebCore::shouldBreakAfter): Added a next character parameter. Changed to consult a table
        for the question mark case in order to keep it fast and not require a text break iterator in
        the ASCII case.
        (WebCore::nextBreakablePosition): Pass the next character to shouldBreakAfter.

2010-01-25  Peter Kasting  <pkasting@google.com>

        Reviewed by Dan Bernstein.

        Mac scrollbar thumbs were drawn with the wrong size.
        https://bugs.webkit.org/show_bug.cgi?id=34049

        * platform/chromium/ScrollbarThemeChromiumMac.mm:
        (WebCore::ScrollbarThemeChromiumMac::paint):
        * platform/mac/ScrollbarThemeMac.mm:
        (WebCore::ScrollbarThemeMac::paint):

2010-01-25  Enrica Casucci  <enrica@apple.com>

        Reviewed by Darin Adler.

        Cleanup unwanted tags after pasting.
        https://bugs.webkit.org/show_bug.cgi?id=34148
        
        Test: editing/pasteboard/paste-noscript-xhtml.xhtml

        * dom/Element.cpp:
        (WebCore::Element::setAttributeNS):
        * dom/Element.h:
        * dom/XMLTokenizer.h:
        * dom/XMLTokenizerLibxml2.cpp:
        (WebCore::XMLTokenizer::XMLTokenizer):
        (WebCore::handleElementNamespaces):
        (WebCore::handleElementAttributes):
        (WebCore::XMLTokenizer::startElementNs):
        (WebCore::XMLTokenizer::endElementNs):
        (WebCore::parseXMLDocumentFragment):
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::createContextualFragment):

2010-01-25  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Simon Fraser.

        A WebGeolocationControllerClient is leaked for every WebView
        https://bugs.webkit.org/show_bug.cgi?id=34145

        * page/GeolocationController.cpp:
        (WebCore::GeolocationController::~GeolocationController):
        * page/GeolocationControllerClient.h:

2010-01-25  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser.

        Fixed bug in positioning of scroll layer within the
        parent root layer.
        https://bugs.webkit.org/show_bug.cgi?id=33847
        
        * platform/graphics/win/WKCACFLayerRenderer.cpp:
        (WebCore::WKCACFLayerRenderer::setScrollFrame):
        (WebCore::WKCACFLayerRenderer::createRenderer):

2010-01-25  Alexey Proskuryakov  <ap@apple.com>

        Rubber-stamped by Geoffrey Garen.

        https://bugs.webkit.org/show_bug.cgi?id=34076
        An image remains accessible via form.property syntax after being removed from document.

        Fix crashing regression tests (tables/mozilla/bugs/bug4527.html et al.)

        * html/HTMLImageElement.cpp: (WebCore::HTMLImageElement::insertedIntoTree): Remove incorrect
        assertions added in the previous patch - it's mot true that m_for is always a parent; table
        parsing can reparent the image element, but m_form still needs to be set.

2010-01-25  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Geoffrey Garen.

        https://bugs.webkit.org/show_bug.cgi?id=34076
        An image remains accessible via form.property syntax after being removed from document.

        Tests: fast/forms/removed-image-as-property.html
               fast/forms/reparented-image-as-property.html

        * html/HTMLImageElement.cpp:
        (WebCore::HTMLImageElement::~HTMLImageElement): This is called during GC - not a good time
        to make observable changes to DOM.
        (WebCore::HTMLImageElement::insertedIntoTree): This is the right place to do any work that
        depends on connectedness to some ancestor. We still allow for m_form to be set via constructor,
        which happens during parsing.
        (WebCore::HTMLImageElement::removedFromTree): Ditto.

        * html/HTMLImageElement.h: Added removedFromTree/insertedIntoTree, moved removedFromDocument
        and insertedIntoDocument to private section, as they shouldn't be called directly.

2010-01-25  Daniel Bates  <dbates@webkit.org>

        Reviewed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=34073

        Fixes misspelled words in comments.

        * accessibility/AccessibilityListBox.cpp:
        (WebCore::AccessibilityListBox::addChildren):
        (WebCore::AccessibilityListBox::doAccessibilityHitTest):
        * accessibility/mac/AccessibilityObjectWrapper.mm:
        (-[AccessibilityObjectWrapper detach]):
        (AXAttributeStringSetElement):
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::completeURL):
        * bindings/js/JSDOMWindowBase.cpp:
        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::getOwnPropertySlot):
        * bindings/js/JSSVGPODTypeWrapper.h:
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::evaluateInWorld):
        * bridge/NP_jsobject.cpp:
        (_NPN_SetException):
        * bridge/jni/jsc/JavaInstanceJSC.cpp:
        (JavaInstance::invokeMethod):
        (JObjectWrapper::JObjectWrapper):
        * bridge/objc/objc_instance.mm:
        (ObjcInstance::setValueOfUndefinedField):
        (ObjcInstance::getValueOfUndefinedField):
        * css/CSSFontSelector.cpp:
        (WebCore::CSSFontSelector::addFontFaceRule):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::CSSStyleSelector):
        (WebCore::CSSStyleSelector::sortMatchedRules):
        (WebCore::CSSStyleSelector::applyDeclarations):
        (WebCore::CSSStyleSelector::applyProperty):
        * dom/Document.cpp:
        (WebCore::Document::updateLayoutIgnorePendingStylesheets):
        (WebCore::Document::detach):
        * dom/Document.h:
        * dom/Element.cpp:
        (WebCore::Element::updateFocusAppearance):
        * dom/Element.h:
        * dom/MessagePortChannel.h:
        * dom/MouseRelatedEvent.cpp:
        (WebCore::MouseRelatedEvent::receivedTarget):
        * dom/Node.cpp:
        (WebCore::Node::isFocusable):
        (WebCore::Node::shadowAncestorNode):
        * dom/Node.h:
        * dom/Position.cpp:
        (WebCore::Position::upstream):
        * dom/Position.h:
        * dom/Range.cpp:
        (WebCore::Range::processContents):
        * dom/StyledElement.cpp:
        (WebCore::StyledElement::addCSSColor):
        * editing/ApplyStyleCommand.cpp:
        (WebCore::StyleChange::reconcileTextDecorationProperties):
        (WebCore::StyleChange::extractTextStyles):
        (WebCore::prepareEditingStyleToApplyAt):
        * editing/DeleteButtonController.cpp:
        (WebCore::isDeletableElement):
        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::initializeStartEnd):
        * editing/Editor.cpp:
        (WebCore::Editor::learnSpelling):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleMessage.prototype._format):
        * loader/Cache.cpp:
        (WebCore::Cache::pruneLiveResources):
        (WebCore::Cache::pruneDeadResources):
        * loader/Cache.h:
        * loader/CachedResource.cpp:
        (WebCore::CachedResource::makePurgeable):
        * loader/CachedResource.h:
        * loader/CachedResourceHandle.h:
        * loader/DocumentLoader.h:
        * loader/FTPDirectoryParser.cpp:
        (WebCore::parseOneFTPLine):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::didExplicitOpen):
        * loader/ResourceLoader.cpp:
        (WebCore::ResourceLoader::didCancel):
        * loader/WorkerThreadableLoader.h:
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::spaceNeeded):
        * notifications/NotificationPresenter.h:
        (WebCore::NotificationPresenter::):
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationController::updateAnimations):
        * platform/LinkHash.cpp:
        (WebCore::cleanPath):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::calculateDrawingMode):
        * platform/graphics/cg/PatternCG.cpp:
        (WebCore::Pattern::createPlatformPattern):
        * platform/graphics/mac/ComplexTextController.cpp:
        (WebCore::ComplexTextController::offsetForPosition):
        * platform/graphics/mac/GraphicsLayerCA.h:
        * platform/graphics/mac/GraphicsLayerCA.mm:
        (WebCore::GraphicsLayerCA::ensureStructuralLayer):
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::doSeek):
        (WebCore::MediaPlayerPrivate::setClosedCaptionsVisible):
        (WebCore::MediaPlayerPrivate::hasAvailableVideoFrame):
        * platform/mac/PasteboardMac.mm:
        (WebCore::Pasteboard::writeSelection):
        (WebCore::Pasteboard::writePlainText):
        (WebCore::Pasteboard::writeURL):
        * platform/text/TextCodecICU.cpp:
        (WebCore::TextCodecICU::registerExtendedEncodingNames):
        * platform/text/TextEncodingDetectorICU.cpp:
        (WebCore::detectTextEncoding):
        * rendering/AutoTableLayout.cpp:
        (WebCore::AutoTableLayout::calcEffectiveWidth):
        (WebCore::AutoTableLayout::layout):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::calcAbsoluteHorizontalValues):
        (WebCore::RenderBox::calcAbsoluteVerticalValues):
        (WebCore::RenderBox::calcAbsoluteHorizontalReplaced):
        (WebCore::RenderBox::calcAbsoluteVerticalReplaced):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollByRecursively):
        (WebCore::RenderLayer::paintLayer):
        (WebCore::RenderLayer::hitTestLayer):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::destroy):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::setInnerTextValue):
        * rendering/RenderTheme.cpp:
        (WebCore::RenderTheme::stateChanged):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderBase::mapLocalToContainer):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::buildTextChunks):
        * rendering/TransformState.cpp:
        (WebCore::TransformState::flattenWithTransform):
        * wml/WMLInputElement.cpp:
        (WebCore::WMLInputElement::dispatchBlurEvent):
        (WebCore::WMLInputElement::suggestedValue):

2010-01-25  Geoffrey Garen  <ggaren@apple.com>

        Suggested by Darin Adler.

        Fixed a spelling error, tightened up some grammar.

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::forgetDOMObject):
        (WebCore::forgetDOMNode):

2010-01-25  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Timothy Hatcher.

        Instead of adding inspector methods to the inspected global objects
        use private implementation visible from inspector code only.
        https://bugs.webkit.org/show_bug.cgi?id=34089

        Test: inspector/inspected-objects-not-overriden.html

        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor):

2010-01-25  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: don't show headers/content tabs in scripts view.

        https://bugs.webkit.org/show_bug.cgi?id=34083

        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceView):
        (WebInspector.ResourceView.prototype.set headersVisible):
        (WebInspector.ResourceView.prototype._selectContentTab):
        (WebInspector.ResourceView.prototype._innerSelectContentTab):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype.show):
        (WebInspector.ResourcesPanel.prototype.recreateViewForResourceIfNeeded):
        (WebInspector.ResourcesPanel.prototype.showResource):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.show):
        (WebInspector.ScriptsPanel.prototype._showScriptOrResource):
        * inspector/front-end/inspector.css:

2010-01-25  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] Reduce the size of the library when compiling for Maemo5
        https://bugs.webkit.org/show_bug.cgi?id=34050

        Exclude the Web Inspector's qrc file in the Maemo5 build, just
        like we do for the Symbian build. Saves about ~900k.

        * WebCore.pro:

2010-01-25  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] In the StyledPainter determine the style from the Render and Scrollbar theme instead of from the paint device
        https://bugs.webkit.org/show_bug.cgi?id=34054

        Getting the style from the painter's paint device is a hack that breaks when
        the paint device's style is different than the style that is used when
        calculating the metries earlier when there is no painter available.

        This change moves us closer to always using the same style.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::StylePainter::StylePainter):
        (WebCore::StylePainter::init):
        (WebCore::RenderThemeQt::paintButton):
        (WebCore::RenderThemeQt::paintTextField):
        (WebCore::RenderThemeQt::paintMenuList):
        (WebCore::RenderThemeQt::paintMenuListButton):
        (WebCore::RenderThemeQt::paintSliderTrack):
        (WebCore::RenderThemeQt::paintMediaMuteButton):
        (WebCore::RenderThemeQt::paintMediaPlayButton):
        (WebCore::RenderThemeQt::paintMediaSliderTrack):
        (WebCore::RenderThemeQt::paintMediaSliderThumb):
        * platform/qt/RenderThemeQt.h:
        * platform/qt/ScrollbarThemeQt.cpp:
        (WebCore::ScrollbarThemeQt::paint):
        (WebCore::ScrollbarThemeQt::hitTest):
        (WebCore::ScrollbarThemeQt::shouldCenterOnThumb):
        (WebCore::ScrollbarThemeQt::scrollbarThickness):
        (WebCore::ScrollbarThemeQt::thumbLength):
        (WebCore::ScrollbarThemeQt::trackPosition):
        (WebCore::ScrollbarThemeQt::trackLength):
        (WebCore::ScrollbarThemeQt::paintScrollCorner):
        (WebCore::ScrollbarThemeQt::style):
        * platform/qt/ScrollbarThemeQt.h:

2010-01-25  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] In RenderThemeQt determine the QStyle from the page client instead of the page's view
        https://bugs.webkit.org/show_bug.cgi?id=34053

        * platform/qt/QWebPageClient.h: Add function to return the style.
        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::qStyle): Determine the style from the page client instead of the page's view.

2010-01-25  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Kenneth Christiansen.

        [Qt] Clean up code to determine palette from page client in RenderThemeQt
        https://bugs.webkit.org/show_bug.cgi?id=34052

        Use the RenderTheme's associated page instead of going through the
        render tree and the document.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::setPaletteFromPageClientIfExists):
        (WebCore::RenderThemeQt::initializeCommonQStyleOptions):
        * platform/qt/RenderThemeQt.h:

2010-01-25  Janne Koskinen  <janne.p.koskinen@digia.com>

        Reviewed by Simon Hausmann.

        [Qt] Phone backup support for QtWebkit for Symbian devices.
        https://bugs.webkit.org/show_bug.cgi?id=34077

        * WebCore.pro:

2010-01-25  Benjamin Poulain  <benjamin.poulain@nokia.com>

        Reviewed by Antti Koivisto.

        Do not render the full frame when there is some elements with fixed positioning
        https://bugs.webkit.org/show_bug.cgi?id=33150

        Do not render the full frame when there is some elements with fixed positioning
        https://bugs.webkit.org/show_bug.cgi?id=33150

        * page/FrameView.cpp:
        (WebCore::FrameView::useSlowRepaints):
        (WebCore::FrameView::useSlowRepaintsIfNotOverlapped):
        (WebCore::FrameView::registerFixedPositionedObject):
        (WebCore::FrameView::unregisterFixedPositionedObject):
        (WebCore::FrameView::scrollContentsFastPath):
        * page/FrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::scrollContents):
        (WebCore::ScrollView::scrollContentsFastPath):
        * platform/ScrollView.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):
        (WebCore::RenderObject::destroy):

2010-01-24  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Add support for addMessage/clearMessages to SourceFrame2.

        https://bugs.webkit.org/show_bug.cgi?id=33904

        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/front-end/SourceFrame2.js:
        (WebInspector.SourceFrame2):
        (WebInspector.SourceFrame2.prototype.addMessage):
        (WebInspector.SourceFrame2.prototype.clearMessages):
        (WebInspector.SourceFrame2.prototype._incrementMessageRepeatCount):
        (WebInspector.SourceFrame2.prototype._addExistingMessagesToSource):
        (WebInspector.SourceFrame2.prototype._addMessageToSource):
        (WebInspector.SourceFrame2.prototype.resize):
        * inspector/front-end/TextEditor.js:
        (WebInspector.TextEditor):
        (WebInspector.TextEditor.prototype.setDivDecoration):
        (WebInspector.TextEditor.prototype._lineHeight):
        (WebInspector.TextEditor.prototype._highlightChanged):
        (WebInspector.TextEditor.prototype.packAndRepaintAll):
        (WebInspector.TextEditor.prototype._updateSize):
        (WebInspector.TextEditor.prototype._repaintAll):
        (WebInspector.TextEditor.prototype._paint):
        (WebInspector.TextEditor.prototype._paintLinesContinuation):
        (WebInspector.TextEditor.prototype._mouseOut):
        (WebInspector.TextEditor.prototype._updateDivDecorations):
        (WebInspector.TextEditor.prototype._positionDivDecoration):
        (WebInspector.TextEditor.prototype._paintSelection):
        (WebInspector.TextEditor.prototype._replaceSelectionWith):
        * inspector/front-end/TextEditorHighlighter.js:
        (WebInspector.TextEditorHighlighter.prototype.updateHighlight):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.css:
        * inspector/front-end/inspector.html:
        * inspector/front-end/textEditor.css: Added.

2010-01-24  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Web Inspector: Replace split pane with tabbed pane in resource
        contents view.

        https://bugs.webkit.org/show_bug.cgi?id=32453

        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceView):
        (WebInspector.ResourceView.prototype.attach):
        (WebInspector.ResourceView.prototype.show):
        (WebInspector.ResourceView.prototype._selectTab):
        (WebInspector.ResourceView.prototype._selectHeadersTab):
        (WebInspector.ResourceView.prototype._selectContentTab):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype.show):
        (WebInspector.ResourcesPanel.prototype.recreateViewForResourceIfNeeded):
        (WebInspector.ResourcesPanel.prototype.showResource):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.show):
        (WebInspector.ScriptsPanel.prototype._showScriptOrResource):
        * inspector/front-end/Settings.js:
        (WebInspector.Settings.prototype._load):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype._loaded):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView):
        * inspector/front-end/inspector.css:

2010-01-24  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Dan Bernstein.

        Media element duration changes to zero after playing in reverse
        https://bugs.webkit.org/show_bug.cgi?id=34041

        Test: media/video-reverse-play-duration.html

        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::didEnd): QTKit's ended notification fires at time zero when 
        playing in reverse, so don't reset duration in that case.

2010-01-24  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dan Bernstein.

        Content with heavily nested residual style is so slow, it seems like a hang
        https://bugs.webkit.org/show_bug.cgi?id=34059
        <rdar://problem/7292906>
        
        Test cast: fast/parser/residual-style-hang.html

        * html/HTMLParser.cpp:
        (WebCore::HTMLParser::handleResidualStyleCloseTagAcrossBlocks):
        Limit the number of iterations of the main loop to 5.
        
        The reason this limit is necessary is that otherwise, N misnested open tags followed
        by N misnested close tags will cause O(N^2) of work due to cloning and attaching subtrees;
        at a fixed limit, the cost is at worst O(N).
        
        The code that was in the loop originally ran exactly once - the loop was added in
        r21472 to fix <https://bugs.webkit.org/show_bug.cgi?id=13603>. I have verified that
        with the iteration limit, the bug is still fixed, both with the original test case
        and with the layout tests tht were added.

2010-01-24  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        HTMLInputElement::valueAsDate setter support for type=week.
        https://bugs.webkit.org/show_bug.cgi?id=33986

        Introduce ISODateTime::setMillisecondsSinceEpochForWeek() and add
        Week type support to ISODateTime::toString().

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::valueAsDate): Avoid default:.
        (WebCore::HTMLInputElement::setValueAsDate):
          Add WEEK type handling and avoid default:.
        * html/ISODateTime.cpp:
        (WebCore::offsetTo1stWeekStart):
        (WebCore::ISODateTime::setMillisecondsSinceEpochForWeek):
        (WebCore::ISODateTime::millisecondsSinceEpoch):
        (WebCore::ISODateTime::toString):
          Add Week type support and avoid default:.
        * html/ISODateTime.h:

2010-01-24  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin Adler.

        Object Serialization assumes deserialization will always occur in the context of a webpage
        https://bugs.webkit.org/show_bug.cgi?id=34056
        rdar://7573833

        Added ClassInfo to JSDOMGlobalObject and make the window and worker class info
        inherit from it.  With this in place we're able to determine whether a given
        global object is a DOMGlobalObject, and then use that information to avoid
        attempting to deserialize types that require the presence of the DOM.

        No test as all global objects in webkit inherit from JSDOMGlobalObject.

        * bindings/js/JSDOMGlobalObject.cpp:
        (WebCore::):
        * bindings/js/JSDOMGlobalObject.h:
        (WebCore::JSDOMGlobalObject::classInfo):
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::):
        * bindings/js/JSWorkerContextBase.cpp:
        (WebCore::):
        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::DeserializingTreeWalker::DeserializingTreeWalker):
        (WebCore::DeserializingTreeWalker::convertIfTerminal):

2010-01-24  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=34047
        <rdar://problem/7573699>
        Media element "endedPlayback" logic doesn't match spec

        Test: media/video-timeupdate-reverse-play.html

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::ended): The 'ended' attribute should only be true when playback
        rate is positive.
        (WebCore::HTMLMediaElement::mediaPlayerTimeChanged): Always schedule a 'timeupdate' event when
        the media engine signals a time discontinuity, scheduleTimeupdateEvent will only queue an event
        if one hasn't already been posted for the current movie time.
        (WebCore::HTMLMediaElement::endedPlayback): Update to match the spec logic.

2010-01-23  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler.

        Video that loads inside reflection doesn't get reflected
        https://bugs.webkit.org/show_bug.cgi?id=34046
        
        ensureCloneLayers() made an incorrect assumption that if a clone of the primaryLayer
        exists already, then the structural layer and content layer can just be returned.
        However, this doesn't account for the situation where a content layer may have
        been create after the clone tree was last updated.
        
        Fix by always creating the structural and clone layers on demand.

        Test: compositing/reflections/load-video-in-reflection.html

        * platform/graphics/mac/GraphicsLayerCA.h: Added utility method, findOrMakeClone().
        * platform/graphics/mac/GraphicsLayerCA.mm:
        (WebCore::GraphicsLayerCA::findOrMakeClone): Utility that efficiently finds
        or creates a layer in a LayerMap.
        (WebCore::GraphicsLayerCA::ensureCloneLayers): Always look for or clone the
        structural and content layers, rather than relying on whether there's a primary
        layer clone already.

2010-01-23  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej Stachowiak.

        Implement support for FileList cloning in postMessage
        https://bugs.webkit.org/show_bug.cgi?id=34048

        Support passing FileList through postMessage APIs.  Basically
        mechanical task in line with other terminals in the object
        graph.

        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::SerializedFileList::create):
        (WebCore::SerializedFileList::length):
        (WebCore::SerializedFileList::item):
        (WebCore::SerializedFileList::SerializedFileList):
        (WebCore::SerializedScriptValueData::SerializedScriptValueData):
        (WebCore::SharedSerializedData::asFileList):
        (WebCore::SerializingTreeWalker::convertIfTerminal):
        (WebCore::DeserializingTreeWalker::convertIfTerminal):
        (WebCore::TeardownTreeWalker::convertIfTerminal):
            Rearrange these functions to not use 'default:' handling
            so that the compiler will actually tell us when we're
            not handling cases.
        * bindings/js/SerializedScriptValue.h:
        (WebCore::SerializedScriptValueData::):
        (WebCore::SerializedScriptValueData::asFileList):

2010-01-23  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Inject inspector script directly into the inspected context. All the
        communication between the script and the frontend is serialized into
        JSON strings. It allows to get rid of object quarantines in Web Inspector.

        https://bugs.webkit.org/show_bug.cgi?id=32554

        Test: inspector/console-log-before-inspector-open.html

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::databaseForId):
        (WebCore::JSInjectedScriptHost::currentCallFrame):
        (WebCore::JSInjectedScriptHost::nodeForId):
        (WebCore::JSInjectedScriptHost::pushNodePathToFrontend):
        (WebCore::JSInjectedScriptHost::selectDatabase):
        (WebCore::JSInjectedScriptHost::selectDOMStorage):
        * bindings/js/ScriptCallStack.h:
        (WebCore::ScriptCallStack::globalState):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::mainWorldScriptState):
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptObject.h:
        (WebCore::ScriptObject::scriptState):
        * bindings/js/ScriptValue.cpp:
        * bindings/js/ScriptValue.h:
        * bindings/v8/ScriptCallStack.h:
        (WebCore::ScriptCallStack::globalState):
        * bindings/v8/ScriptObject.h:
        (WebCore::ScriptObject::scriptState):
        * bindings/v8/ScriptValue.h:
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        * inspector/ConsoleMessage.cpp:
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::ConsoleMessage::addToConsole):
        (WebCore::ConsoleMessage::isEqual):
        * inspector/ConsoleMessage.h:
        * inspector/InjectedScriptHost.cpp:
        (WebCore::InjectedScriptHost::releaseWrapperObjectGroup):
        * inspector/InjectedScriptHost.h:
        * inspector/InjectedScriptHost.idl:
        * inspector/InspectorBackend.cpp:
        (WebCore::InspectorBackend::setInjectedScriptSource):
        (WebCore::InspectorBackend::dispatchOnInjectedScript):
        (WebCore::InspectorBackend::releaseWrapperObjectGroup):
        * inspector/InspectorBackend.h:
        * inspector/InspectorBackend.idl:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::clearConsoleMessages):
        (WebCore::InspectorController::inspectedWindowScriptObjectCleared):
        (WebCore::InspectorController::windowScriptObjectAvailable):
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::setFrontendProxyObject):
        (WebCore::InspectorController::close):
        (WebCore::InspectorController::resetScriptObjects):
        (WebCore::InspectorController::didPause):
        (WebCore::InspectorController::injectedScriptForNodeId):
        * inspector/InspectorController.h:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::addConsoleMessage):
        (WebCore::InspectorFrontend::pausedScript):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/AuditsPanel.js:
        (WebInspector.AuditsPanel.prototype._reloadResources):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleView.prototype.requestClearMessages):
        (WebInspector.ConsoleView.prototype.doEvalInWindow):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMNode):
        (WebInspector.CSSStyleDeclaration):
        (WebInspector.CSSStyleDeclaration.parseRule):
        * inspector/front-end/Database.js:
        (WebInspector.Database.prototype.executeSql):
        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged.InjectedScriptAccess.get addInspectedNode):
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged):
        (WebInspector.ElementsPanel.prototype.setDocument):
        (WebInspector.ElementsPanel.prototype.searchCanceled):
        (WebInspector.ElementsPanel.prototype.performSearch):
        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype.createTooltipForImageNode):
        * inspector/front-end/EventListenersSidebarPane.js:
        ():
        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor):
        (injectedScriptConstructor.):
        * inspector/front-end/InjectedScriptAccess.js:
        (InjectedScriptAccess):
        (InjectedScriptAccess.getDefault):
        (get InjectedScriptAccess):
        (InjectedScriptAccess._installHandler.InjectedScriptAccess.prototype.methodName):
        (InjectedScriptAccess._installHandler):
        * inspector/front-end/MetricsSidebarPane.js:
        (WebInspector.MetricsSidebarPane):
        (WebInspector.MetricsSidebarPane.prototype.update.inlineStyleCallback):
        * inspector/front-end/ObjectPropertiesSection.js:
        * inspector/front-end/ObjectProxy.js:
        (WebInspector.ObjectProxy):
        * inspector/front-end/PropertiesSidebarPane.js:
        (WebInspector.PropertiesSidebarPane.prototype.update.callback):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourceSidebarTreeElement.prototype.ondblclick):
        * inspector/front-end/ScriptsPanel.js:
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype):
        * inspector/front-end/WatchExpressionsSidebarPane.js:
        (WebInspector.WatchExpressionsSection.prototype.update):
        * inspector/front-end/inspector.js:
        (WebInspector.loaded):
        (WebInspector.pausedScript):
        (WebInspector.addConsoleMessage):
        (WebInspector.log.logMessage):
        (WebInspector.log):

2010-01-22  Alex Milowski  <alex@milowski.com>

        Reviewed by David Hyatt.

        Added support for RenderMathMLBlock base object and isRenderMathMLBlock()
        method on RenderObject. 

        Added support for text elements and updated tag and attribute names

        Also, updated the stylesheet added files to the project

        * DerivedSources.make:
        * WebCore.xcodeproj/project.pbxproj:
        * css/mathml.css:
        * mathml/MathMLInlineContainerElement.cpp:
        (WebCore::MathMLInlineContainerElement::createRenderer):
        * mathml/MathMLTextElement.cpp: Added.
        (WebCore::MathMLTextElement::MathMLTextElement):
        (WebCore::MathMLTextElement::create):
        (WebCore::MathMLTextElement::createRenderer):
        * mathml/MathMLTextElement.h: Added.
        * mathml/RenderMathMLBlock.cpp: Added.
        (WebCore::RenderMathMLBlock::RenderMathMLBlock):
        (WebCore::RenderMathMLBlock::styleDidChange):
        (WebCore::RenderMathMLBlock::isChildAllowed):
        (WebCore::RenderMathMLBlock::makeBlockStyle):
        (WebCore::RenderMathMLBlock::nonOperatorHeight):
        (WebCore::RenderMathMLBlock::stretchToHeight):
        * mathml/RenderMathMLBlock.h: Added.
        (WebCore::RenderMathMLBlock::isRenderMathMLBlock):
        (WebCore::RenderMathMLBlock::isRenderMathMLOperator):
        (WebCore::RenderMathMLBlock::isRenderMathMLRow):
        (WebCore::RenderMathMLBlock::isRenderMathMLMath):
        (WebCore::RenderMathMLBlock::hasBase):
        (WebCore::toRenderMathMLBlock):
        * mathml/mathattrs.in: Added.
        * rendering/RenderObject.h:
        (WebCore::RenderObject::isRenderMathMLBlock):

2010-01-22  James Robinson  <jamesr@chromium.org>

        Reviewed by Alexey Proskuryakov.

        Ensures that the 'selected' attribute of an <option> is correct
        https://bugs.webkit.org/show_bug.cgi?id=32641

        Adds a check in OptionElement::selected() that checks if list items need to be recalculated and does so if needed,
        so the attribute is up to date more often.  Also gets rid of most of the recalcStyle() side effects.

         Our behavior now matches Firefox 3.5 and IE8 after the </select> is parsed.

         Tests: fast/forms/HTMLOptionElement_selected2.html
                fast/forms/HTMLOptionElement_selected3.html

        * dom/SelectElement.cpp:
        (WebCore::SelectElement::setOptionsChangedOnRenderer):
        (WebCore::SelectElement::setRecalcListItems):
        (WebCore::SelectElement::recalcListItems):
        (WebCore::SelectElement::restoreFormControlState):
        (WebCore::SelectElement::reset):
        (WebCore::SelectElement::typeAheadFind):
        * dom/SelectElement.h:
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::selected):
        (WebCore::HTMLOptionElement::insertedIntoTree):
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::recalcStyle):
        (WebCore::HTMLSelectElement::recalcListItemsIfNeeded):
        * html/HTMLSelectElement.h:
        * wml/WMLSelectElement.cpp:
        (WebCore::WMLSelectElement::recalcStyle):

2010-01-22  Chris Rogers  <crogers@google.com>

        Reviewed by Eric Seidel.

        Need to handle WebGLUnsignedByteArray as method argument for V8 binding
        https://bugs.webkit.org/show_bug.cgi?id=33929

        V8 code generator does not have associated tests

        * bindings/scripts/CodeGeneratorV8.pm:

2010-01-22  Elliot Glaysher  <erg@chromium.org>

        Reviewed by David Levin.

        Chromium: theme selection colors to match gtk theme
        Add functions to RenderThemeChromiumLinux to change the selection color
        according to the current GTK+ theme.

        Since the change is to the Chromium WebKit API layer, testing is done
        in Chromium's test shell (see Chromium side of this patch:
        http://codereview.chromium.org/554004)

        https://bugs.webkit.org/show_bug.cgi?id=33921

        * rendering/RenderThemeChromiumLinux.cpp:
        (WebCore::RenderThemeChromiumLinux::platformActiveSelectionBackgroundColor):
        (WebCore::RenderThemeChromiumLinux::platformInactiveSelectionBackgroundColor):
        (WebCore::RenderThemeChromiumLinux::platformActiveSelectionForegroundColor):
        (WebCore::RenderThemeChromiumLinux::platformInactiveSelectionForegroundColor):
        (WebCore::RenderThemeChromiumLinux::setSelectionColors):
        * rendering/RenderThemeChromiumLinux.h: Adds static members.

2010-01-22  Kevin Watters  <kevinwatters@gmail.com>

        Reviewed by Kevin Ollivier.

        [wx] Remove the Bakefile build system, which is no longer being used.
        
        https://bugs.webkit.org/show_bug.cgi?id=34022

        * WebCoreSources.bkl: Removed.
        * webcore-base.bkl: Removed.
        * webcore-wx.bkl: Removed.

2010-01-22  Peter Kasting  <pkasting@google.com>

        Reviewed by Darin Adler.

        Remove unnecessary copy of zlib.
        https://bugs.webkit.org/show_bug.cgi?id=34028

        * platform/image-decoders/zlib: Removed.
        * platform/image-decoders/zlib/adler32.c: Removed.
        * platform/image-decoders/zlib/compress.c: Removed.
        * platform/image-decoders/zlib/crc32.c: Removed.
        * platform/image-decoders/zlib/crc32.h: Removed.
        * platform/image-decoders/zlib/deflate.c: Removed.
        * platform/image-decoders/zlib/deflate.h: Removed.
        * platform/image-decoders/zlib/gzio.c: Removed.
        * platform/image-decoders/zlib/infback.c: Removed.
        * platform/image-decoders/zlib/inffast.c: Removed.
        * platform/image-decoders/zlib/inffast.h: Removed.
        * platform/image-decoders/zlib/inffixed.h: Removed.
        * platform/image-decoders/zlib/inflate.c: Removed.
        * platform/image-decoders/zlib/inflate.h: Removed.
        * platform/image-decoders/zlib/inftrees.c: Removed.
        * platform/image-decoders/zlib/inftrees.h: Removed.
        * platform/image-decoders/zlib/mozzconf.h: Removed.
        * platform/image-decoders/zlib/trees.c: Removed.
        * platform/image-decoders/zlib/trees.h: Removed.
        * platform/image-decoders/zlib/uncompr.c: Removed.
        * platform/image-decoders/zlib/zconf.h: Removed.
        * platform/image-decoders/zlib/zlib.h: Removed.
        * platform/image-decoders/zlib/zutil.c: Removed.
        * platform/image-decoders/zlib/zutil.h: Removed.

2010-01-22  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=34025
        Enable client-based Geolocation abstraction for Mac, Windows AppleWebKit targets.

        * Configurations/FeatureDefines.xcconfig:
        * DerivedSources.make:

2010-01-22  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Eric Carlson.

        Race condition in video setup can force videos into software mode
        https://bugs.webkit.org/show_bug.cgi?id=34034

        We used to call setUpVideoRendering() unconditionally from
        acceleratedRenderingStateChanged(); this could happen before the movie had any
        data, and thus force the movie into software rendering mode.
        
        Fix by returning early from setUpVideoRendering() if isReadyForRendering() returns false,
        which also allows us to remove some other checks for being ready to render.
        
        Timing dependent, hard to make a test for.

        * platform/graphics/mac/GraphicsLayerCA.mm:
        (WebCore::GraphicsLayerCA::setContentsToMedia): Optimize to do an early return
        if passing in the same layer that is already being used.
        
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::setUpVideoRendering): Return without doing anything
        if not ready to render.
        (WebCore::MediaPlayerPrivate::updateStates): No need to call isReadyForRendering()
        any more, since setUpVideoRendering() does that.
        (WebCore::MediaPlayerPrivate::setVisible): No need to check the ready state; this
        is equivalent to the check inside of setUpVideoRendering().

2010-01-22  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        REGRESSION (r53110): Find My iPhone message dialog is offset from original position once it gets focus
        https://bugs.webkit.org/show_bug.cgi?id=33821

        Fix an issue with the geometry of fixed position, composited layers inside other
        composited layers. If we called convertToLayerCoords() on a fixed layer with an ancestor
        layer which is not the root, then we assumed that the fixed layer had a positioning root.
        However, this is not always the case, since the fixed layer may have a compositing ancestor
        which is not a fixed container.
        
        Test: compositing/geometry/fixed-in-composited.html

        * rendering/RenderLayer.cpp:
        (WebCore::isFixedPositionedContainer): Utility function to test whether a layer acts
        as a fixed position container.
        
        (WebCore::RenderLayer::convertToLayerCoords): When called on a fixed position layer
        for an ancestor layer that is not the root, compute the correct offsets by looking for
        the fixed position container, and computing offsets relative to that. If the ancestorLayer
        is the fixed position container, fall through to the existing code that is shared
        with absolutely positioned layers.

2010-01-22  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        webkitConvertPointFromNodeToPage doesn't take into account most recent transform style
        https://bugs.webkit.org/show_bug.cgi?id=34023

        Be sure to call updateLayoutIgnorePendingStylesheets() before doing point mapping,
        to apply any style changes since the last layout.

        Test: fast/dom/Window/webkitConvertPointUpdateLayout.html

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::webkitConvertPointFromNodeToPage): Call updateLayoutIgnorePendingStylesheets().
        (WebCore::DOMWindow::webkitConvertPointFromPageToNode): Ditto.

2010-01-22  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Adam Roben.

        Use stale cache data when going back and forward but not using WebCore’s page cache
        https://bugs.webkit.org/show_bug.cgi?id=33993
        <rdar://problem/7383392>

        No tests since this is a performance change.

        * loader/CachePolicy.h:
        (WebCore::): Add CachePolicyAllowStale.
        * loader/DocLoader.cpp:
        (WebCore::DocLoader::checkForReload): Never reload in the case of
        CachePolicyAllowStale.
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::subresourceCachePolicy): Return CachePolicyAllowStale
        if the main resource is being loaded to allow stale data.
        (WebCore::FrameLoader::addExtraFieldsToRequest): Use ReturnCacheDataElseLoad
        on back/forward loads - needed when going back of forward to a page with frames.

2010-01-22  Kelly Norton  <knorton@google.com>

        Reviewed by Pavel Feldman.

        Web Inspector: JavaScript Error in DOMAgent.js:375 (_attributesUpdated)
        https://bugs.webkit.org/show_bug.cgi?id=33915

        Errors were caused by the fact that Element::attributes calls Element::setAttribute to
        synchronized the styleAttr. The fix is to simply check the synchronizing style attribute
        flag.

        * dom/Element.cpp:
        (WebCore::Element::setAttribute): Checked for case where styleAttr is being synchronized.

2010-01-22  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Simon Fraser.

        Update r53711 for GraphicsLayer method rename.

        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.cpp:
        (WebCore::MediaPlayerPrivate::createLayerForMovie): Rename from change setContentsToVideo.

2010-01-22  Jian Li  <jianli@chromium.org>

        Reviewed by Darin Adler.

        Add BlobConstructor to DOMWindow.
        https://bugs.webkit.org/show_bug.cgi?id=33982

        * page/DOMWindow.idl:

2010-01-22  Brian Weinstein  <bweinstein@apple.com>

        Rubber-stamped by Adam Roben.
        
        Commit files that were supposed to be part of r53696, but weren't
        landed.

        * English.lproj/localizedStrings.js:
        * manual-tests/debugger-caught-uncaught-exceptions.html: Added.

2010-01-22  Peter Kasting  <pkasting@google.com>

        Reviewed by David Hyatt.

        When scrolling by page, hold back 1/8th of the visible size instead of
        40 px.
        https://bugs.webkit.org/show_bug.cgi?id=32595

        * editing/EditorCommand.cpp:
        (WebCore::verticalScrollDistance):
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::wheelEvent):
        * platform/Scrollbar.h:
        * platform/wx/ScrollViewWx.cpp:
        (WebCore::ScrollView::ScrollViewPrivate::OnScrollWinEvents):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateScrollInfoAfterLayout):

2010-01-22  Peter Kasting  <pkasting@google.com>

        Not reviewed, backout.

        Back out r52673, which caused several regressions.
        https://bugs.webkit.org/show_bug.cgi?id=32533

        * platform/PopupMenuClient.h:
        * platform/chromium/PopupMenuChromium.cpp:
        (WebCore::PopupContainer::hidePopup):
        (WebCore::PopupListBox::handleKeyEvent):
        (WebCore::PopupListBox::abandon):
        (WebCore::PopupListBox::acceptIndex):
        (WebCore::PopupListBox::selectIndex):
        (WebCore::PopupListBox::clearSelection):
        (WebCore::PopupListBox::hidePopup):
        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenu::menuUnmapped):
        * platform/mac/PopupMenuMac.mm:
        (WebCore::PopupMenu::show):
        * platform/qt/QtAbstractWebPopup.cpp:
        (WebCore::QtAbstractWebPopup::popupDidHide):
        * platform/qt/QtAbstractWebPopup.h:
        * platform/win/PopupMenuWin.cpp:
        (WebCore::PopupMenu::hide):
        * platform/wx/PopupMenuWx.cpp:
        (WebCore::PopupMenu::OnMenuItemSelected):
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::popupDidHide):
        * rendering/RenderMenuList.h:
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::popupDidHide):
        * rendering/RenderTextControlSingleLine.h:

2010-01-22  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Darin Adler.

        Revert r53693 because it broke scrolling of pages with fixed elements on
        Mac OS X.

        * page/FrameView.cpp:
        * page/FrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::scrollContents):
        * platform/ScrollView.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):
        (WebCore::RenderObject::destroy):

2010-01-22  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=34008
        Assertion failure in KURL::setProtocol when running DOM Fuzzer

        Test: fast/dom/Window/invalid-protocol.html

        * bindings/js/JSLocationCustom.cpp: (WebCore::JSLocation::setProtocol): Raise an exception
        if KURL::setProtocol fails.

        * html/HTMLAnchorElement.cpp: (WebCore::HTMLAnchorElement::setProtocol): Move argument
        tweaking logic into KURL. This way, the ':' trick applies to both JSLocation and
        HTMLAnchorElement, matching IE (but not Firefox). IE behavior is more permissive, and even
        more logical in my opinion.

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::iconURL): Assert that setting protocol
        succeeded.

        * platform/KURL.cpp: (WebCore::KURL::setProtocol): Remove everything past ':', if present.
        Return false if the protocol to set is not valid.
        (WebCore::isValidProtocol): Made this work correctly for empty strings.

        * platform/KURL.h: isValidProtocol() is now static in KURL.cpp, it's only used in setProtocol().

        * platform/KURLGoogle.cpp: 
        (WebCore::KURL::setProtocol): Always return true. This should hopefully prevent Chromium build
        breakage, alhough tests will likely fail.
        (WebCore::isValidProtocol): Removed, as this isn't used at the moment.

        * websockets/WebSocketHandshake.cpp: (WebCore::WebSocketHandshake::httpURLForAuthenticationAndCookies):
        Assert that setting protocol succeeded.

2010-01-22  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Adam Roben.

        <rdar://problem/7373568>
        https://bugs.webkit.org/show_bug.cgi?id=34007
        Implement hardware acceleration of video compositing on Windows

        Internally we still have QuickTime render to a bitmap, but frames are then composited
        with the page using an accelerated renderer.

        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.cpp:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate): Initialize m_newFrameAvailable.
        (WebCore::MediaPlayerPrivate::~MediaPlayerPrivate): Call tearDownVideoRendering.
        (WebCore::MediaPlayerPrivate::cancelLoad): Call tearDownVideoRendering.
        (WebCore::MediaPlayerPrivate::updateStates): Call setUpVideoRendering once the movie 
            is ready to draw.
        (WebCore::MediaPlayerPrivate::isReadyForRendering): New, utility function returns true 
            only when movie is ready to render.
        (WebCore::MediaPlayerPrivate::setSize): Remember the size as we need it when rendering 
            in accelerated mode.
        (WebCore::MediaPlayerPrivate::setVisible): Call setUpVideoRendering when made visible.
        (WebCore::MediaPlayerPrivate::paint): Do nothing when rendering to a layer. Move frame 
            rate drawing code to paintCompleted.
        (WebCore::MediaPlayerPrivate::paintCompleted): New, clear m_newFrameAvailable and, when 
            built with DRAW_FRAME_RATE, draw framerate.
        (WebCore::MediaPlayerPrivate::movieNewImageAvailable): Set m_newFrameAvailable, trigger 
            repaint differently when drawing to a layer.
        (WebCore::MediaPlayerPrivate::currentRenderingMode): New, return the current rendering mode.
        (WebCore::MediaPlayerPrivate::preferredRenderingMode): New, return preferred rendering mode
            (render to a layer whenever possible).
        (WebCore::MediaPlayerPrivate::setUpVideoRendering): New, tear down current rendering mode 
            and set up new mode when necessary.
        (WebCore::MediaPlayerPrivate::tearDownVideoRendering): New, noop unless rendering to a layer.
        (WebCore::MediaPlayerPrivate::hasSetUpVideoRendering): New.
        (WebCore::MediaPlayerPrivate::paintContents): New, callback from compositing layer when it
            is time to draw the current frame.
        (WebCore::MediaPlayerPrivate::createLayerForMovie): New, allocate a layer for the movie.
        (WebCore::MediaPlayerPrivate::destroyLayerForMovie): New, delete movie layer.
        (WebCore::MediaPlayerPrivate::supportsAcceleratedRendering): New, return true unless the 
            movie is not ready to render.
        (WebCore::MediaPlayerPrivate::acceleratedRenderingStateChanged): New, deal with change in 
            accelerated rendering state.
        (WebCore::MediaPlayerPrivate::notifySyncRequired): New, callback from compositing layer 
            when it wants to schedule a redraw.
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.h:
        (WebCore::MediaPlayerPrivate::notifyAnimationStarted):
        (WebCore::MediaPlayerPrivate::showDebugBorders):
        (WebCore::MediaPlayerPrivate::showRepaintCounter):

        * platform/graphics/win/QTMovieWin.cpp:
        (QTMovieWin::getCurrentFrameInfo):
            New, return information about the offscreen render buffer.
        (QTMovieWin::initializeQuickTime):
        * platform/graphics/win/QTMovieWin.h:

2010-01-21  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Darin Fisher.

        The Chromium WebKit API needs to expose storage event related data
        https://bugs.webkit.org/show_bug.cgi?id=33985

        This change is not visible to layoutTests/web pages.

        * storage/StorageArea.h:
        * storage/StorageAreaImpl.cpp:
        (WebCore::StorageAreaImpl::setItem): return the old value
        (WebCore::StorageAreaImpl::removeItem): return the old value
        (WebCore::StorageAreaImpl::clear): return whether there was anything to clear
        * storage/StorageAreaImpl.h:

2010-01-22  Adele Peterson  <adele@apple.com>

        Reviewed by Dan Bernstein.

        An element that doesn't validate and an invalid element shouldn't share style
        https://bugs.webkit.org/show_bug.cgi?id=34010

        Test: fast/css/pseudo-invalid-novalidate-001.html

        * css/CSSStyleSelector.cpp: (WebCore::CSSStyleSelector::canShareStyleWithElement): 
          Separate the check for willValidate from the check for isValidFormControlElement.
        * html/HTMLFormControlElement.h: The validity method doesn't need to be virtual.

2010-01-22  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Dan Bernstein.

        Crash in fast/dom/Window/window-properties if Geolocation enabled
        https://bugs.webkit.org/show_bug.cgi?id=34013
        
        Add null check to fix Geolocation crash in fast/dom/Window/window-properties.
        
        * page/Geolocation.cpp:
        (WebCore::createGeoposition):

2010-01-22  Kent Hansen  <kent.hansen@nokia.com>

        Reviewed by Darin Adler.

        Object.getOwnPropertyDescriptor(window) returns descriptors for properties in the prototype chain
        https://bugs.webkit.org/show_bug.cgi?id=33948

        Even though prototype properties are proxied by JSDOMWindow::getOwnPropertySlot(),
        that proxying should not be performed by JSDOMWindow::getOwnPropertyDescriptor().

        This makes getOwnPropertyDescriptor() consistent with getOwnPropertyNames().

        Test: fast/dom/Window/window-property-descriptors.html

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::getOwnPropertyDescriptor):

2010-01-22  Girish Ramakrishnan  <girish@forwardbias.in>

        Reviewed by Simon Hausmann.

        [Qt] Save the QWebPageClient instead of the ownerWidget in QtAbstractWebPopup
        
        The QWebPageClient is required for the QtFallbackWebPopup. QtFallbackWebPopup will
        need it to create a QGraphicsProxyWidget (in a future commit) for the 
        QGraphicsWebView's web popup.

        * platform/qt/PopupMenuQt.cpp:
        (WebCore::PopupMenu::show):
        * platform/qt/QtAbstractWebPopup.cpp:
        (WebCore::QtAbstractWebPopup::QtAbstractWebPopup):
        (WebCore::QtAbstractWebPopup::popupDidHide):
        (WebCore::QtAbstractWebPopup::valueChanged):
        (WebCore::QtAbstractWebPopup::itemType):
        * platform/qt/QtAbstractWebPopup.h:
        (WebCore::QtAbstractWebPopup::itemText):
        (WebCore::QtAbstractWebPopup::itemToolTip):
        (WebCore::QtAbstractWebPopup::itemIsEnabled):
        (WebCore::QtAbstractWebPopup::itemCount):
        (WebCore::QtAbstractWebPopup::pageClient):
        (WebCore::QtAbstractWebPopup::font):

2010-01-22  Simon Hausmann  <simon.hausmann@nokia.com>

        Unreviewed Qt "build" fix.

        * WebCore.pro: Fix warning about missing header file that isn't present anymore.

2010-01-22  Sebastian Dröge  <sebastian.droege@collabora.co.uk>

        Reviewed by Gustavo Noronha Silva.

        Update copy of the source whenever playbin2's source property
        changes.

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateSourceChangedCallback):
        (WebCore::MediaPlayerPrivate::updateStates):
        (WebCore::MediaPlayerPrivate::createGSTPlayBin):
        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.h:
        Connect to the notify::source signal and update the source
        element pointer from there. This makes sure that we never
        store a pointer to an old source element.

2010-01-22  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Timothy Hatcher.

        Web Inspector: Caught exceptions still pause the debugger.
        <https://bugs.webkit.org/show_bug.cgi?id=28622>.

        Turn the pauseOnExceptions variable from a bool to an int, because we now have
        3 states, in an enum: DontPauseOnExceptions, PauseOnAllExceptions, and
        PauseOnUncaughtExceptions. The status button for pausing on exceptions is now
        a tri-state button, which cycles from Don't pause (no background) to Pause on All
        (blue background) to Pause on Uncaught (purple background).

        Also added the ability for a status button to have more than 2 states, and added
        style rules for a CSS three state button.

        Added a manual test, manual-tests/debugger-caught-uncaught-exceptions.html, that
        generates caught and uncaught exceptions.

        * English.lproj/localizedStrings.js: Added updated Action / Click to Action text.
        * inspector/InspectorBackend.cpp:
        (WebCore::InspectorBackend::pauseOnExceptions): Changed from a bool to an int.
        (WebCore::InspectorBackend::setPauseOnExceptions): Ditto.
        * inspector/InspectorBackend.h: Ditto.
        * inspector/InspectorBackend.idl: Ditto.
        * inspector/JavaScriptDebugServer.cpp:
        (WebCore::JavaScriptDebugServer::JavaScriptDebugServer): Changed from bool to PauseOnExceptionsState.
        (WebCore::JavaScriptDebugServer::setPauseOnExceptions): Ditto.
        (WebCore::JavaScriptDebugServer::exception): Updated logic to see if we are breaking
            on uncaught exceptions, and check if we have a handler.
        * inspector/JavaScriptDebugServer.h:
        (WebCore::JavaScriptDebugServer::): Changed from bool to PauseOnExceptionsState.
        (WebCore::JavaScriptDebugServer::pauseOnExceptions): Ditto.
        * inspector/front-end/InspectorBackendStub.js:
        (.WebInspector.InspectorBackendStub.prototype.pauseOnExceptionsState): Changed from returning false to returning 0 (stub function).
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel):
        (WebInspector.ScriptsPanel.prototype._updatePauseOnExceptionsButton): Updated to new text/new cycling of variables.
        (WebInspector.ScriptsPanel.prototype._togglePauseOnExceptions): Updated to new text/new cycling of variables.
        * inspector/front-end/StatusBarButton.js:
        (WebInspector.StatusBarButton): Added the option for a different number of states.
        (WebInspector.StatusBarButton.prototype.set toggled): Added rules to toggle on/off with multiple states.
        * inspector/front-end/inspector.css: Added rules for toggled-1 and toggled-2.
        * manual-tests/debugger-caught-uncaught-exceptions.html: Added.

2010-01-22  Ben Murdoch  <benm@google.com>

        Reviewed by Eric Seidel.

        [Android] Android platform specific PlatformTouchEvent and PlatformTouchPoint implementations are not upstream.
        https://bugs.webkit.org/show_bug.cgi?id=33719

        Add the Android specific files and update the Android makefile.

        No new tests as this is all Android-specific code.

        * Android.mk: Add Touch event related files to the makefile.
        * platform/PlatformTouchEvent.h: Add Android constructor.
        * platform/PlatformTouchPoint.h: Ditto.
        * platform/android/PlatformTouchEventAndroid.cpp: Added.
        (WebCore::PlatformTouchEvent::PlatformTouchEvent): Android implementation.
        * platform/android/PlatformTouchPointAndroid.cpp: Added.
        (WebCore::PlatformTouchPoint::PlatformTouchPoint): Android implementation.

2010-01-22  Benjamin Poulain  <benjamin.poulain@nokia.com>

        Reviewed by Kenneth Rohde Christiansen.

        Do not render the full frame when there is some elements with fixed positioning
        https://bugs.webkit.org/show_bug.cgi?id=33150

        The RenderObjects with fixed position register to the view
        to be taken into account while scrolling.
        The scrolling code update specifically those elements after blitting the pixels.

        * page/FrameView.cpp:
        (WebCore::FrameView::registerFixedPositionedObject):
        (WebCore::FrameView::unregisterFixedPositionedObject):
        (WebCore::FrameView::scrollContentsFastPath):
        * page/FrameView.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::scrollContents):
        (WebCore::ScrollView::scrollContentsFastPath):
        * platform/ScrollView.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):
        (WebCore::RenderObject::destroy):

2010-01-22  Anton Muhin  <antonm@chromium.org>

        Reviewed by Eric Seidel.

        Adding ScriptWrappable into WebCore.
        This allows to associate custom information when Node
        gets wrapped into JavaScript wrapper.

        [v8, dom] Add a pointer field to C++ Node class
        https://bugs.webkit.org/show_bug.cgi?id=32430

        * WebCore.gypi:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/ScriptWrappable.h: Added.
        (WebCore::ScriptWrappable::ScriptWrappable):
        * bindings/v8/ScriptWrappable.h: Added.
        (WebCore::ScriptWrappable::ScriptWrappable):
        (WebCore::ScriptWrappable::wrapper):
        (WebCore::ScriptWrappable::setWrapper):
        (WebCore::ScriptWrappable::clearWrapper):
        * dom/Node.h:

2010-01-22  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Add stub implementation of dispatchOnInjectedScript method so that
        Chromium source can compile against it and the main fix for the bug
        28622 can be landed without breaking Chromium build.

        https://bugs.webkit.org/show_bug.cgi?id=28622

        * inspector/InspectorBackend.h:
        (WebCore::InspectorBackend::dispatchOnInjectedScript):

2010-01-22  Kwang Yul Seo  <skyul@company100.net>

        Reviewed by Dmitry Titov.

        ENABLE(DATABASE) guard is missing in ScriptExecutionContext::~ScriptExecutionContext
        https://bugs.webkit.org/show_bug.cgi?id=33990

        Add missing ENABLE(DATABASE) guard.

        * dom/ScriptExecutionContext.cpp:
        (WebCore::ScriptExecutionContext::~ScriptExecutionContext):

2010-01-22  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        [GTK] GObject DOM bindings
        https://bugs.webkit.org/show_bug.cgi?id=33590

        * bindings/scripts/generate-bindings.pl:

2010-01-22  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        [GTK] GObject DOM bindings
        https://bugs.webkit.org/show_bug.cgi?id=33590

        Rename FEATURE_DEFINES_JAVASCRIPT to FEATURE_DEFINES and remove
        the hardcoded LANGUAGE_JAVASCRIPT=1, in preparation for its use by
        the GObject DOM bindings.

        * GNUmakefile.am:

2010-01-22  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/7568696> Zoom applied to embedded SVG incorrectly
        https://bugs.webkit.org/show_bug.cgi?id=33988

        Test: svg/custom/text-zoom.xhtml

        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement): Initialize m_scale.
        (WebCore::SVGSVGElement::currentScale): If this is the document element,
        return the frame’s zoom factor. Otherwise, return m_scale.
        (WebCore::SVGSVGElement::setCurrentScale): If this is the document element,
        set the frame’s zoom factor. Otherwise, set m_scale and mark for layout.
        * svg/SVGSVGElement.h: Added m_scale member.

2010-01-21  Adam Barth  <abarth@webkit.org>

        Reviewed by Eric Seidel.

        [chromium] Add allowPlugins callback to allow per-site enabling of plugins
        https://bugs.webkit.org/show_bug.cgi?id=33974

        Add a callback into the FrameLoaderClient to let the embedder enable or
        disable plugins on a per-site basis.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::requestObject):
        * loader/FrameLoaderClient.h:
        (WebCore::FrameLoaderClient::allowPlugins):

2010-01-21  Tony Chang  <tony@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=25501
        Remove empty font tags when applying a style to a content editable
        region.

        Test: editing/execCommand/change-font.html

        * editing/ApplyStyleCommand.cpp:
        (WebCore::isEmptyFontTag):

2010-01-21  Joe Mason  <jmason@rim.com>

        Reviewed by Darin Adler.

        Promote pow argument to double to resolve ambiguous overload (compile fix for RVCT 4.0)
        https://bugs.webkit.org/show_bug.cgi?id=33952

        * platform/graphics/filters/FEComponentTransfer.cpp:
        (WebCore::gamma):

2010-01-21  Andrei Popescu  <andreip@google.com>

        Reviewed by David Levin.

        [Android] bindings/v8/ScriptController.cpp needs to include
        PlatformBridge.h instead of ChromiumBridge.h so that it can
        be used on both Chromium and Android.
        https://bugs.webkit.org/show_bug.cgi?id=33673

        Add "static NPObject* pluginScriptableObject(Widget*);" method
        to PlatformBridge.h
        Include PlatformBridge.h from ScriptController.cpp.

        No new tests, just platform code.

        * bindings/v8/ScriptController.cpp:
        (WebCore::ScriptController::createScriptInstanceForWidget):
        * platform/android/PlatformBridge.h:

2010-01-21  Brady Eidson  <beidson@apple.com>

        Reviewed by Maciej Stachowiak.

        history.back() for same-document history traversals isn't synchronous as the specification states.
        <rdar://problem/7535011> and https://bugs.webkit.org/show_bug.cgi?id=33538

        In resolving https://bugs.webkit.org/show_bug.cgi?id=25570, all history.back()/forward()/go() navigations
        were made asynchronous. That doesn't agree with the HTML5 spec and might have been overreaching for fixing
        that particular bug. In working with the new history state APIs I noticed some things that should've been
        possible were not possible because of this change.

        The change in loading behavior is well covered via modifications to previous tests.

        * loader/RedirectScheduler.cpp:
        (WebCore::RedirectScheduler::scheduleHistoryNavigation): Determine beforehand if the traversal is
          a same-document navigation. If it is, perform the load directly instead of scheduling it.

2010-01-21  Jakub Wieczorek  <faw217@gmail.com>

        Reviewed by Tor Arne Vestbø.

        [Qt] Don't allow Phonon's invisible video widget to keep the app running.
        https://bugs.webkit.org/show_bug.cgi?id=33842

        The change made in r38223 should not be limited to Qt < 4.5 only.

        * platform/graphics/qt/MediaPlayerPrivatePhonon.cpp:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):

2010-01-21  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        HTMLInputElement::valueAsDate setter support for type=datetime.
        https://bugs.webkit.org/show_bug.cgi?id=33939

        Introduce ISODateTime::setMillisecondsSinceEpochForDateTime() and add
        DateTime type support to ISODateTime::toString().

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setValueAsDate):
        * html/ISODateTime.cpp:
        (WebCore::ISODateTime::setMillisecondsSinceEpochForDate):
         Set Invalid to m_type.
        (WebCore::ISODateTime::setMillisecondsSinceEpochForDateTime):
        (WebCore::ISODateTime::setMillisecondsSinceEpochForMonth):
         Set Invalid to m_type.
        (WebCore::ISODateTime::setMillisecondsSinceMidnight):
         Set Invalid to m_type.
        (WebCore::ISODateTime::toString):
         Support DateTime type. This always produces UTC representation.
        * html/ISODateTime.h:

2010-01-21  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Fixed <rdar://problem/7562574> ASSERT in WebCore::removeWrapper() at the
        end of run-webkit-tests
        
        This was an ASSERT-only bug, introduced by isolated worlds, which
        created the novelty of a wrapper that might outlive its wrapper cache.
        
        When a wrapper outlived its wrapper cache, both the wrapper's destructor
        and the wrapper cache's destructor would claim to have uncached the wrapper,
        causing an ASSERT to fire.
        
        The solution is to distinguish between operations that logically add and
        remove cache entries, and operations that delete whole caches. We track
        when a cache entry is logically added, and when it's logically removed,
        independent of whether the actual cache still exists.

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::willCacheWrapper):
        (WebCore::didUncacheWrapper): New names for these functions to help
        explain what they track.

        (WebCore::DOMWrapperWorld::~DOMWrapperWorld): Don't claim to uncache
        all the wrappers in the world; we're deleting the cache, not managing its
        entries.

        (WebCore::cacheDOMObjectWrapper):
        (WebCore::forgetDOMObject):
        (WebCore::forgetDOMNode):
        (WebCore::cacheDOMNodeWrapper):
        (WebCore::forgetAllDOMNodesForDocument):
        (WebCore::forgetWorldOfDOMNodesForDocument):
        (WebCore::takeWrappers):
        (WebCore::updateDOMNodeDocument): Updated for renames.

2010-01-21  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Sam Weinig.

        SVG JS bindings "context" pointer needs to move onto binding impls
        https://bugs.webkit.org/show_bug.cgi?id=27243

        Rewrite SVG DOM JSC bindings to use a global DOMObject <-> SVGElement context map, similar to V8's approach.
        This allows us to remove DOMObjectWithSVGContext and make all SVG JS objects use DOMObjectWithGlobalPointer.
        We're fitting again in JS_CELL_SIZE, and there's no need to special case SVG anymore.

        Not adding a new test, as we have yet to identify how to test that we're passing around correct global objects.
        For now this is just a code cleanup which lets me continue making progress in that area of the code.

        * GNUmakefile.am: Add new DOMObjectWithSVGContext.h to build.
        * WebCore.gypi: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * bindings/js/DOMObjectWithSVGContext.h: Removed.
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::setDOMException): Add comment, that passing 0 context is intentional.
        * bindings/js/JSDOMBinding.h:
        (WebCore::createDOMObjectWrapper): Add to JSSVGContextCache, when creating wrappers.
        (WebCore::getDOMObjectWrapper): Add assertion guarding the JSSVGContextCache is in-sync with the passed context.
        * bindings/js/JSSVGContextCache.h: Added. Maps DOMObjects to SVGElements - just like V8 approachs to this problem.
        (WebCore::JSSVGContextCache::wrapperMap):
        (WebCore::JSSVGContextCache::addWrapper):
        (WebCore::JSSVGContextCache::forgetWrapper):
        (WebCore::JSSVGContextCache::propagateSVGDOMChange): 
        (WebCore::JSSVGContextCache::svgContextForDOMObject):
        * bindings/js/JSSVGLengthCustom.cpp: Retrieve context from cache, instead of taking it from the JS* class.
        (WebCore::JSSVGLength::value):
        (WebCore::JSSVGLength::convertToSpecifiedUnits):
        * bindings/js/JSSVGMatrixCustom.cpp Ditto.:
        (WebCore::JSSVGMatrix::multiply):
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::rotateFromVector):
        * bindings/js/JSSVGPODListCustom.h: Ditto.
        (WebCore::JSSVGPODListCustom::finishGetter):
        (WebCore::JSSVGPODListCustom::finishSetter):
        (WebCore::JSSVGPODListCustom::finishSetterReadOnlyResult):
        (WebCore::JSSVGPODListCustom::clear):
        (WebCore::JSSVGPODListCustom::initialize):
        * bindings/js/JSSVGPODTypeWrapper.h: Ditto.
        (WebCore::JSSVGDynamicPODTypeWrapper::commitChange):
        (WebCore::JSSVGStaticPODTypeWrapper::commitChange):
        (WebCore::JSSVGStaticPODTypeWrapperWithPODTypeParent::commitChange):
        (WebCore::JSSVGStaticPODTypeWrapperWithParent::commitChange):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::create):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::commitChange):
        * bindings/js/JSSVGPathSegCustom.cpp: Ditto.
        (WebCore::toJS):
        * bindings/js/JSSVGPathSegListCustom.cpp: Ditto.
        (WebCore::JSSVGPathSegList::clear):
        (WebCore::JSSVGPathSegList::initialize):
        (WebCore::JSSVGPathSegList::getItem):
        (WebCore::JSSVGPathSegList::insertItemBefore):
        (WebCore::JSSVGPathSegList::replaceItem):
        (WebCore::JSSVGPathSegList::removeItem):
        (WebCore::JSSVGPathSegList::appendItem):
        * bindings/scripts/CodeGeneratorJS.pm:
        * svg/SVGAngle.h: Remove unneeded associatedAttributeName() method.
        * svg/SVGPreserveAspectRatio.h: Ditto.
        * svg/SVGTransform.h: Ditto.

2010-01-21  Kevin Ollivier  <kevino@theolliviers.com>

        Build fix, add missing header.

        * dom/ScriptExecutionContext.cpp:

2010-01-21  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        -webkit-mask-box-image draws a box while loading
        https://bugs.webkit.org/show_bug.cgi?id=33979
        <rdar://problem/7378662>
        
        Don't render masked elements until the mask images are fully loaded.

        Test: http/tests/misc/slow-loading-mask.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::paintMaskImages): Check that all mask images (both the single mask-box-image,
        and the possibly multiple mask-image) are fully loaded before allowing the masked content to render.
        If they are not fully loaded, use a fully transparent transparency layer.
        
        * rendering/style/FillLayer.h:
        * rendering/style/FillLayer.cpp:
        (WebCore::FillLayer::imagesAreLoaded): New utility function that returns true if the image
        in every FillLayer is loaded.

2010-01-21  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        REGRESSION (r52795): New message created in response to mailto: URL has random character in message body
        rdar://problem/7565902

        This regression affects the Mac OS X Mail application.
        I was not able to find a simple way to create a regression test.

        * platform/cf/SharedBufferCF.cpp:
        (WebCore::SharedBuffer::SharedBuffer): Initialize m_size to 0 as in the other constructors.

2010-01-21  Enrica Casucci  <enrica@apple.com>

        Reviewed by Darin Adler.

        Script tags are copied and pasted, making cross-domain attacks possible.
        https://bugs.webkit.org/show_bug.cgi?id=33970

        Tests: editing/pasteboard/paste-noscript-svg.html
               editing/pasteboard/paste-visible-script.html

        We remove the content and the attributes of every script tag before
        pasting into the destination.
        
        * dom/Element.cpp:
        (WebCore::Element::setAttributeMap): Now we are removing xlink:href
        if it contains javascript protocol.
        * html/HTMLParser.cpp:
        (WebCore::HTMLParser::parseToken): We strip all the script tag attributes
        we are parsing to create a fragment to paste.
        * html/HTMLTokenizer.cpp:
        (WebCore::HTMLTokenizer::HTMLTokenizer):
        (WebCore::HTMLTokenizer::scriptHandler): Removes the script text after it was parsed.
        * html/HTMLTokenizer.h:

2010-01-21  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Dirk Schulze.

        <use> with % lengths does not update on window resize
        https://bugs.webkit.org/show_bug.cgi?id=14639

        appendChild broken for symbol-use
        https://bugs.webkit.org/show_bug.cgi?id=24802

        Test: svg/custom/relative-sized-shadow-tree-content-with-symbol.xhtml
              svg/custom/svg/custom/relative-sized-use-on-symbol.xhtml

        Fix reaction on window size changes for relative sized elements within <symbol> elements.
        Don't evaluate SVGUseElement width/height attributes in order to propagate them to the shadow tree,
        instead just propagate the attribute values itself so "100%" remains "100%" instead of being evaluated
        to an absolute pixel value in the parent <svg> user-space.

        Needs another fix in SVGStyledElement::childrenChanged(), which is a regression from my last <use>
        patch, that hasn't been detected, as the use-dynamic-append.svg testcase was broken.

        The combination of all the last <use> patches finally fixes the peepo.co.uk website, which was broken by several bugs for years.

        * svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::childrenChanged): Need to mark shadow trees needing recalcs, even when parsing.
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::svgAttributeChanged): Don't reclone for width/height attribute changes, just propagate them down the render tree
        (WebCore::updateContainerSize): Added helper function, updating the width/height attributes in the shadow tree.
        (WebCore::SVGUseElement::updateContainerSizes):
        (WebCore::SVGUseElement::buildShadowAndInstanceTree): Update container width/height after shadow tree creation, instead of doing it inbetween.
        (WebCore::SVGUseElement::buildShadowTree): Don't alter width/height attributes here anymore.
        (WebCore::SVGUseElement::expandUseElementsInShadowTree): Ditto.
        (WebCore::SVGUseElement::expandSymbolElementsInShadowTree): Ditto.
        * svg/SVGUseElement.h:

2010-01-21  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=33972
        Assertion failure in FrameLoader::checkLoadComplete()

        I couldn't make a test for this, after trying rather hard. I'm not too worried, because such
        a test has to depend on details of current implementation so intimately that it would become
        ineffective very quickly anyway.

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::stopAllLoaders): Stop the check timer, we
        don't need it after aborting load.

2010-01-21  Csaba Osztrogonác  <ossy@webkit.org>

        Reviewed by Dave Hyatt.

        Buildfix for r53646.

        * bindings/js/SerializedScriptValue.cpp: path of JSLock.h fixed.

2010-01-21  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed buildfix after r53644.

        * platform/Scrollbar.cpp:
        (WebCore::Scrollbar::scroll): missing HAVE(ACCESSIBILITY) guard added.

2010-01-21  Darin Fisher  <darin@chromium.org>

        Reviewed by David Levin.

        Unnecessary call to HistoryItem::targetItem in HistoryController::pushState
        https://bugs.webkit.org/show_bug.cgi?id=33969

        * loader/HistoryController.cpp:
        (WebCore::HistoryController::pushState): Remove unnecessary code.

2010-01-21  Dmitry Titov  <dimich@chromium.org>

        Not reviewed, Chromium build fix. Add AccessibilityScrollbar.h and .cpp to WebCore.gypi

        * WebCore.gypi:

2010-01-21  Albert J. Wong  <ajwong@chromium.org>

        [chromium] Unreviewed build fix.

        Fix possible use of initialized variable warning in release mode.

        * bindings/v8/SerializedScriptValue.cpp:
        (WebCore::ZigZag::Deserializer::doDeserialize):

2010-01-21  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt] Unreviewed buildfix after r53644.

        * WebCore.pro: accessibility/AccessibilityScrollbar.cpp and accessibility/AccessibilityScrollbar.h added.

2010-01-21  Dave Hyatt  <hyatt@apple.com>

        Reviewed by Oliver Hunt.

        Make sure to do a JSLock before deserialization of script values, since they can heap allocate.

        * bindings/js/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValueData::deserialize):

2010-01-21  Beth Dakin  <bdakin@apple.com>

        Reviewed by Oliver Hunt.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=33923 REGRESSION 
        (Safari 4): AXValueChanged no longer sent for text area scrollbars
        -and corresponding-
        <rdar://problem/6942686>

        New class AccessibilityScrollbar inherits directly from 
        AccessibilityObject.
        * accessibility/AccessibilityScrollbar.cpp: Added.
        (WebCore::AccessibilityScrollbar::AccessibilityScrollbar):
        (WebCore::AccessibilityScrollbar::create):
        (WebCore::AccessibilityScrollbar::valueForRange):
        * accessibility/AccessibilityScrollbar.h: Added.
        (WebCore::AccessibilityScrollbar::setScrollbar):
        (WebCore::AccessibilityScrollbar::roleValue):
        (WebCore::AccessibilityScrollbar::accessibilityIsIgnored):
        (WebCore::AccessibilityScrollbar::size):
        (WebCore::AccessibilityScrollbar::elementRect):
        (WebCore::AccessibilityScrollbar::parentObject):

        AXObjectCache::getOrCreate() now has a case for ScrollBarRole, 
        which will create a new AccessibilityScrollbar. I also added a new 
        version of postNotification() that does not require a renderer. The 
        old postNotification() calls the new one.
        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::getOrCreate):
        (WebCore::AXObjectCache::postNotification):
        * accessibility/AXObjectCache.h:

        When AX is enabled, getOrCreate an AccessibilityScrollbar and send 
        a notification.
        * platform/Scrollbar.cpp:
        (WebCore::Scrollbar::scroll):

        Fix project files.
        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:

2010-01-21  Eric Uhrhane  <ericu@chromium.org>

        Reviewed by Dmitry Titov.

        Add changes missing from r53595, without which Chromium has no database.

        https://bugs.webkit.org/show_bug.cgi?id=33966

        No new tests - fixes database layout tests in Chromium.

        * bindings/v8/RuntimeEnabledFeatures.cpp:
        * bindings/v8/RuntimeEnabledFeatures.h:

2010-01-21  Jakob Petsovits  <jpetsovits@rim.com>

        Reviewed by Adam Treat.

        Don't call vgGetError()/eglGetError() repeatedly
        https://bugs.webkit.org/show_bug.cgi?id=33959

        For vgGetError(), I missed the part of the spec where
        it says that calling that function clears the error
        and subsequent calls will return VG_NO_ERROR again.

        For eglGetError(), the specification doesn't mention
        that kind of behavior, and interpretations seem to
        differ between EGL implementations (even within
        Khronos: the OpenVG reference implementation doesn't
        reset the error code - and even mentions the difference
        to vgGetError() in a comment - whereas the online
        OpenGL ES API document explicitly specifies clearing
        the error code).

        It thus makes sense not to call either of the two
        error functions more than once for checking a single
        EGL/OpenVG call. This patch adapts assertions to
        accommodate for this behavior, and also needs to
        change surface creation methods as they previously
        relied on multiple calls of eglGetError().

        * platform/graphics/openvg/EGLDisplayOpenVG.cpp:
        (WebCore::EGLDisplayOpenVG::sharedPlatformSurface):
        (WebCore::EGLDisplayOpenVG::createPbufferSurface):
        * platform/graphics/openvg/EGLDisplayOpenVG.h:
        * platform/graphics/openvg/EGLUtils.h:
        * platform/graphics/openvg/SurfaceOpenVG.cpp:
        (WebCore::SurfaceOpenVG::SurfaceOpenVG):
        * platform/graphics/openvg/SurfaceOpenVG.h:
        * platform/graphics/openvg/VGUtils.h:

2010-01-20  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt.

        Hit testing on composited plugins is broken
        https://bugs.webkit.org/show_bug.cgi?id=33927
        <rdar://problem/7559069>

        RenderWidget::paint()'s strategy of moving widgets at paint time, using tx and ty, was flawed
        because tx,ty are not always root-relative, especially when painting into compositing layers.
        This would move widgets to the wrong location, which caused hit testing issues.
        
        Widgets are usually positioned by layout. The one time this was not true was scrolling fixed-position
        elements, so we now reposition widgets after scrolling too.
        
        There was a related problem, which was that widgets expect the graphics context to be set up for
        root-relative painting. To fix this, adjust the CTM and the paintRect when the widget's frameRect
        is in a different coordinate system to the painting offset.
        
        Test: plugins/mouse-events-fixedpos.html

        * page/FrameView.cpp:
        (WebCore::FrameView::scrollPositionChanged): Update widget positions, to handle widgets in fixed position
        elements, but only if we're not already inside of layout.

        * platform/graphics/GraphicsContext.h:
        (WebCore::GraphicsContext::translate): Add a translate() convenience method that takes a FloatSize.

        * platform/graphics/IntSize.h:
        (WebCore::IntSize::isZero): Add a convenience method for testing for a zero size.

        * platform/mac/WidgetMac.mm:
        (WebCore::Widget::paint): Adjust a comment.

        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::paint): Detect when the widget's frame is in a different coordinate system
        to painting, and adjust the CTM and paintRect in that case.

2010-01-21  Andrei Popescu  <andreip@google.com>

        Reviewed by David Levin.

        [Android] bindings/v8/NPV8Object.cpp does not compile on Android
        https://bugs.webkit.org/show_bug.cgi?id=33608

        Use the standard WebKit header in bridge/npruntime.h.
        Include PlatformBridge.h instead of ChroimiumBridge.h.
        Add popupsAllowed() method to PlatformBridge.h on Android.
        Add ARRAYSIZE_UNSAFE to PlatformBridge.h on Android.

        No new tests, fixing the build.

        * bindings/v8/NPV8Object.cpp:
        (_NPN_Evaluate):
        * bindings/v8/NPV8Object.h:
        * platform/android/PlatformBridge.h:

2010-01-21  Andrei Popescu  <andreip@google.com>

        Reviewed by David Levin.

        Add PlatformBridge.h header and a typedef to give ChromiumBridge a new name: PlatformBridge.
        https://bugs.webkit.org/show_bug.cgi?id=33917

        No new tests needed, this is just to allow other methods to call ChromiumBridge
        using the new 'PlatformBridge' name.

        * platform/chromium/PlatformBridge.h: Added.

2010-01-21  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt] Unreviewed buildfix after r53625.

        Cleanup MediaPlayer and MediaPlayerPrivateInterface to remove dead methods
        https://bugs.webkit.org/show_bug.cgi?id=30106

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::paintMediaSliderTrack):

2010-01-21  Andrei Popescu  <andreip@google.com>

        Reviewed by David Levin.

        [Android] bindings/v8/V8DOMWrapper.h[cpp] are missing guards for XPATH and XSLT features
        https://bugs.webkit.org/show_bug.cgi?id=33944

        Inside V8DOMWrapper.h[cpp], the code for XPATH and XSLT features is not guarded
        by the appropriate #if ENABLE(feature) macros. Add the missing guards.
        V8DOMWrapper.cpp includes ChromiumBridge.h for no reason. Remove the include.

        No new tests needed, functionality not changed.

        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore::V8DOMWrapper::getTemplate):
        * bindings/v8/V8DOMWrapper.h:

2010-01-21  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Darin Adler.

        Intermittent crash when media element is adopted by another document
        https://bugs.webkit.org/show_bug.cgi?id=33919
        rdar://problem/7557527
        
        Test: media/adopt-node-crash.html

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::willMoveToNewOwnerDocument): Unregister for
        document callbacks.
        (WebCore::HTMLMediaElement::didMoveToNewOwnerDocument): Register for
        document callbacks.
        * html/HTMLMediaElement.h:

2010-01-21  Adam Roben  <aroben@apple.com>

        More Windows build fixing

        * WebCore.vcproj/WebCore.vcproj: Copy bridge/jsc in the post-build
        event of all configurations, not just Debug.

2010-01-21  Thiago Macieira  <thiago.macieira@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Fix incorrect dependency to QtXmlPatterns in generated include/QtWebKit/QtWebKit header

        The generated file includes QtXmlPatterns/QtXmlPatterns, which is neither used/required by
        the public QtWebKit API nor will it be available if Qt is configured with -no-xmlpatterns.

        * WebCore.pro: Trick syncqt to believe that xmlpatterns is not a dependency, so that it's not
        included in the generated file. It'll still be used and linked to with this trick.

2010-01-21  Steve Block  <steveblock@google.com>

        Unreviewed build fix.

        Copy BridgeJSC.h to generated headers on Windows

        No new tests, build fix only.

        * WebCore.vcproj/WebCore.vcproj:

2010-01-21  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Darin Adler.

        Cleanup MediaPlayer and MediaPlayerPrivateInterface to remove dead methods
        https://bugs.webkit.org/show_bug.cgi?id=30106

        No new tests, only dead code was removed.

        * platform/graphics/MediaPlayer.cpp:
        * platform/graphics/MediaPlayer.h:
        * platform/graphics/MediaPlayerPrivate.h:
        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.h:
        * platform/graphics/mac/MediaPlayerPrivateQTKit.h:
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        * platform/graphics/qt/MediaPlayerPrivatePhonon.cpp:
        * platform/graphics/qt/MediaPlayerPrivatePhonon.h:
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.cpp:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::currentTime):
        (WebCore::MediaPlayerPrivate::doSeek):
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.h:
        * platform/graphics/wince/MediaPlayerPrivateWince.h:

2010-01-21  Iain Campbell <iain.campbell@accenture.com>

        Reviewed by Simon Hausmann.

        [Qt] Simplify the qmake code for freezing QtWebKit on Symbian.

        * WebCore.pro:

2010-01-21  Steve Block  <steveblock@google.com>

        Unreviewed speculative build fix for Windows.

        Adds missing include path for JSCBridge.h on Windows, added in http://trac.webkit.org/changeset/53620

        No new tests, build fix only.

        * WebCore.vcproj/WebCoreCommon.vsprops:

2010-01-21  Steve Block  <steveblock@google.com>

        Unreviewed build fix.

        Adds missing include path for JSCBridge.h, added in http://trac.webkit.org/changeset/53620

        No new tests, build fix only.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:

2010-01-21  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Move bridge interfaces Field, Class, Instance and Array from Bridge to BridgeJSC
        https://bugs.webkit.org/show_bug.cgi?id=33589

        These interfaces use JSC-specific types, so are moved out of Bridge.h to allow the file to
        be used with both JSC and V8.

        No new tests, refactoring only.

        * Android.jscbindings.mk: Modified. Removed Bridge.cpp and added BridgeJSC.cpp
        * GNUmakefile.am: Modified. Removed Bridge.cpp and added BridgeJSC.[cpp|h]
        * WebCore.pro: Modified. Removed Bridge.cpp and added BridgeJSC.[cpp|h]
        * WebCore.xcodeproj/project.pbxproj: Modified. Removed Bridge.cpp and added BridgeJSC.[cpp|h]
        * WebCoreSources.bkl: Modified. Removed Bridge.cpp and added BridgeJSC.cpp
        * bridge/Bridge.cpp: Removed.
        * bridge/Bridge.h: Modfied. Moved Field, Class, Instance and Array interfaces to BridgeJSC.h
        * bridge/jsc: Added.
        * bridge/jsc/BridgeJSC.cpp: Copied from WebCore/bridge/Bridge.cpp.
        * bridge/jsc/BridgeJSC.h: Copied from WebCore/bridge/Bridge.h.

2010-01-21  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Fixes style in WebCore/bridge/jni/JNIBridge
        https://bugs.webkit.org/show_bug.cgi?id=33914

        No new tests, style fixes only.

        * bridge/jni/JNIBridge.cpp:
        * bridge/jni/JNIBridge.h:

2010-01-13  Philippe Normand  <pnormand@igalia.com>

        Reviewed by Oliver Hunt.

        [GTK] handle media redirections
        https://bugs.webkit.org/show_bug.cgi?id=33539

        Media redirections support.

        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.cpp:
        (WebCore::mediaPlayerPrivateMessageCallback):
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::~MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::mediaLocationChanged):
        (WebCore::MediaPlayerPrivate::loadNextLocation):
        * platform/graphics/gtk/MediaPlayerPrivateGStreamer.h:
        (WebCore::MediaPlayerPrivate::pipelineReset):

2010-01-21  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Antti Koivisto.

        [Qt] Implement GraphicsLayer for accelerated layer compositing
        https://bugs.webkit.org/show_bug.cgi?id=33514

        No new tests: tests in LayoutTests/compositing are now relevant for
        QtWebkit!

        * WebCore.pro: added accelerated-compositing related files 
        * platform/graphics/GraphicsLayer.h: define Qt-specific implementation           of GraphicsLayer
        * platform/graphics/qt/GraphicsLayerQt.cpp: Added.
        (WebCore::GraphicsLayerQtImpl::): Implementation of GraphicsLayer with
        a QGraphicsItem
        (WebCore::GraphicsLayerQtImpl::ContentData::ContentData): save 
        pixmap/color info for directly composited content
        (WebCore::GraphicsLayerQtImpl::State::State): save info for syncing
        (WebCore::GraphicsLayerQtImpl::GraphicsLayerQtImpl): ctor
        (WebCore::GraphicsLayerQtImpl::~GraphicsLayerQtImpl): dtor
        (WebCore::GraphicsLayerQtImpl::setBaseTransform): set Qt
        transformation in the way WebCore wants it
        (WebCore::GraphicsLayerQtImpl::opaqueArea): calculate opaque area
        based on info we have
        (WebCore::GraphicsLayerQtImpl::boundingRect): reimp QGraphicsItem
        (WebCore::GraphicsLayerQtImpl::paint): reimp QGraphicsItem
        (WebCore::GraphicsLayerQtImpl::drawContents): draw HTML/Pixmap/Color
        (WebCore::GraphicsLayerQtImpl::notifyChange): let WebCore know
        something has changed
        (WebCore::GraphicsLayerQtImpl::flushChanges): Make the changes appear
        on screen by setting them to QGraphicsItems
        (WebCore::GraphicsLayerQtImpl::notifyAnimationStarted): let WebCore
        know the QAnimation started
        (WebCore::GraphicsLayerQt::GraphicsLayerQt): ctor
        (WebCore::GraphicsLayerQt::~GraphicsLayerQt): dtor
        (WebCore::GraphicsLayer::create): hook for WebCore to know we're
        implementing compositing
        (WebCore::GraphicsLayer::compositingCoordinatesOrientation): hook for
        WebCore to know we use a top-down system
        (WebCore::GraphicsLayerQt::setNeedsDisplay): update the display
        (WebCore::GraphicsLayerQt::setNeedsDisplayInRect): udpate part of the
        display
        (WebCore::GraphicsLayerQt::setName): reimp
        (WebCore::GraphicsLayerQt::setParent): reimp
        (WebCore::GraphicsLayerQt::setChildren): reimp
        (WebCore::GraphicsLayerQt::addChild): reimp
        (WebCore::GraphicsLayerQt::addChildAtIndex): reimp
        (WebCore::GraphicsLayerQt::addChildAbove): reimp
        (WebCore::GraphicsLayerQt::addChildBelow): reimp
        (WebCore::GraphicsLayerQt::replaceChild): reimp
        (WebCore::GraphicsLayerQt::removeFromParent): reimp
        (WebCore::GraphicsLayerQt::setMaskLayer): reimp
        (WebCore::GraphicsLayerQt::setPosition): reimp
        (WebCore::GraphicsLayerQt::setAnchorPoint): reimp
        (WebCore::GraphicsLayerQt::setSize): reimp
        (WebCore::GraphicsLayerQt::setTransform): reimp
        (WebCore::GraphicsLayerQt::setChildrenTransform): reimp
        (WebCore::GraphicsLayerQt::setPreserves3D): reimp
        (WebCore::GraphicsLayerQt::setMasksToBounds): reimp
        (WebCore::GraphicsLayerQt::setDrawsContent): reimp
        (WebCore::GraphicsLayerQt::setBackgroundColor): reimp
        (WebCore::GraphicsLayerQt::clearBackgroundColor): reimp
        (WebCore::GraphicsLayerQt::setContentsOpaque): reimp
        (WebCore::GraphicsLayerQt::setBackfaceVisibility): reimp
        (WebCore::GraphicsLayerQt::setOpacity): reimp
        (WebCore::GraphicsLayerQt::setContentsRect): reimp
        (WebCore::GraphicsLayerQt::setContentsToImage): reimp
        (WebCore::GraphicsLayerQt::setContentsBackgroundColor): reimp
        (WebCore::GraphicsLayerQt::setGeometryOrientation): reimp
        (WebCore::GraphicsLayerQt::setContentsOrientation): reimp
        (WebCore::GraphicsLayerQt::distributeOpacity): reimp
        (WebCore::GraphicsLayerQt::accumulatedOpacity): reimp
        (WebCore::GraphicsLayerQt::syncCompositingState): reimp
        (WebCore::GraphicsLayerQt::nativeLayer): reimp (QGraphicsItem*)
        (WebCore::GraphicsLayerQt::platformLayer): reimp (QGraphicsItem*)
        (WebCore::solveEpsilon): copy from AnimationBase.cpp
        (WebCore::solveCubicBezierFunction): copy from AniamtionBase.cpp
        (WebCore::applyTimingFunction): use WebCore's timing and not Qt's
        (WebCore::webkitAnimationToQtAnimationValue): safely figure out
        animation values
        (WebCore::AnimationQtBase::AnimationQtBase): base class for Qt-based
        Webcore-initiated animations
        (WebCore::AnimationQtBase::updateState): notify when an animation
        starts
        (WebCore::AnimationQtBase::duration): reimp QAbstractAnimation
        (WebCore::AnimationQt:::AnimationQtBase):
        (WebCore::AnimationQt::updateCurrentTime): realize keyframes from
        progress
        (WebCore::TransformAnimationQt::TransformAnimationQt): ctor
        (WebCore::TransformAnimationQt::~TransformAnimationQt): dtor
        (WebCore::TransformAnimationQt::applyFrame): set the actual QTransform
        based on WebCore TransformOperations
        (WebCore::TransformAnimationQt::updateState): change cache mode
        (WebCore::OpacityAnimationQt::OpacityAnimationQt):
        (WebCore::OpacityAnimationQt::applyFrame): change item's opacity
        (WebCore::OpacityAnimationQt::updateState):
        (WebCore::GraphicsLayerQt::addAnimation): convert WebCore Animation to
        Qt Animation
        (WebCore::GraphicsLayerQt::removeAnimationsForProperty):
        (WebCore::GraphicsLayerQt::removeAnimationsForKeyframes):
        (WebCore::GraphicsLayerQt::pauseAnimation):
        (WebCore::GraphicsLayerQt::suspendAnimations):
        (WebCore::GraphicsLayerQt::resumeAnimations):
        * platform/graphics/qt/GraphicsLayerQt.h: Added.
        * platform/qt/QWebPageClient.h: virtual functions for QGraphicsWebView
        compositing
        (QWebPageClient::setRootGraphicsLayer): let QGraphicsWebView know that
        compositing has started/ended
        (QWebPageClient::markForSync): let QGraphicsWebView know the
        compositing layers need to sync, either soon or with the next update

2010-01-21  No'am Rosenthal  <noam.rosenthal@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Adding QPixmap/QImage support for the Qt hybrid layer
        Allows accesing QPixmap and QImage based arguments from Qt signals,
        slots and properties
        This is done by an intermediate object that can be turned into
        web-based objects by calling either toHTMLImageElement() or
        toDataURL()
        https://bugs.webkit.org/show_bug.cgi?id=32461

        Tests are in WebKit/qt/tests/hybridPixmap

        * WebCore.pro:
        * bridge/qt/qt_pixmapruntime.cpp: Added.
        (JSC::Bindings::QtPixmapWidthField::name): "width"
        (JSC::Bindings::QtPixmapWidthField::valueFromInstance): width of
        pixmap
        (JSC::Bindings::QtPixmapWidthField::setValueToInstance): nothing
        (JSC::Bindings::QtPixmapHeightField::name): "height"
        (JSC::Bindings::QtPixmapHeightField::valueFromInstance): height of
        pixmap
        (JSC::Bindings::QtPixmapHeightField::setValueToInstance): nothing
        (JSC::Bindings::QtPixmapRuntimeMethod::numParameters): 0
        (JSC::Bindings::QtPixmapCreateElementMethod::name): toHTMLImageElement
        (JSC::Bindings::QtPixmapCreateElementMethod::invoke): creates an HTML
        element from the QPixmap
        (JSC::Bindings::QtPixmapToDataUrlMethod::name): "toDataURL"
        (JSC::Bindings::QtPixmapToDataUrlMethod::invoke): encodes the image to
        a base64 data url
        (JSC::Bindings::QtPixmapToStringMethod::name): "toString"
        (JSC::Bindings::QtPixmapToStringMethod::invoke): [Qt Native Pixmap
        w,h]

        (JSC::Bindings::QtPixmapRuntimeObjectImp::createStructure):
        runtime-object broilerplate
        (JSC::Bindings::QtPixmapRuntimeObjectImp::classInfo): ditto
        (JSC::Bindings::QtPixmapRuntimeObjectImp::QtPixmapRuntimeObjectImp):
        ditto
        (JSC::Bindings::): ditto
        (JSC::Bindings::QtPixmapClass::QtPixmapClass): class for the
        intermediate pixmap-holder 
        (JSC::Bindings::QtPixmapInstance::getClass): ditto
        (JSC::Bindings::QtPixmapInstance::invokeMethod): ditto
        (JSC::Bindings::QtPixmapClass::methodsNamed): toHTMLImageElement,
        toDataURL
        (JSC::Bindings::QtPixmapClass::fieldNamed): width, height
        (JSC::Bindings::QtPixmapInstance::getPropertyNames):
                toHTMLImageElement, toDataURL, width, height
        (JSC::Bindings::QtPixmapInstance::defaultValue): nothing
        (JSC::Bindings::QtPixmapInstance::valueOf): toString
        (JSC::Bindings::data): holds a QVariant of type QImage/QPixmap
        (JSC::Bindings::QtPixmapInstance::width): width of the image/pixmap
        (JSC::Bindings::QtPixmapInstance::height): height of the image/pixmap
        (JSC::Bindings::QtPixmapInstance::toPixmap): converts to a QPixmap
        (JSC::Bindings::QtPixmapInstance::toImage): converts to a QImage
        (JSC::Bindings::QtPixmapInstance::variantFromObject): makes sure this
        is the right type of object, and creates a QVariant
        (JSC::Bindings::QtPixmapInstance::createRuntimeObject): creates a new
        intermediate pixmap holder from a QVariant
        (JSC::Bindings::QtPixmapInstance::canHandle): returns true if a
        QPixmap/QImage is required
        * bridge/qt/qt_pixmapruntime.h: Added.
        * bridge/qt/qt_runtime.cpp: hooks for the bridge
        (JSC::Bindings::convertValueToQVariant): handle QPixmap/QImage if the
        object is the intermediate pixmap holder or an HTMLImageElement
        (JSC::Bindings::convertQVariantToValue): creates the intermediate
        object from a QVariant of type QImage/QPixmap

2010-01-21  Luiz Agostini  <luiz.agostini@openbossa.org>

        Reviewed by Kenneth Rohde Christiansen.

        [Qt] Custom select popups.
        https://bugs.webkit.org/show_bug.cgi?id=33418

        Optimization of the WebCore support to combobox popup delegate.

        * platform/qt/PopupMenuQt.cpp:
        (WebCore::PopupMenu::show):
        * platform/qt/QtAbstractWebPopup.cpp:
        (WebCore::QtAbstractWebPopup::QtAbstractWebPopup):
        (WebCore::QtAbstractWebPopup::itemType):
        * platform/qt/QtAbstractWebPopup.h:
        (WebCore::QtAbstractWebPopup::):
        (WebCore::QtAbstractWebPopup::itemText):
        (WebCore::QtAbstractWebPopup::itemToolTip):
        (WebCore::QtAbstractWebPopup::itemIsEnabled):
        (WebCore::QtAbstractWebPopup::itemCount):
        (WebCore::QtAbstractWebPopup::view):
        (WebCore::QtAbstractWebPopup::geometry):
        (WebCore::QtAbstractWebPopup::currentIndex):
        (WebCore::QtAbstractWebPopup::font):

2010-01-20  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        Stylesheet href property shows redirected URL unlike other browsers
        https://bugs.webkit.org/show_bug.cgi?id=33683

        Teach StyleSheet the difference between original and final URLs in
        redirect chains.  Unfortunately, StyleSheet needs to know both of these
        URLs.  The original URL is needed for the href property and the final
        URL is needed as the baseURL.

        This change required touching a lot of lines of code because we need to
        plumb this information to the StyleSheet object.  I audited all
        existing clients of href() and setHref() to see whether they wanted the
        original or final URLs.  I then updated the clients (except the JS
        bindings themselves) to use the correct accessor.

        Test: http/tests/security/stylesheet-href-redirect.html

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::setCSSStyleSheet):
        (WebCore::CSSImportRule::insertedIntoParent):
        * css/CSSImportRule.h:
        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::CSSStyleSheet):
        * css/CSSStyleSheet.h:
        (WebCore::CSSStyleSheet::create): 
        (WebCore::CSSStyleSheet::createInline): Added a new constructor to deal
        with "inline" style sheets that don't have a distinct original and
        final URL.
        * css/StyleBase.cpp:
        (WebCore::StyleBase::baseURL): This code wants to use the final URL,
        not the original URL.  Updated it to grab the baseURL directly.
        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::StyleSheet):
        * css/StyleSheet.h:
        (WebCore::StyleSheet::href):
        (WebCore::StyleSheet::setBaseURL): This function really just updates
        the base URL of the style sheet, so I made it more explicit.
        (WebCore::StyleSheet::putativeBaseURL): We need an accessor for the
        base URL, but baseURL is already taken.
        * dom/Document.cpp:
        (WebCore::Document::updateBaseURL):
        (WebCore::Document::pageUserSheet):
        (WebCore::Document::pageGroupUserSheets):
        (WebCore::Document::elementSheet):
        (WebCore::Document::mappedElementSheet):
        * dom/ProcessingInstruction.cpp:
        (WebCore::ProcessingInstruction::checkStyleSheet):
        (WebCore::ProcessingInstruction::setCSSStyleSheet):
        (WebCore::ProcessingInstruction::setXSLStyleSheet):
        * dom/ProcessingInstruction.h:
        * dom/StyleElement.cpp:
        (WebCore::StyleElement::createSheet):
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::setCSSStyleSheet):
        * html/HTMLLinkElement.h:
        * loader/CachedCSSStyleSheet.cpp:
        (WebCore::CachedCSSStyleSheet::didAddClient):
        (WebCore::CachedCSSStyleSheet::checkNotify): This code now passes both
        the original and final URL into setCSSStyleSheet so that the style
        sheet can have both.
        * loader/CachedResourceClient.h:
        (WebCore::CachedResourceClient::setCSSStyleSheet):
        (WebCore::CachedResourceClient::setXSLStyleSheet):
        * loader/CachedXSLStyleSheet.cpp:
        (WebCore::CachedXSLStyleSheet::didAddClient):
        (WebCore::CachedXSLStyleSheet::checkNotify): I don't have any direct
        evidence that we need to change the XSLStyleSheet behavior, which is
        why I wasn't able to add a test for the behavior.  However, the objects
        are parallel enough that it seemed like the right thing to do.
        * xml/XSLImportRule.cpp:
        (WebCore::XSLImportRule::setXSLStyleSheet):
        (WebCore::XSLImportRule::loadSheet):
        * xml/XSLImportRule.h:
        * xml/XSLStyleSheet.h:
        (WebCore::XSLStyleSheet::create):
        (WebCore::XSLStyleSheet::createEmbedded):
        * xml/XSLStyleSheetLibxslt.cpp:
        (WebCore::XSLStyleSheet::XSLStyleSheet):
        (WebCore::XSLStyleSheet::parseString):
        (WebCore::XSLStyleSheet::loadChildSheets):
        * xml/XSLStyleSheetQt.cpp:
        (WebCore::XSLStyleSheet::XSLStyleSheet):
        * xml/XSLTProcessorLibxslt.cpp:
        (WebCore::xsltStylesheetPointer):
        * xml/XSLTProcessorQt.cpp:
        (WebCore::XSLTProcessor::transformToString):

2010-01-20  Kwang Yul Seo  <skyul@company100.net>

        Reviewed by Alexey Proskuryakov.

        Use xmlStrdup instead of strdup for consistency in Libxml2.
        https://bugs.webkit.org/show_bug.cgi?id=33935

        Remove the direct use of strdup.

        * dom/XMLTokenizerLibxml2.cpp:
        (WebCore::PendingCallbacks::appendErrorCallback):
        (WebCore::PendingCallbacks::):
        (WebCore::XMLTokenizer::error):

2010-01-20  Oliver Hunt  <oliver@apple.com>

        Reviewed by Dan Bernstein.

        Insufficient repaint issues with html embedded in foreignObject
        https://bugs.webkit.org/show_bug.cgi?id=16318

        Final part of fix -- now we render the selection rect of list
        markers in a transformed context.

        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::localSelectionRect):
        (WebCore::RenderListMarker::paint):
        * rendering/RenderListMarker.h:

2010-01-20  Daniel Bates  <dbates@webkit.org>

        No review, rolling out 53591.
        http://trac.webkit.org/changeset/53591
        https://bugs.webkit.org/show_bug.cgi?id=29564

        Rolling out the change committed in change set 53591
        <http://trac.webkit.org/changeset/53591> because it caused
        a regression of test /fast/replaced/table-percent-height.html
        on the Qt bot.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::adjustButtonStyle):

2010-01-20  Stephen White  <senorblanco@chromium.org>

        Reviewed by David Levin.

        Disable the "seatbelt" coordinate validation functions in the
        Skia graphics layer.  We believe all the underlying bugs have
        been fixed, but just in case we're being overly optimistic, this
        leaves in the code for an easy revert.

        https://bugs.webkit.org/show_bug.cgi?id=33908
        Exercised by many layout tests.

        * platform/graphics/skia/GraphicsContextSkia.cpp:

2010-01-20  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        HTMLInputElement::valueAsDate setter support for type=date.
        https://bugs.webkit.org/show_bug.cgi?id=33911

        Introduce ISODateTime::setMillisecondsSinceEpochForDate() and add Date
        type support to ISODateTime::toString().

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setValueAsDate):
        * html/ISODateTime.cpp:
        (WebCore::ISODateTime::setMillisecondsSinceEpochForDate):
        (WebCore::ISODateTime::toString):
        * html/ISODateTime.h:

2010-01-20  Ben Murdoch  <benm@google.com>

        Reviewed by Simon Hausmann.

        Touch Events are not sent to iframes
        https://bugs.webkit.org/show_bug.cgi?id=33894

        Fix the touch event handler so it does not bail out early if the main frame document does not have any touch listeners registered, as there may be embedded iframes that have registered for touch events.

        Test: fast/events/touch/touch-inside-iframe.html

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleTouchEvent): Instead of looking at the document of the main frame to see if touch event listeners are registered, look at the document of the target element to account for iframes.

2010-01-20  Michael Nordman  <michaeln@google.com>

        Reviewed by Alexey Proskuryakov.

        Remove an assertion that is not valid in some detached iframes cases.
        https://bugs.webkit.org/show_bug.cgi?id=33827

        Test: http/tests/appcache/detached-iframe.html

        * loader/appcache/DOMApplicationCache.cpp:
        (WebCore::DOMApplicationCache::DOMApplicationCache):

2010-01-20  Eric Uhrhane  <ericu@chromium.org>

        Reviewed by Dmitry Titov.

        Refactoring and plumbing to get the HTML5 SQL Database API accessible to
        web workers.  No new functionality is exposed yet; this just gets the
        infrastructure in place.  It touches a lot of files in small ways; here
        are the main changes:

        1) Database members and methods move from Document up to
        ScriptExecutionContext.  Each of Document and WorkerContext must
        implement a few virtual methods where the Database code requires
        differentiation.
        2) Worker thread shutdown got changed a bunch to handle Database cleanup
        and thread synchronization issues.  Database cleanup tasks need to post
        some cleanup tasks to the JavaScript thread.  However, since database
        cleanup may happen due to the destruction of the WorkerThread, I added a
        handshake [involving WorkerThreadShutdownStartTask,
        WorkerThreadShutdownFinishTask, and a DatabaseTaskSynchronizer] between
        the Database thread and WorkerThread that cleans up all the Database
        stuff before the WorkerThread's runLoop can exit.
        3) The runtime enabler for the Database moved to a static variable
        accessible through Database::isAvailable, following the model used by
        WebSocket.
        4) Worker threads don't run their JavaScript on the Main thread, so
        Database code that differentiated between the Main thread and the
        Database thread now need to deal with a third possibility.
        5) Most of the other changes have to do with having a
        ScriptExecutionContext pointer instead of a Document pointer when
        dealing with a Database.  In many cases it's just a string replacement,
        but in some it required the creation of a new virtual function [e.g.
        databaseExceededQuota, isDatabaseReadOnly]

        https://bugs.webkit.org/show_bug.cgi?id=22725

        No new tests; in a future patch I'll add JSC and V8 bindings and new
        layout tests to exercise them.

        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::V8DOMWindow::OpenDatabaseEnabled):
        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::~Document):
        (WebCore::Document::isDatabaseReadOnly):
        (WebCore::Document::databaseExceededQuota):
        (WebCore::Document::isContextThread):
        * dom/Document.h:
        * dom/ScriptExecutionContext.cpp:
        (WebCore::ScriptExecutionContext::ScriptExecutionContext):
        (WebCore::ScriptExecutionContext::~ScriptExecutionContext):
        (WebCore::ScriptExecutionContext::databaseThread):
        (WebCore::ScriptExecutionContext::addOpenDatabase):
        (WebCore::ScriptExecutionContext::removeOpenDatabase):
        (WebCore::ScriptExecutionContext::stopDatabases):
        * dom/ScriptExecutionContext.h:
        (WebCore::ScriptExecutionContext::setHasOpenDatabases):
        (WebCore::ScriptExecutionContext::hasOpenDatabases):
        (WebCore::ScriptExecutionContext::Task::isCleanupTask):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::stopLoading):
        * storage/Database.cpp:
        (WebCore::Database::setIsAvailable):
        (WebCore::Database::isAvailable):
        (WebCore::Database::openDatabase):
        (WebCore::Database::Database):
        (WebCore::DerefContextTask::create):
        (WebCore::DerefContextTask::performTask):
        (WebCore::DerefContextTask::isCleanupTask):
        (WebCore::Database::~Database):
        (WebCore::Database::openAndVerifyVersion):
        (WebCore::Database::markAsDeletedAndClose):
        (WebCore::ContextRemoveOpenDatabaseTask::create):
        (WebCore::ContextRemoveOpenDatabaseTask::performTask):
        (WebCore::ContextRemoveOpenDatabaseTask::isCleanupTask):
        (WebCore::ContextRemoveOpenDatabaseTask::ContextRemoveOpenDatabaseTask):
        (WebCore::Database::close):
        (WebCore::Database::performOpenAndVerify):
        (WebCore::Database::scheduleTransaction):
        (WebCore::Database::scheduleTransactionStep):
        (WebCore::DeliverPendingCallbackTask::create):
        (WebCore::DeliverPendingCallbackTask::performTask):
        (WebCore::DeliverPendingCallbackTask::DeliverPendingCallbackTask):
        (WebCore::Database::scheduleTransactionCallback):
        (WebCore::Database::transactionClient):
        (WebCore::Database::transactionCoordinator):
        (WebCore::Database::tableNames):
        (WebCore::Database::securityOrigin):
        * storage/Database.h:
        (WebCore::Database::scriptExecutionContext):
        * storage/DatabaseTask.h:
        * storage/DatabaseThread.cpp:
        (WebCore::DatabaseThread::DatabaseThread):
        (WebCore::DatabaseThread::~DatabaseThread):
        (WebCore::DatabaseThread::requestTermination):
        (WebCore::DatabaseThread::databaseThread):
        (WebCore::DatabaseThread::unscheduleDatabaseTasks):
        * storage/DatabaseThread.h:
        * storage/DatabaseTracker.cpp:
        (WebCore::DatabaseTracker::canEstablishDatabase):
        (WebCore::DatabaseTracker::getMaxSizeForDatabase):
        * storage/DatabaseTracker.h:
        * storage/SQLTransaction.cpp:
        (WebCore::SQLTransaction::executeSQL):
        * storage/SQLTransactionClient.cpp:
        (WebCore::SQLTransactionClient::didCommitTransaction):
        (WebCore::SQLTransactionClient::didExecuteStatement):
        (WebCore::SQLTransactionClient::didExceedQuota):
        * storage/chromium/DatabaseTrackerChromium.cpp:
        (WebCore::DatabaseTracker::canEstablishDatabase):
        (WebCore::DatabaseTracker::addOpenDatabase):
        (WebCore::TrackerRemoveOpenDatabaseTask::create):
        (WebCore::TrackerRemoveOpenDatabaseTask::performTask):
        (WebCore::TrackerRemoveOpenDatabaseTask::TrackerRemoveOpenDatabaseTask):
        (WebCore::DatabaseTracker::removeOpenDatabase):
        (WebCore::DatabaseTracker::getMaxSizeForDatabase):
        * storage/chromium/SQLTransactionClientChromium.cpp:
        (WebCore::NotifyDatabaseChangedTask::create):
        (WebCore::NotifyDatabaseChangedTask::performTask):
        (WebCore::NotifyDatabaseChangedTask::NotifyDatabaseChangedTask):
        (WebCore::SQLTransactionClient::didCommitTransaction):
        (WebCore::SQLTransactionClient::didExecuteStatement):
        (WebCore::SQLTransactionClient::didExceedQuota):
        * workers/WorkerContext.cpp:
        (WebCore::WorkerContext::openDatabase):
        (WebCore::WorkerContext::isContextThread):
        * workers/WorkerContext.h:
        (WebCore::WorkerContext::clearScript):
        (WebCore::WorkerContext::thread):
        (WebCore::WorkerContext::isDatabaseReadOnly):
        (WebCore::WorkerContext::databaseExceededQuota):
        * workers/WorkerRunLoop.cpp:
        (WebCore::WorkerRunLoop::runInMode):
        (WebCore::WorkerRunLoop::Task::performTask):
        * workers/WorkerThread.cpp:
        (WebCore::WorkerThread::workerThread):
        (WebCore::WorkerThreadShutdownFinishTask::create):
        (WebCore::WorkerThreadShutdownFinishTask::performTask):
        (WebCore::WorkerThreadShutdownFinishTask::isCleanupTask):
        (WebCore::WorkerThreadShutdownStartTask::create):
        (WebCore::WorkerThreadShutdownStartTask::performTask):
        (WebCore::WorkerThreadShutdownStartTask::isCleanupTask):
        (WebCore::WorkerThread::stop):

2010-01-20  Fumitoshi Ukai  <ukai@chromium.org>

        Reviewed by Alexey Proskuryakov.

        WebSocket: Request-URI should not be empty when no tralling slash in host
        https://bugs.webkit.org/show_bug.cgi?id=33689

        Test: websocket/tests/url-no-trailing-slash.html

        * websockets/WebSocketHandshake.cpp:
        (WebCore::resourceName):

2010-01-20  Daniel Bates  <dbates@webkit.org>

        Reviewed by Tor Arne Vestbø.

        https://bugs.webkit.org/show_bug.cgi?id=29564

        [Qt] Fixes an issue where the height of <button>- and
        <input type="button">- elements are fixed to the height of the
        button label font plus padding. That is, the CSS height property
        is being ignored.

        Instead, we should honor the user-specified height, if appropriate
        for the platform and context. Notice, the Mac ports do not honor the
        height for <input type="button"> elements unless a border and/or
        background is also specified.

        Test: fast/css/button-height.html

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::RenderThemeQt):
        (WebCore::RenderThemeQt::adjustButtonStyle):

2010-01-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig.

        Assertion failure calling history.pushState within popstate event handler.
        https://bugs.webkit.org/show_bug.cgi?id=33830

        Test: fast/loader/stateobjects/pushstate-within-popstate-handler-assert.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::navigateWithinDocument): Remove the ASSERT and invalid part of the comment.

2010-01-20  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Oliver Hunt.

        Crash on dispatching SVG mouse events
        https://bugs.webkit.org/show_bug.cgi?id=33841

        Return early SVGUseElement::instanceForShadowTreeElement if m_targetElementInstance is zero.
        This only happens if the SVGUseElement has just been removed from the document and EventHandler
        tries to dispatch a mouseout event to the corresponding SVGElementInstance. This is not testable
        using DRT unfortunately, so we have to add another manual testcase for that.

        Tests: manual-tests/use-crash-on-mouse-hover.svg

        * manual-tests/svg-crash-hovering-use.svg: Added.
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::instanceForShadowTreeElement): Add ASSERT(!inDocument()) when returning 0 here if m_targetElementInstance is 0.

2010-01-20  Ilya Tikhonovsky  <loislo@chromium.org>

        Reviewed by Pavel Feldman.

        Timeline reset button doesn't clean timeline if the panel is scrolled down.
        The overview pane also stay dirty after reset.
        https://bugs.webkit.org/show_bug.cgi?id=33829

        * inspector/front-end/TimelineGrid.js:
        (WebInspector.TimelineGrid.prototype.updateDividers):
        * inspector/front-end/TimelineOverviewPane.js:
        (WebInspector.TimelineOverviewPane.prototype.reset):
        * inspector/front-end/TimelinePanel.js:
        (WebInspector.TimelinePanel.prototype.reset):
        (WebInspector.TimelinePanel.prototype._refreshRecords):

2010-01-20  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=33930
        Crash in JSDOMWindowBase::crossDomainAccessErrorMessage when accessing a detached sandboxed frame

        Test: http/tests/security/detached-sandboxed-frame-access.html

        * bindings/js/JSDOMWindowBase.cpp: (WebCore::JSDOMWindowBase::crossDomainAccessErrorMessage):
        Changed the way we discover the url to match what the actual check does. Both old and new
        code correctly fetch the URL of the current window displayed in frame, but going via
        DOMWindowShell avoids crashing on null DOMWindow::m_frame pointer.

2010-01-20  Vitaly Repeshko  <vitalyr@chromium.org>

        Reviewed by Pavel Feldman.

        [V8] Support SerializedScriptValue.
        https://bugs.webkit.org/show_bug.cgi?id=32920
        http://crbug.com/30620

        Initial implementation of SerializedScriptValue which is used to
        to create a serialized representation of JavaScript objects.  This
        representation is needed for structured clones and worker messages.

        * WebCore.gypi: Added SerializedScriptValue.cpp.
        * bindings/scripts/CodeGeneratorV8.pm: Removed conversion to string before using SerializedScriptValue.
        * bindings/v8/SerializedScriptValue.cpp: Added.
        (WebCore::):
        (WebCore::ZigZag::encode):
        (WebCore::ZigZag::decode):
        (WebCore::Writer::Writer):
        (WebCore::Writer::writeUndefined):
        (WebCore::Writer::writeNull):
        (WebCore::Writer::writeTrue):
        (WebCore::Writer::writeFalse):
        (WebCore::Writer::writeString):
        (WebCore::Writer::writeInt32):
        (WebCore::Writer::writeNumber):
        (WebCore::Writer::endComposite):
        (WebCore::Writer::data):
        (WebCore::Writer::doWriteUint32):
        (WebCore::Writer::append):
        (WebCore::Writer::ensureSpace):
        (WebCore::Writer::fillHole):
        (WebCore::Writer::charAt):
        (WebCore::Serializer::Serializer):
        (WebCore::Serializer::serialize):
        (WebCore::Serializer::StateBase::~StateBase):
        (WebCore::Serializer::StateBase::nextState):
        (WebCore::Serializer::StateBase::setNextState):
        (WebCore::Serializer::StateBase::composite):
        (WebCore::Serializer::StateBase::StateBase):
        (WebCore::Serializer::State::composite):
        (WebCore::Serializer::State::tag):
        (WebCore::Serializer::State::State):
        (WebCore::Serializer::StackCleaner::StackCleaner):
        (WebCore::Serializer::StackCleaner::~StackCleaner):
        (WebCore::Serializer::ArrayState::ArrayState):
        (WebCore::Serializer::ArrayState::done):
        (WebCore::Serializer::ArrayState::advance):
        (WebCore::Serializer::ObjectState::ObjectState):
        (WebCore::Serializer::ObjectState::done):
        (WebCore::Serializer::ObjectState::advance):
        (WebCore::Serializer::ObjectState::nextProperty):
        (WebCore::Serializer::doSerialize):
        (WebCore::Serializer::push):
        (WebCore::Serializer::top):
        (WebCore::Serializer::pop):
        (WebCore::Serializer::checkComposite):
        (WebCore::Reader::Reader):
        (WebCore::Reader::isEof):
        (WebCore::Reader::read):
        (WebCore::Reader::readTag):
        (WebCore::Reader::readString):
        (WebCore::Reader::readInt32):
        (WebCore::Reader::readNumber):
        (WebCore::Reader::doReadUint32):
        (WebCore::Deserializer::Deserializer):
        (WebCore::Deserializer::deserialize):
        (WebCore::Deserializer::doDeserialize):
        (WebCore::Deserializer::push):
        (WebCore::Deserializer::pop):
        (WebCore::Deserializer::stackDepth):
        (WebCore::Deserializer::element):
        (WebCore::SerializedScriptValue::SerializedScriptValue):
        (WebCore::SerializedScriptValue::deserialize):
        * bindings/v8/SerializedScriptValue.h:
        (WebCore::SerializedScriptValue::create):
        (WebCore::SerializedScriptValue::createFromWire):
        (WebCore::SerializedScriptValue::release):
        (WebCore::SerializedScriptValue::toWireString):

        Updated uses of SerializedScriptValue:
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::V8DOMWindow::postMessageCallback):
        * bindings/v8/custom/V8DedicatedWorkerContextCustom.cpp:
        (WebCore::V8DedicatedWorkerContext::postMessageCallback):
        * bindings/v8/custom/V8HistoryCustom.cpp:
        (WebCore::V8History::pushStateCallback):
        (WebCore::V8History::replaceStateCallback):
        * bindings/v8/custom/V8MessageEventCustom.cpp:
        (WebCore::V8MessageEvent::initMessageEventCallback):
        * bindings/v8/custom/V8MessagePortCustom.cpp:
        (WebCore::V8MessagePort::postMessageCallback):
        * bindings/v8/custom/V8WorkerCustom.cpp:
        (WebCore::V8Worker::postMessageCallback):

2010-01-20  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Sam Weinig.

        Fix crash in geolocation when observers change during iteration.

        * page/GeolocationController.cpp:
        (WebCore::GeolocationController::positionChanged): Copy observers to vector while iterating.
        (WebCore::GeolocationController::errorOccurred): Copy observers to vector while iterating.

2010-01-19  Oliver Hunt  <oliver@apple.com>

        Reviewed by Dan Bernstein.

        Insufficient repaint issues with html embedded in foreignObject
        https://bugs.webkit.org/show_bug.cgi?id=16318

        Partial fix for selection repaint in foreignObject, basically we
        just need to make sure foreignObject correctly applies the svg
        transform to the selection rect.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintSelection):
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::mapLocalToContainer):
        * rendering/RenderForeignObject.h:

2010-01-20  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by NOBODY.

        <rdar://problem/7557695> REGRESSION(r53445-r53449): Many new memory leaks (33867)

        Revert r53447, since this caused leaks.

        * WebCore.base.exp:
        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::operator new):
        (WebCore::StringImpl::operator delete):
        (WebCore::StringImpl::StringImpl):
        (WebCore::StringImpl::~StringImpl):
        (WebCore::StringImpl::create):
        (WebCore::StringImpl::createWithTerminatingNullCharacter):
        (WebCore::StringImpl::crossThreadString):
        (WebCore::StringImpl::sharedBuffer):
        * platform/text/StringImpl.h:
        (WebCore::StringImpl::hasTerminatingNullCharacter):
        (WebCore::StringImpl::inTable):
        (WebCore::StringImpl::setInTable):
        (WebCore::StringImpl::):
        * storage/OriginUsageRecord.cpp:
        (WebCore::OriginUsageRecord::addDatabase):
        (WebCore::OriginUsageRecord::markDatabase):

2010-01-20  Jian Li  <jianli@chromium.org>

        Reviewed by Dmitry Titov.

        Implement File and Blob interfaces as defined in File API spec.
        https://bugs.webkit.org/show_bug.cgi?id=32912

        * Android.derived.jscbindings.mk:
        * Android.derived.v8bindings.mk:
        * Android.mk:
        * DerivedSources.cpp:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.gypi:
        * WebCore.pri:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::send):
        * bindings/objc/DOMHTML.h:
        * bindings/objc/PublicDOMInterfaces.h:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * bindings/scripts/CodeGeneratorV8.pm:
        * bindings/v8/DOMObjectsInclude.h:
        * bindings/v8/DerivedSourcesAllInOne.cpp:
        * bindings/v8/V8Binding.h:
        (WebCore::toInt64):
        * bindings/v8/V8Index.cpp:
        * bindings/v8/V8Index.h:
        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::V8XMLHttpRequest::sendCallback):
        * html/File.cpp:
        (WebCore::File::File):
        * html/File.h:
        (WebCore::File::create):
        (WebCore::File::name):
        (WebCore::File::fileName):
        (WebCore::File::fileSize):
        * html/File.idl:
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::send):
        * xml/XMLHttpRequest.h:

2010-01-20  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        WAI-ARIA popup buttons spoken as simply 'button'
        https://bugs.webkit.org/show_bug.cgi?id=33922

        Test: platform/mac/accessibility/aria-popup.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::actionElement):
        (WebCore::AccessibilityRenderObject::determineAriaRoleAttribute):
        * html/HTMLAttributeNames.in:

2010-01-19  David Levin  <levin@chromium.org>

        Reviewed by Oliver Hunt.

        CrossThreadCopier needs to support ThreadSafeShared better.
        https://bugs.webkit.org/show_bug.cgi?id=33698

        Now the copier is able to handle types that derive from ThreadSafeShared.

        No change functionality so no new tests.

        * loader/WorkerThreadableLoader.cpp:
        (WebCore::WorkerThreadableLoader::MainThreadBridge::cancel): Remove unnecessary cast.
        (WebCore::WorkerThreadableLoader::MainThreadBridge::clearClientWrapper): Ditto.
        * loader/WorkerThreadableLoader.h:
        Change to use the derived class instead of the ThreadSafeShared version.
        * platform/CrossThreadCopier.cpp:
        Add the new template parameter throughout the classes and adjust the class that 
        handles ThreadSafeShared to allow for derived types.
        * platform/CrossThreadCopier.h:
        Add another template parameter to be able to detect classes that derive 
        from ThreadSafeShared.
        * websockets/WorkerThreadableWebSocketChannel.cpp:
        Removed unnecessary casts and changed a type to use the derived class instead of
        the ThreadSafeShared version.
        (WebCore::WorkerThreadableWebSocketChannel::Peer::Peer):
        (WebCore::workerContextDidSend):
        (WebCore::workerContextDidGetBufferedAmount):
        (WebCore::workerContextDidConnect):
        (WebCore::workerContextDidReceiveMessage):
        (WebCore::workerContextDidClose):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::setWebSocketChannel):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::mainThreadCreateWebSocketChannel):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::send):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::bufferedAmount):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::clearClientWrapper):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::setMethodNotCompleted):
        (WebCore::WorkerThreadableWebSocketChannel::Bridge::waitForMethodCompletion):
        * websockets/WorkerThreadableWebSocketChannel.h:
        (WebCore::WorkerThreadableWebSocketChannel::Peer::create): Changed a type to use the
        derived class instead of the ThreadSafeShared version.

2010-01-20  Jon Honeycutt  <jhoneycutt@apple.com>

        <rdar://problem/7086565> Crash in WebCore::PlugInView::dispatchNPEvent

        Reviewed by Sam Weinig.

        * plugins/PluginView.cpp:
        (WebCore::PluginView::handleEvent):
        Ref the PluginView to protect it from deletion while calling into the
        plug-in.

2010-01-20  Jon Honeycutt  <jhoneycutt@apple.com>

        MSAA: accSelect() is not implemented

        https://bugs.webkit.org/show_bug.cgi?id=33918
        <rdar://problem/7436861>

        Reviewed by Darin Adler.

        Test: platform/win/accessibility/selection-and-focus.html

        * accessibility/AccessibilityMenuListOption.cpp:
        (WebCore::AccessibilityMenuListOption::setSelected):
        Return early if the object is not selectable.

2010-01-20  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed. Fix chromium build, introduced a copy&paste error.

        * bindings/v8/ScriptEventListener.cpp:
        (WebCore::createAttributeEventListener):

2010-01-20  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6579204> Exception thrown when opening a <select> pop-up that
        uses a web font
        https://bugs.webkit.org/show_bug.cgi?id=23911

        * platform/mac/PopupMenuMac.mm:
        (WebCore::PopupMenu::populate): Use the (bold) system font if an NSFont cannot
        be obtained.

2010-01-19  Nikolas Zimmermann  <nzimmermann@rim.com>

        Reviewed by Alexey Proskuryakov. 

        svg/custom/use-instanceRoot-event-bubbling.xhtml is flakey
        https://bugs.webkit.org/show_bug.cgi?id=33835

        mouseEvent fires mutiple times in svg/custom/use-instanceRoot-as-event-target.xhtml
        https://bugs.webkit.org/show_bug.cgi?id=32519

        Test: svg/custom/use-instanceRoot-event-listener-liveness.xhtml

        Stabilize <use> scripting support - use tests are reliable now (tested using --repeach-each 50 --random -p)

        Do not reclone trees anymore because of event listener changes, instead keep correspondingElement & shadowTreeElement
        synchronized for each SVGElementInstance - any mutations on any event listeners are live, and take immediate effect,
        w/o having to rely on a reclone - this was the root of several race conditions making the <use> tests flakey.

        Fix SVGUseElement::instanceRoot() to force shadow tree creation, even if it was not attached so far - we can't wait
        for finishedParsing() to be called which would recalculate the document style and attach the shadow tree as result.
        This is now matching Operas behaviour.

        Optimize createAttributeEventListener() to not create event listeners if the supplied Attribute isNull() - otherwhise
        DOM calls like removeAttribute("onclick") cause a temporary JSEventListener to be created, added to the event listener
        cache and removed afterwards.

        * bindings/js/ScriptEventListener.cpp:
        (WebCore::createAttributeEventListener): Return early if the supplied attribute is null as discussed with Geoffrey.
        * bindings/v8/ScriptEventListener.cpp:
        (WebCore::createAttributeEventListener): Ditto.
        * dom/Node.cpp: Synchronize event listeners with all element instances, instead of marking the use elements to reclone.
        (WebCore::instancesForSVGElement):
        (WebCore::tryAddEventListener):
        (WebCore::Node::addEventListener): When adding a listener, get a list of element instances and add it their as well.
        (WebCore::tryRemoveEventListener):
        (WebCore::Node::removeEventListener): Ditto for removals, but with special logic for listeners created from markup (see comments)
        * svg/SVGElementInstance.cpp: Cleaned up, removing unncessary checks of correspondingElement() - there is an ASSERT in the ctor.
        (WebCore::SVGElementInstance::invalidateAllInstancesOfElement):
        (WebCore::SVGElementInstance::scriptExecutionContext):
        (WebCore::SVGElementInstance::addEventListener):
        (WebCore::SVGElementInstance::removeEventListener):
        (WebCore::SVGElementInstance::removeAllEventListeners):
        (WebCore::SVGElementInstance::eventTargetData):
        (WebCore::SVGElementInstance::ensureEventTargetData):
        * svg/SVGUseElement.cpp: Call document()->updateLayoutIgnorePendingStylesheets() to force shadow tree creation, just like CSSStyleDecl works.
        (WebCore::SVGUseElement::instanceRoot):

2010-01-20  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        Move local utility class DocumentWeakReference entirely from Document.h into Document.cpp
        since it is only used there. It is a followup for http://trac.webkit.org/changeset/53345.

        No new tests since no change in functionality.

        * dom/Document.cpp: Move definitions of the methods into declaration of the class, remove 'inline'.
        * dom/Document.h: Replace DocumentWeakReference declaration with a forward declaration.

2010-01-20  Oliver Hunt  <oliver@apple.com>

        No review, rolling out r53561.
        http://trac.webkit.org/changeset/53561
        https://bugs.webkit.org/show_bug.cgi?id=16318

        broke selection repaint for transformed text in html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintSelection):
        * rendering/RenderForeignObject.cpp:
        * rendering/RenderForeignObject.h:

2010-01-19  Oliver Hunt  <oliver@apple.com>

        Reviewed by Beth Dakin.

        Insufficient repaint issues with html embedded in foreignObject
        https://bugs.webkit.org/show_bug.cgi?id=16318

        Partial fix for selection repaint in foreignObject, basically we
        just need to make sure foreignObject correctly applies the svg
        transform to the selection rect.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintSelection):
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::mapLocalToContainer):
        * rendering/RenderForeignObject.h:

2010-01-20  Kevin Ollivier  <kevino@theolliviers.com>

        Build fix for !ENABLE(SVG).

        * rendering/TrailingFloatsRootInlineBox.h:
        (WebCore::TrailingFloatsRootInlineBox::TrailingFloatsRootInlineBox):

2010-01-20  David Levin  <levin@chromium.org>

        No review, rolling out r53552.
        http://trac.webkit.org/changeset/53552
        https://bugs.webkit.org/show_bug.cgi?id=32554

        Caused lots of fast/profile test failures.

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::databaseForId):
        (WebCore::JSInjectedScriptHost::inspectedWindow):
        (WebCore::JSInjectedScriptHost::wrapCallback):
        (WebCore::JSInjectedScriptHost::currentCallFrame):
        (WebCore::JSInjectedScriptHost::nodeForId):
        (WebCore::JSInjectedScriptHost::wrapObject):
        (WebCore::JSInjectedScriptHost::unwrapObject):
        (WebCore::JSInjectedScriptHost::pushNodePathToFrontend):
        (WebCore::JSInjectedScriptHost::selectDatabase):
        (WebCore::JSInjectedScriptHost::selectDOMStorage):
        * bindings/js/ScriptCallStack.h:
        (WebCore::ScriptCallStack::state):
        * bindings/js/ScriptController.cpp:
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptObject.h:
        * bindings/js/ScriptValue.cpp:
        (WebCore::ScriptValue::quarantineValue):
        * bindings/js/ScriptValue.h:
        * bindings/v8/ScriptObject.h:
        * bindings/v8/ScriptValue.h:
        (WebCore::ScriptValue::quarantineValue):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::V8InjectedScriptHost::inspectedWindowCallback):
        (WebCore::V8InjectedScriptHost::wrapCallbackCallback):
        (WebCore::V8InjectedScriptHost::wrapObjectCallback):
        (WebCore::V8InjectedScriptHost::unwrapObjectCallback):
        * inspector/ConsoleMessage.cpp:
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::ConsoleMessage::addToConsole):
        (WebCore::ConsoleMessage::isEqual):
        * inspector/ConsoleMessage.h:
        * inspector/InjectedScriptHost.cpp:
        (WebCore::InjectedScriptHost::wrapObject):
        (WebCore::InjectedScriptHost::unwrapObject):
        * inspector/InjectedScriptHost.h:
        * inspector/InjectedScriptHost.idl:
        * inspector/InspectorBackend.cpp:
        (WebCore::InspectorBackend::dispatchOnInjectedScript):
        (WebCore::InspectorBackend::releaseWrapperObjectGroup):
        * inspector/InspectorBackend.h:
        * inspector/InspectorBackend.idl:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::clearConsoleMessages):
        (WebCore::InspectorController::inspectedWindowScriptObjectCleared):
        (WebCore::InspectorController::windowScriptObjectAvailable):
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::setFrontendProxyObject):
        (WebCore::InspectorController::close):
        (WebCore::InspectorController::resetScriptObjects):
        (WebCore::InspectorController::didPause):
        (WebCore::InspectorController::wrapObject):
        (WebCore::InspectorController::unwrapObject):
        (WebCore::InspectorController::releaseWrapperObjectGroup):
        (WebCore::InspectorController::resetInjectedScript):
        (WebCore::InspectorController::deleteCookie):
        * inspector/InspectorController.h:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::addConsoleMessage):
        (WebCore::InspectorFrontend::pausedScript):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/AuditsPanel.js:
        (WebInspector.AuditsPanel.prototype._reloadResources):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleView.prototype.requestClearMessages):
        (WebInspector.ConsoleView.prototype.completions):
        (WebInspector.ConsoleView.prototype.doEvalInWindow):
        (WebInspector.ConsoleView.prototype._formatnode):
        (WebInspector.ConsoleView.prototype._formatarray):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMNode):
        (WebInspector.CSSStyleDeclaration):
        (WebInspector.CSSStyleDeclaration.parseRule):
        * inspector/front-end/Database.js:
        (WebInspector.Database.prototype.executeSql):
        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged):
        (WebInspector.ElementsPanel.prototype.setDocument):
        (WebInspector.ElementsPanel.prototype.searchCanceled):
        (WebInspector.ElementsPanel.prototype.performSearch):
        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype.createTooltipForImageNode):
        * inspector/front-end/EventListenersSidebarPane.js:
        ():
        * inspector/front-end/InjectedScript.js:
        (InjectedScript.dispatch):
        (InjectedScript.toggleStyleEnabled):
        (InjectedScript._serializeRule):
        (InjectedScript._serializeStyle):
        (InjectedScript.getProperties):
        (InjectedScript.setPropertyValue):
        (InjectedScript._evaluateAndWrap):
        (InjectedScript.getCallFrames):
        (InjectedScript._inspectObject):
        (InjectedScript._ensureCommandLineAPIInstalled):
        (InjectedScript._resolveObject):
        (InjectedScript._window):
        (InjectedScript._objectForId):
        (InjectedScript.createProxyObject):
        (InjectedScript.executeSql):
        (InjectedScript.executeSql.errorCallback):
        (InjectedScript.executeSql.queryTransaction):
        (Object.type):
        (String.prototype.escapeCharacters):
        * inspector/front-end/InjectedScriptAccess.js:
        (InjectedScriptAccess._installHandler.InjectedScriptAccess.methodName):
        (InjectedScriptAccess._installHandler):
        * inspector/front-end/MetricsSidebarPane.js:
        (WebInspector.MetricsSidebarPane):
        (WebInspector.MetricsSidebarPane.prototype.update.inlineStyleCallback):
        (WebInspector.MetricsSidebarPane.prototype.update):
        (WebInspector.MetricsSidebarPane.prototype.editingCommitted):
        * inspector/front-end/ObjectPropertiesSection.js:
        (WebInspector.ObjectPropertiesSection.prototype.update):
        (WebInspector.ObjectPropertyTreeElement.prototype.onpopulate):
        (WebInspector.ObjectPropertyTreeElement.prototype.applyExpression):
        * inspector/front-end/ObjectProxy.js:
        (WebInspector.ObjectProxy):
        (WebInspector.ObjectProxy.getPropertiesAsync):
        * inspector/front-end/PropertiesSidebarPane.js:
        (WebInspector.PropertiesSidebarPane.prototype.update.callback):
        (WebInspector.PropertiesSidebarPane.prototype.update):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourceSidebarTreeElement.prototype.ondblclick):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.doEvalInCallFrame):
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylesSidebarPane.prototype.update):
        (WebInspector.StylePropertiesSection.prototype.editingSelectorCommitted):
        (WebInspector.BlankStylePropertiesSection.prototype.editingSelectorCommitted):
        (WebInspector.StylePropertyTreeElement.prototype):
        * inspector/front-end/WatchExpressionsSidebarPane.js:
        (WebInspector.WatchExpressionsSection.prototype.update):
        * inspector/front-end/inspector.js:
        (WebInspector.loaded):
        (WebInspector.pausedScript):
        (WebInspector.addConsoleMessage):
        (WebInspector.log.logMessage):
        (WebInspector.log):

2010-01-20  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Renames jni_runtime.[cpp|h] to JNIBridge.[cpp|h]
        https://bugs.webkit.org/show_bug.cgi?id=33899

        No new tests, refactoring only.

        * Android.jscbindings.mk: Modified. Removes jni_runtime.cpp and adds JNIBridge.cpp
        * GNUmakefile.am: Modified. Removes jni_runtime.h and adds JNIBridge.h
        * WebCore.xcodeproj/project.pbxproj: Modified. Removes jni_runtime.[cpp|h] and adds JNIBridge.[cpp|h]
        * bridge/jni/JNIBridge.cpp: Copied from WebCore/bridge/jni/jni_runtime.cpp.
        * bridge/jni/JNIBridge.h: Copied from WebCore/bridge/jni/jni_runtime.h.
        * bridge/jni/jni_jsobject.mm: Modified. Updated to include JNIBridge.h
        * bridge/jni/jni_runtime.cpp: Removed.
        * bridge/jni/jni_runtime.h: Removed.
        * bridge/jni/jsc/JNIUtilityPrivate.cpp: Modified. Updated to include JNIBridge.h
        * bridge/jni/jsc/JavaClassJSC.cpp: Modified. Removed superfluous include
        * bridge/jni/jsc/JavaClassJSC.h: Modified. Updated to include JNIBridge.h
        * bridge/jni/jsc/JavaInstanceJSC.cpp: Modified. Updated to include JNIBridge.h

2010-01-20  Alexey Proskuryakov  <ap@apple.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=33913
        Crash under Media::matchMedium in detached frame

        Also took the opportunity to fix JS bindings for the Media object.

        Test: fast/media/lifetime.html

        * css/Media.h:
        (WebCore::Media::create): Take and store a Frame pointer, like other similar objects do.
        (WebCore::Media::disconnectFrame): Zero out the frame pointer (this is called from
        DOMWindow::clear()).

        * css/Media.cpp:
        (WebCore::Media::Media): Updated to storing Frame pointer.
        (WebCore::Media::type): Ditto.
        (WebCore::Media::matchMedium): Removed null check for document element - every document has
        one. Also, every Frame has a document, so we only need to check for m_frame being zero.

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::markChildren):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::clear):
        (WebCore::DOMWindow::media):
        * page/DOMWindow.h:
        (WebCore::DOMWindow::optionalMedia):
        Make sure there's only one Media object per window, and keep its wrapper alive.

2010-01-20  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin Adler and Adam Roben.

        Feature defines are difficult to maintain on Windows builds
        https://bugs.webkit.org/show_bug.cgi?id=33883

        FeatureDefines.vsprops are now maintained in a way similar to
        Configurations/FeatureDefines.xcconfig, with the added advantage
        of having a single FeatureDefines file across all projects.

        * Configurations/FeatureDefines.xcconfig: Add comments about keeping feature definitions in sync.
        * WebCore.vcproj/MigrateIDLAndScripts: Remove reference to file that no longer exists.
        * WebCore.vcproj/QTMovieWin.vcproj: Add FeatureDefines.vsprops inherited property sheet.
        * WebCore.vcproj/WebCore.vcproj: Add FeatureDefines.vsprops inherited property sheet.
        * WebCore.vcproj/WebCoreCommon.vsprops: Remove ENABLE_ preprocessor definitions.
        * WebCore.vcproj/WebCoreGenerated.vcproj: Added Cairo configuration for selecting proper features.
        * WebCore.vcproj/WebCoreMediaQT.vsprops: Remove ENABLE_VIDEO. This is picked up from FeatureDefines.vsprops.
        * WebCore.vcproj/build-generated-files.sh: Pick up features from FeatureDefines.vsprops or FeatureDefinesCairo.vsprops.

2010-01-20  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Pavel Feldman.

        Inject inspector script directly into the inspected context. All the
        communication between the script and the frontend is serialized into
        JSON strings. It allows to get rid of object quarantines in Web Inspector.

        https://bugs.webkit.org/show_bug.cgi?id=32554

        Test: inspector/console-log-before-inspector-open.html

        * bindings/js/JSInjectedScriptHostCustom.cpp:
        (WebCore::JSInjectedScriptHost::databaseForId):
        (WebCore::JSInjectedScriptHost::currentCallFrame):
        (WebCore::JSInjectedScriptHost::nodeForId):
        (WebCore::JSInjectedScriptHost::pushNodePathToFrontend):
        (WebCore::JSInjectedScriptHost::selectDatabase):
        (WebCore::JSInjectedScriptHost::selectDOMStorage):
        * bindings/js/ScriptCallStack.h:
        (WebCore::ScriptCallStack::state):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::mainWorldScriptState):
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptObject.h:
        (WebCore::ScriptObject::scriptState):
        * bindings/js/ScriptValue.cpp:
        * bindings/js/ScriptValue.h:
        * bindings/v8/ScriptObject.h:
        (WebCore::ScriptObject::scriptState):
        * bindings/v8/ScriptValue.h:
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        * inspector/ConsoleMessage.cpp:
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::ConsoleMessage::addToConsole):
        (WebCore::ConsoleMessage::isEqual):
        * inspector/ConsoleMessage.h:
        * inspector/InjectedScriptHost.cpp:
        (WebCore::InjectedScriptHost::releaseWrapperObjectGroup):
        * inspector/InjectedScriptHost.h:
        * inspector/InjectedScriptHost.idl:
        * inspector/InspectorBackend.cpp:
        (WebCore::InspectorBackend::setInjectedScriptSource):
        (WebCore::InspectorBackend::dispatchOnInjectedScript):
        (WebCore::InspectorBackend::releaseWrapperObjectGroup):
        * inspector/InspectorBackend.h:
        * inspector/InspectorBackend.idl:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::clearConsoleMessages):
        (WebCore::InspectorController::inspectedWindowScriptObjectCleared):
        (WebCore::InspectorController::windowScriptObjectAvailable):
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::setFrontendProxyObject):
        (WebCore::InspectorController::close):
        (WebCore::InspectorController::resetScriptObjects):
        (WebCore::InspectorController::didPause):
        (WebCore::InspectorController::injectedScriptForNodeId):
        * inspector/InspectorController.h:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::addConsoleMessage):
        (WebCore::InspectorFrontend::pausedScript):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/AuditsPanel.js:
        (WebInspector.AuditsPanel.prototype._reloadResources):
        * inspector/front-end/ConsoleView.js:
        (WebInspector.ConsoleView.prototype.requestClearMessages):
        (WebInspector.ConsoleView.prototype.doEvalInWindow):
        * inspector/front-end/DOMAgent.js:
        (WebInspector.DOMNode):
        (WebInspector.CSSStyleDeclaration):
        (WebInspector.CSSStyleDeclaration.parseRule):
        * inspector/front-end/Database.js:
        (WebInspector.Database.prototype.executeSql):
        * inspector/front-end/ElementsPanel.js:
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged.InjectedScriptAccess.get addInspectedNode):
        (WebInspector.ElementsPanel.this.treeOutline.focusedNodeChanged):
        (WebInspector.ElementsPanel.prototype.setDocument):
        (WebInspector.ElementsPanel.prototype.searchCanceled):
        (WebInspector.ElementsPanel.prototype.performSearch):
        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype.createTooltipForImageNode):
        * inspector/front-end/EventListenersSidebarPane.js:
        ():
        * inspector/front-end/InjectedScript.js:
        (injectedScriptConstructor):
        (injectedScriptConstructor.):
        * inspector/front-end/InjectedScriptAccess.js:
        (InjectedScriptAccess):
        (InjectedScriptAccess.getDefault):
        (get InjectedScriptAccess):
        (InjectedScriptAccess._installHandler.InjectedScriptAccess.prototype.methodName):
        (InjectedScriptAccess._installHandler):
        * inspector/front-end/MetricsSidebarPane.js:
        (WebInspector.MetricsSidebarPane):
        (WebInspector.MetricsSidebarPane.prototype.update.inlineStyleCallback):
        * inspector/front-end/ObjectPropertiesSection.js:
        * inspector/front-end/ObjectProxy.js:
        (WebInspector.ObjectProxy):
        * inspector/front-end/PropertiesSidebarPane.js:
        (WebInspector.PropertiesSidebarPane.prototype.update.callback):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourceSidebarTreeElement.prototype.ondblclick):
        * inspector/front-end/ScriptsPanel.js:
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype):
        * inspector/front-end/WatchExpressionsSidebarPane.js:
        (WebInspector.WatchExpressionsSection.prototype.update):
        * inspector/front-end/inspector.js:
        (WebInspector.loaded):
        (WebInspector.pausedScript):
        (WebInspector.addConsoleMessage):
        (WebInspector.log.logMessage):
        (WebInspector.log):

2010-01-20  Kent Tamura  <tkent@chromium.org>

        Reviewed by Darin Adler.

        HTMLInputElement::valueAsDate setter support for type=time.
        https://bugs.webkit.org/show_bug.cgi?id=33825

        Introduce ISODateTime::setMillisecondsSinceMidnight() and add a
        SecondFormat parameter to ISODateTime::toString(). The main code
        logic for type=time is implemented in
        setMillisecondsSinceMidnightInternal() and toStringForTime()
        because the logic is going to be used for other types.

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setValueAsDate):
        * html/ISODateTime.cpp:
        (WebCore::positiveFmod):
        (WebCore::ISODateTime::setMillisecondsSinceMidnightInternal):
        (WebCore::ISODateTime::setMillisecondsSinceMidnight):
        (WebCore::ISODateTime::toStringForTime):
        (WebCore::ISODateTime::toString):
        * html/ISODateTime.h:
        (WebCore::ISODateTime::):

2010-01-20  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt] Unreviewed buildfix for r53547.

        * WebCore.pri:

2010-01-20  Ben Murdoch  <benm@google.com>

        Reviewed by Simon Hausmann.

        The touchcancel event is not supported.
        https://bugs.webkit.org/show_bug.cgi?id=33598

        This change adds support for the touchcancel event in WebCore and adds a test.

        Test: fast/events/touch/send-oncancel-event.html

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::processingUserGestureEvent): Considers touchcancel with the other touch events when working out if the event is a user gesture.
        * dom/Document.cpp:
        (WebCore::Document::addListenerTypeIfNeeded): Adds a check to consider ontouchcancel a touch event listener.
        * dom/Document.h: Add the touchcancel attribute event listener.
        * dom/Document.idl: ditto.
        * dom/Element.h: ditto.
        * dom/Element.idl: ditto.
        * dom/EventNames.h: Adds touchcancel as an event name.
        * html/HTMLAttributeNames.in:Adds touchcancel as an HTML attribute name.
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::parseMappedAttribute): Parses the ontouchcancel attribute.
        * page/DOMWindow.h: Adds the touchcancel attribute event listener.
        * page/DOMWindow.idl: ditto.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleTouchEvent): Add code to detect and dispatch touchcancel events.
        * platform/PlatformTouchEvent.h:
        (WebCore::): Add TouchCancel as a touch event type.
        * platform/PlatformTouchPoint.h:
        (WebCore::PlatformTouchPoint::): Add TouchCanceled as a touch point state.

2010-01-20  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Make extraCompilers for generated sources depend on their scripts

        * DerivedSources.pro:
        * WebCore.pri:

2010-01-20  Kent Tamura  <tkent@chromium.org>

        Reviewed by Adam Barth.

        [Chromium][V8] Fix null pointer dereference in V8Proxy::retrieve().
        https://bugs.webkit.org/show_bug.cgi?id=33886

        This is equivalent to r53433, and fix a crash by
        LayoutTests/http/tests/appcache/destroyed-iframe.html.

        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::retrieve): Check if context is null.

2010-01-20  Alexander Pavlov  <apavlov@chromium.org>

        Reviewed by Timothy Hatcher.

        Optimize resize event handling for hidden views
        https://bugs.webkit.org/show_bug.cgi?id=33803

        * inspector/front-end/AbstractTimelinePanel.js:
        (WebInspector.AbstractTimelinePanel.prototype.resize):
        (WebInspector.AbstractTimelinePanel.prototype.updateMainViewWidth):
        * inspector/front-end/AuditsPanel.js:
        * inspector/front-end/Panel.js:
        (WebInspector.Panel.prototype.updateSidebarWidth):
        (WebInspector.Panel.prototype.resize):
        * inspector/front-end/PanelEnablerView.js:
        (WebInspector.PanelEnablerView):
        (WebInspector.PanelEnablerView.prototype.show):
        (WebInspector.PanelEnablerView.prototype.resize):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype.show):
        (WebInspector.ProfilesPanel.prototype.addProfileHeader):
        (WebInspector.ProfilesPanel.prototype.showProfile):
        (WebInspector.ProfilesPanel.prototype.showView):
        (WebInspector.ProfilesPanel.prototype.closeVisibleView):
        (WebInspector.ProfilesPanel.prototype._updateInterface):
        (WebInspector.ProfilesPanel.prototype.updateMainViewWidth):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype.show):
        (WebInspector.ResourcesPanel.prototype.get visibleView):
        (WebInspector.ResourcesPanel.prototype.updateMainViewWidth):
        * inspector/front-end/Settings.js:
        * inspector/front-end/StoragePanel.js:
        (WebInspector.StoragePanel.prototype.updateMainViewWidth):
        * inspector/front-end/WelcomeView.js:
        (WebInspector.WelcomeView):
        (WebInspector.WelcomeView.prototype.show):
        (WebInspector.WelcomeView.prototype.resize):
        * inspector/front-end/inspector.css:
        * inspector/front-end/inspector.js:
        (WebInspector.windowResize):

2010-01-20  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Fixes style in WebCore/bridge/Bridge
        https://bugs.webkit.org/show_bug.cgi?id=33839

        No new tests, style fixes only.

        * bridge/Bridge.cpp: Modified.
        * bridge/Bridge.h: Modified.
        * bridge/c/c_instance.cpp: Modified.
        (JSC::Bindings::CInstance::invokeMethod): Modified. Use renamed m_rootObject member
        (JSC::Bindings::CInstance::invokeDefaultMethod): Modified. Use renamed m_rootObject member
        (JSC::Bindings::CInstance::invokeConstruct): Modified. Use renamed m_rootObject member
        * bridge/jni/jni_runtime.cpp: Modified.
        (JavaArray::JavaArray): Modified. Use renamed m_rootObject member
        (JavaArray::rootObject): Modified. Use renamed m_rootObject member
        * bridge/objc/objc_instance.mm: Modified.
        (ObjcInstance::invokeMethod): Modified. Use renamed m_rootObject member
        (ObjcInstance::invokeDefaultMethod): Modified. Use renamed m_rootObject member
        (ObjcInstance::getValueOfUndefinedField): Modified. Use renamed m_rootObject member
        * bridge/objc/objc_runtime.mm: Modified.
        (JSC::Bindings::ObjcArray::valueAt): Modified. Use renamed m_rootObject member
        * bridge/qt/qt_runtime.cpp: Modified.
        (JSC::Bindings::::rootObject): Modified. Use renamed m_rootObject member

2010-01-20  Daniel Bates  <dbates@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=33885

        Fixes style errors exposed by the style bot in the patch
        for bug #33770. Moreover, fixes all style errors reported
        by check-webkit-style.

        No functionality was changed. So, no new tests.

        * bindings/js/JSWebGLRenderingContextCustom.cpp:
        (WebCore::dataFunctionf):
        (WebCore::dataFunctioni):
        (WebCore::dataFunctionMatrix):

2010-01-19  Steve Block  <steveblock@google.com>

        Reviewed by David Levin.

        Fixes style in WebCore/bridge/JNIUtility
        https://bugs.webkit.org/show_bug.cgi?id=33870

        No new tests, style fixes only.

        * bridge/jni/JNIUtility.cpp:
        * bridge/jni/JNIUtility.h:

2010-01-20  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        On Linux link QtWebKit with -no-undefined to catch build breakages due to missing
        files in the .pro file, resulting in unresolved symbols.

        * WebCore.pro:

2010-01-20  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        [Qt] Make it possible to link with -no-undefined.

        * WebCore.pro: Add missing explicit dependency to libXrender due to the
        use of XRenderFindVisualFormat in the X11 plugin code.

2010-01-20  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Add missing files to the build.

        * WebCore.pro:

2010-01-20  Shinichiro Hamaji  <hamaji@chromium.org>

        Reviewed by Darin Fisher.

        [Chromium] computePageRectsForFrame seems to be unnecessary
        https://bugs.webkit.org/show_bug.cgi?id=33881

        * WebCore.gypi: Removed FrameChromium.h
        * page/chromium/FrameChromium.cpp: Removed computePageRectsForFrame.
        * page/chromium/FrameChromium.h: Removed.

2010-01-20  Roland Steiner  <rolandsteiner@chromium.org>

        Reviewed by Dan Bernstein.

        Bug 33266 - WebCore::InlineFlowBox::determineSpacingForFlowBoxes ReadAV@NULL (43c64e8abbda6766e5f5edbd254c2d57)
        (https://bugs.webkit.org/show_bug.cgi?id=33266)
        
        Ruby did not handle malformed cases correctly when the ruby base was in
        block flow. Changed the code to handle all possible cases.
        Also, added some simplification methods to RenderBlock.

        Tests: fast/ruby/ruby-illegal-1.html
               fast/ruby/ruby-illegal-2.html
               fast/ruby/ruby-illegal-3.html
               fast/ruby/ruby-illegal-4.html
               fast/ruby/ruby-illegal-5.html
               fast/ruby/ruby-illegal-6.html
               fast/ruby/ruby-illegal-7.html
               fast/ruby/ruby-illegal-combined.html
               fast/ruby/rubyDOM-insert-rt-block-1.html
               fast/ruby/rubyDOM-insert-rt-block-2.html
               fast/ruby/rubyDOM-insert-rt-block-3.html
               fast/ruby/rubyDOM-remove-rt-block-1.html
               fast/ruby/rubyDOM-remove-rt-block-2.html
               fast/ruby/rubyDOM-remove-rt-block-3.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::moveAllChildrenTo): useful for anonymous block manipulation
        (WebCore::RenderBlock::removeChild): making use of moveAllChildrenTo
        * rendering/RenderBlock.h:
        * rendering/RenderRubyBase.cpp:
        (WebCore::RenderRubyBase::hasOnlyWrappedInlineChildren):
        (WebCore::RenderRubyBase::moveChildren):
        (WebCore::RenderRubyBase::moveInlineChildren):
        (WebCore::RenderRubyBase::moveBlockChildren):
        (WebCore::RenderRubyBase::mergeBlockChildren):
        * rendering/RenderRubyBase.h:
        * rendering/RenderRubyRun.cpp:
        (WebCore::RenderRubyRun::addChild):
        (WebCore::RenderRubyRun::removeChild):

2010-01-19  Dan Bernstein  <mitz@apple.com>

        Build fix after r53514

        * WebCore.base.exp: Removed threadGlobalData(), which was inlined in r53514.

2010-01-19  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein.

        Avoid calling NSEqualRects() on the garbage rect obtained
        by calling -frame on a null view.

        * platform/mac/WidgetMac.mm:
        (WebCore::Widget::setFrameRect):

2010-01-19  Maciej Stachowiak  <mjs@apple.com>

        Unreviewed build fix.

        Remove currentWorld from the exports file again, since it is now inline.

        * WebCore.base.exp:

2010-01-19  Brian Weinstein  <bweinstein@apple.com>

        Reviewed by Tim Hatcher.

        Part of <http://webkit.org/b/28622>.
        Caught exceptions still pause the debugger.
        
        Update JavaScriptDebugServer::exception to take a hasHandler parameter,
        so later we can differentiate between a caught and an uncaught exception.
        
        This just adds a new parameter, no behavior is changed.

        No change in functionality, so no tests.

        * inspector/JavaScriptDebugServer.cpp:
        (WebCore::JavaScriptDebugServer::exception):
        * inspector/JavaScriptDebugServer.h:

2010-01-18  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Adam Barth.

        Inline functions that are hot in DOM manipulation
        https://bugs.webkit.org/show_bug.cgi?id=33820

        (3% speedup on Dromaeo DOM Core tests)

        * bindings/js/JSDOMBinding.h:
        (WebCore::currentWorld): Inlined.
        (WebCore::jsString): Inlined String& overload and split off slow case.
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::jsStringSlowCase): Slow case for the above.
        * dom/Document.h:
        (WebCore::Document::isHTMLDocument): Use a bit and an inline method
        instead of a virtual method, since this is so hot and size of Document
        is not a prime concern.
        (WebCore::Document::create): Adapt for above.
        (WebCore::Document::createXHTML): ditto
        * dom/Document.cpp:
        (WebCore::Document::Document): ditto
        * html/HTMLDocument.cpp:
        (WebCore::HTMLDocument::HTMLDocument): ditto
        * html/HTMLDocument.h: ditto
        * loader/PlaceholderDocument.h:
        (WebCore::PlaceholderDocument::PlaceholderDocument): ditto
        * svg/SVGDocument.cpp:
        (WebCore::SVGDocument::SVGDocument): ditto
        * dom/Element.h:
        (WebCore::Element::attributes): Inlined.
        (WebCore::Element::updateId): Inlined.
        * dom/Element.cpp: (Remove inlined methods.)
        * dom/NamedAttrMap.h:
        (WebCore::NamedNodeMap::getAttributeItem): Inlined and split off slow case.
        * dom/NamedAttrMap.cpp:
        (WebCore::NamedNodeMap::getAttributeItemSlowCase): Slow case for the above.
        * inspector/InspectorController.cpp:
        * inspector/InspectorController.h:
        (WebCore::InspectorController::didInsertDOMNode): Inlined so the fast case
        early exit doesn't incur a function call.
        (WebCore::InspectorController::didRemoveDOMNode): ditto
        (WebCore::InspectorController::didModifyDOMAttr): ditto
        * platform/ThreadGlobalData.h:
        (WebCore::threadGlobalData): Inlined.
        * platform/ThreadGlobalData.cpp: (Removed inline methods).
        * platform/Timer.h:
        (WebCore::TimerBase::isActive): Inlined.
        * platform/Timer.cpp: (Removed inline methods).
        * WebCore.xcodeproj/project.pbxproj: Install new heares.
        * WebCore.base.exp: Add appropriate exports.

2010-01-19  Jon Honeycutt  <jhoneycutt@apple.com>

        Chromium build fix.

        * accessibility/chromium/AccessibilityObjectChromium.cpp:
        (WebCore::AccessibilityObject::accessibilityPlatformIncludesObject):
        Call correct function.

2010-01-17  Jon Honeycutt  <jhoneycutt@apple.com>

        MSAA: The child <option> elements of a non-multiple <select> are not
        exposed

        https://bugs.webkit.org/show_bug.cgi?id=33773
        <rdar://problem/7550556>

        Reviewed by Alice Liu.

        This exposes the child <option> elements in a format similar to
        Firefox's: the <select> element has one child, a hidden list object,
